// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include <wx/aui/aui.h>
#include <wx/aui/auibook.h>
#include <wx/aui/dockart.h>
extern "C"{

object WXEUAPI new_wxAuiManager( object params ){
        wxWindow * managed = NULL;
        int flags = wxAUI_MGR_DEFAULT;
        switch( LENGTH(params) ){
                case 2:
                        flags = get_int( params, 2 );
                
                case 1:
                        managed = (wxWindow*) get_int( params, 1 );
                
                default:
                        break;
        }
        
        return BOX_INT( new wxAuiManager( managed, flags ) );
}

void WXEUAPI add_pane_with_info( long manager, long win, long pane_info ){
        ((wxAuiManager*)manager)->AddPane( (wxWindow*)win, *(wxAuiPaneInfo*)pane_info);
}

void WXEUAPI add_pane_simple( long manager, long win, int direction, object caption ){
        ((wxAuiManager*)manager)->AddPane( (wxWindow*) win, direction, get_string( caption ) );
        wxDeRefDS( caption );
}

void WXEUAPI add_pane_with_pos( long manager, long win, long pane_info, int x, int y ){
        ((wxAuiManager*)manager)->AddPane( (wxWindow*)win, *(wxAuiPaneInfo*)pane_info, wxPoint(x, y) );
}

object WXEUAPI detach_pane( long manager, long window ){
        return ((wxAuiManager*)manager)->DetachPane( (wxWindow*) window );
}

object WXEUAPI get_managed_window( long manager ){
        return BOX_INT( ((wxAuiManager*)manager)->GetManagedWindow());
}

object WXEUAPI get_manager( long window ){
        return BOX_INT( wxAuiManager::GetManager( (wxWindow*) window ));
}

object WXEUAPI get_pane( long manager, long window ){
        wxAuiPaneInfo * info = & ((wxAuiManager*)manager)->GetPane( (wxWindow*)window );
        return BOX_INT( info );
}

void WXEUAPI hide_hint( long manager ){
        ((wxAuiManager*)manager)->HideHint();
}

object WXEUAPI insert_pane( long manager, long window, long insert_location, int insert_level ){
        return ((wxAuiManager*)manager)->InsertPane( (wxWindow*) window, *(wxAuiPaneInfo*)insert_location, insert_level );
}

void WXEUAPI load_pane_info( long manager, object pane_part, long pane ){
        ((wxAuiManager*)manager)->LoadPaneInfo( get_string( pane_part ), *(wxAuiPaneInfo*)pane );
        wxDeRefDS( pane_part );
}

object WXEUAPI load_perspective( long manager, object perspective, int update ){
        wxDeRefDS( perspective );
        return ((wxAuiManager*)manager)->LoadPerspective( get_string( perspective ), update );
}

object WXEUAPI save_pane_info( long manager, long pane ){
        return get_sequence( ((wxAuiManager*)manager)->SavePaneInfo( *(wxAuiPaneInfo*)pane) );
}

object WXEUAPI save_perspective( long manager ){
        return get_sequence( ((wxAuiManager*)manager)->SavePerspective() );
}

void WXEUAPI set_art_provider( long manager, long art_provider ){
        ((wxAuiManager*)manager)->SetArtProvider( (wxAuiDockArt*) art_provider );
}

void WXEUAPI set_dock_size_constraint( long manager, double widthpct, double heightpct ){
        ((wxAuiManager*)manager)->SetDockSizeConstraint( widthpct, heightpct );
}

void WXEUAPI set_aui_flags( long manager, int flags ){
        ((wxAuiManager*)manager)->SetFlags( flags );
}

void WXEUAPI set_managed_window( long manager, long managed_wnd ){
        ((wxAuiManager*)manager)->SetManagedWindow( (wxWindow*) managed_wnd );
}

void WXEUAPI uninit_aui( long manager ){
        ((wxAuiManager*)manager)->UnInit();
}

void WXEUAPI update_aui( long manager ){
        ((wxAuiManager*)manager)->Update();
}

object WXEUAPI new_wxAuiPaneInfo( object params ){
        wxDeRefDS( params );
        return BOX_INT( new wxAuiPaneInfo() );
}

void WXEUAPI delete_wxAuiPaneInfo( object obj ){
        DELETE_INSTANCE( wxAuiPaneInfo, obj )
}

void WXEUAPI best_size_pane( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->BestSize( x, y );
}

void WXEUAPI aui_best_size( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->BestSize( x, y );
}

void WXEUAPI aui_bottom( long info ){
        ((wxAuiPaneInfo*)info)->Bottom();
}

void WXEUAPI aui_bottom_dockable( long info, int b ){
        ((wxAuiPaneInfo*)info)->BottomDockable( b );
}

void WXEUAPI aui_caption( long info, object c ){
        ((wxAuiPaneInfo*)info)->Caption( get_string( c ) );
        wxDeRefDS( c );
}

void WXEUAPI aui_caption_visible( long info, int visible ){
        ((wxAuiPaneInfo*)info)->CaptionVisible( visible );
}


void WXEUAPI aui_center( long info ){
        ((wxAuiPaneInfo*)info)->Center();
}

void WXEUAPI aui_center_pane( long info ){
        ((wxAuiPaneInfo*)info)->CenterPane();
}

void WXEUAPI aui_close_button( long info, int visible ){
        ((wxAuiPaneInfo*)info)->CloseButton( visible );
}

void WXEUAPI aui_default_pane( long info ){
        ((wxAuiPaneInfo*)info)->DefaultPane();
}

void WXEUAPI aui_destroy_on_close( long info, int b ){
        ((wxAuiPaneInfo*)info)->DestroyOnClose( b );
}

void WXEUAPI aui_direction( long info, int direction ){
        ((wxAuiPaneInfo*)info)->Direction( direction );
}

void WXEUAPI aui_dock( long info ){
        ((wxAuiPaneInfo*)info)->Dock();
}

void WXEUAPI aui_dockable( long info, int b ){
        ((wxAuiPaneInfo*)info)->Dockable( b );
}

void WXEUAPI aui_fixed( long info ){
        ((wxAuiPaneInfo*)info)->Fixed();
}

void WXEUAPI aui_float( long info ){
        ((wxAuiPaneInfo*)info)->Float();
}

void WXEUAPI aui_floatable( long info, int b ){
        ((wxAuiPaneInfo*)info)->Floatable( b );
}

void WXEUAPI aui_floating_position( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->FloatingPosition( x, y );
}

void WXEUAPI aui_floating_size( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->FloatingSize( x, y );
}

void WXEUAPI aui_gripper( long info, int visible ){
        ((wxAuiPaneInfo*)info)->Gripper( visible );
}

void WXEUAPI aui_gripper_top( long info, int attop ){
        ((wxAuiPaneInfo*)info)->Gripper( attop );
}

object WXEUAPI aui_has_border( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasBorder();
}

object WXEUAPI aui_has_caption( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasCaption();
}

object WXEUAPI aui_has_close_button( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasCloseButton();
}

object WXEUAPI aui_has_flag( long info, int flag ){
        return 1 & ((wxAuiPaneInfo*)info)->HasFlag( flag );
}

object WXEUAPI aui_has_gripper( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasGripper();
}

object WXEUAPI aui_has_gripper_top( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasGripperTop();
}

object WXEUAPI aui_has_maximize_button( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasMaximizeButton();
}

object WXEUAPI aui_has_minimize_button( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasMinimizeButton();
}

object WXEUAPI aui_has_pin_button( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->HasPinButton();
}

void WXEUAPI aui_hide( long info ){
        ((wxAuiPaneInfo*)info)->Hide();
}

object WXEUAPI aui_is_bottom_dockable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsBottomDockable();
}

object WXEUAPI aui_is_docked( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsDocked();
}

object WXEUAPI aui_is_fixed( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsFixed();
}

object WXEUAPI aui_is_floatable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsFloatable();
}

object WXEUAPI aui_is_floating( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsFloating();
}

object WXEUAPI aui_is_left_dockable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsLeftDockable();
}

object WXEUAPI aui_is_movable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsMovable();
}

object WXEUAPI aui_is_ok( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsOk();
}

object WXEUAPI aui_is_resizable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsResizable();
}

object WXEUAPI aui_is_right_dockable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsRightDockable();
}

object WXEUAPI aui_is_shown( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsShown();
}

object WXEUAPI aui_is_toolbar( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsToolbar();
}

object WXEUAPI aui_is_top_dockable( long info ){
        return 1 & ((wxAuiPaneInfo*)info)->IsTopDockable();
}

void WXEUAPI aui_layer( long info, int layer ){
        ((wxAuiPaneInfo*)info)->Layer( layer );
}

void WXEUAPI aui_left( long info ){
        ((wxAuiPaneInfo*)info)->Left();
}

void WXEUAPI aui_left_dockable( long info, int b ){
        ((wxAuiPaneInfo*)info)->LeftDockable(b);
}

void WXEUAPI aui_max_size( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->MaxSize( x, y );
}

void WXEUAPI aui_maximize_button( long info, int visible ){
        ((wxAuiPaneInfo*)info)->MaximizeButton( visible );
}

void WXEUAPI aui_min_size( long info, int x, int y ){
        ((wxAuiPaneInfo*)info)->MinSize( x, y );
}

void WXEUAPI aui_minimize_button( long info, int visible ){
        ((wxAuiPaneInfo*)info)->MinimizeButton( visible );
}

void WXEUAPI aui_movable( long info, int b ){
        ((wxAuiPaneInfo*)info)->Movable( b );
}

void WXEUAPI aui_name( long info, object n ){
        ((wxAuiPaneInfo*)info)->Name( get_string( n ) );
        wxDeRefDS( n );
}

void WXEUAPI aui_pane_border( long info, int visible ){
        ((wxAuiPaneInfo*)info)->PaneBorder( visible );
}

void WXEUAPI aui_pin_button( long info, int visible ){
        ((wxAuiPaneInfo*)info)->PinButton( visible );
}

void WXEUAPI aui_position( long info, int pos ){
        ((wxAuiPaneInfo*)info)->Position( pos );
}

void WXEUAPI aui_resizable( long info, int resizable ){
        ((wxAuiPaneInfo*)info)->Resizable( resizable );
}

void WXEUAPI aui_right( long info ){
        ((wxAuiPaneInfo*)info)->Right();
}

void WXEUAPI aui_right_dockable( long info, int b ){
        ((wxAuiPaneInfo*)info)->RightDockable( b );
}

void WXEUAPI aui_row( long info, int row ){
        ((wxAuiPaneInfo*)info)->Row( row );
}

void WXEUAPI aui_safe_set( long info, long source ){
        ((wxAuiPaneInfo*)info)->SafeSet( *(wxAuiPaneInfo*)source );
}

void WXEUAPI aui_set_flag( long info, int flag, int option_state ){
        ((wxAuiPaneInfo*)info)->SetFlag( flag, option_state );
}

void WXEUAPI aui_show( long info, int show ){
        ((wxAuiPaneInfo*)info)->Show( show );
}

void WXEUAPI aui_toolbar_pane( long info ){
        ((wxAuiPaneInfo*)info)->ToolbarPane();
}

void WXEUAPI aui_top( long info ){
        ((wxAuiPaneInfo*)info)->Top();
}

void WXEUAPI aui_top_dockable( long info, int b ){
        ((wxAuiPaneInfo*)info)->TopDockable( b );
}

void WXEUAPI aui_window( long info, int w ){
        ((wxAuiPaneInfo*)info)->Window( (wxWindow*)w );
}

object WXEUAPI new_wxAuiNotebook( object params ){
        NEW_SIMPLE_CONTROL_STYLE( wxAuiNotebook, wxAUI_NB_DEFAULT_STYLE )
}

object WXEUAPI aui_notebook_add_page( long nb, long page, object caption, int select, long bitmap ){
        wxBitmap bmp = (bitmap == 0) ? NULL : *(wxBitmap*) bitmap;
        wxDeRefDS( caption );
        return ((wxAuiNotebook*)nb)->AddPage( (wxWindow*) page, get_string( caption ), select, bmp );
}

object WXEUAPI aui_notebook_delete_page( long nb, long page ){
        return ((wxAuiNotebook*)nb)->DeletePage( page );
}

object WXEUAPI aui_notebook_get_art_provider( long nb ){
        return BOX_INT( ((wxAuiNotebook*)nb)->GetArtProvider() );
}

object WXEUAPI aui_notebook_get_page( long nb, int page_idx ){
        return BOX_INT( ((wxAuiNotebook*)nb)->GetPage( page_idx ) );
}

object WXEUAPI aui_notebook_get_page_bitmap( long nb, long page ){
        return BOX_INT( new wxBitmap( ((wxAuiNotebook*)nb)->GetPageBitmap( page ) ) );
}

object WXEUAPI aui_notebook_get_page_count( long nb ){
        return ((wxAuiNotebook*)nb)->GetPageCount();
}

object WXEUAPI aui_notebook_get_page_index( long nb, long page_wnd ){
        return BOX_INT( ((wxAuiNotebook*)nb)->GetPageIndex( (wxWindow*)page_wnd ) );
}

object WXEUAPI aui_get_selection( long nb ){
        return BOX_INT( ((wxAuiNotebook*)nb)->GetSelection() );
}

object WXEUAPI aui_notebook_insert_page( long nb, long page_idx, long page, object caption, int select, long bitmap ){
        wxDeRefDS( caption );
        return 1 & ((wxAuiNotebook*)nb)->InsertPage( page_idx, (wxWindow*)page, get_string( caption ),
                select, *(wxBitmap*) bitmap );
}

object WXEUAPI aui_notebook_remove_page( long nb, long page ){
        return 1 & ((wxAuiNotebook*)nb)->RemovePage( page );
}

void WXEUAPI aui_notebook_set_art_provider( long nb, int art ){
        ((wxAuiNotebook*)nb)->SetArtProvider( (wxAuiTabArt*) art );
}

object WXEUAPI aui_notebook_set_page_bitmap( long nb, long page, long bitmap ){
        return 1 & ((wxAuiNotebook*)nb)->SetPageBitmap( page, *(wxBitmap*)bitmap );
}

object WXEUAPI aui_notebook_set_page_text( long nb, long page, object text ){
        wxDeRefDS( text );
        return 1 & ((wxAuiNotebook*)nb)->SetPageText( page, get_string( text ) );
}

object WXEUAPI aui_notebook_set_selection( long nb, int new_page ){
        return ((wxAuiNotebook*)nb)->SetSelection( new_page );
}

void WXEUAPI aui_notebook_set_tab_ctrl_height( long nb, int height ){
        ((wxAuiNotebook*)nb)->SetTabCtrlHeight( height );
}

void WXEUAPI aui_notebook_set_uniform_bitmap_size( long nb, int x, int y ){
        ((wxAuiNotebook*)nb)->SetUniformBitmapSize( wxSize( x, y ) );
}

void WXEUAPI aui_notebook_split( long nb, long page, int direction ){
        ((wxAuiNotebook*)nb)->Split( page, direction );
}

class EuAuiDockArt : public wxAuiDefaultDockArt {
    
    public:
        
        intptr_t rid_DrawBackground,
            rid_DrawBorder,
            rid_DrawCaption,
            rid_DrawGripper,
            rid_DrawPaneButton,
            rid_DrawSash;
        
        EuAuiDockArt() {
            
            rid_DrawBackground = -1;
            rid_DrawBorder = -1;
            rid_DrawCaption = -1;
            rid_DrawGripper = -1;
            rid_DrawPaneButton = -1;
            rid_DrawSash = -1;
            
        }
        
        void DrawBackground(wxDC& dc, wxWindow* window, int orientation, const wxRect& rect) {
            
            if ( rid_DrawBackground != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 4 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = orientation;
                s->base[4] = MAKE_SEQ( r );
                
                EuApp::wxEuApp->proc( rid_DrawBackground, MAKE_SEQ(s) );
                
            }
            else {
                
                wxAuiDefaultDockArt::DrawBackground( dc, window, orientation, rect );
                
            }
                        
        }
        
        void DrawBorder(wxDC& dc, wxWindow* window, const wxRect& rect, wxAuiPaneInfo& pane) {
            
            if ( rid_DrawBorder != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 4 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = MAKE_SEQ( r );
                s->base[4] = BOX_INT( &pane );
                
                EuApp::wxEuApp->proc( rid_DrawBorder, MAKE_SEQ(s) );
            }
            else {
                
                wxAuiDefaultDockArt::DrawBorder( dc, window, rect, pane );
                
            }
            
        }
        
        void DrawCaption(wxDC& dc, wxWindow* window, const wxString& text, const wxRect& rect, wxAuiPaneInfo& pane) {
            
            if ( rid_DrawCaption != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 5 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = get_sequence( text );
                s->base[4] = MAKE_SEQ( r );
                s->base[5] = BOX_INT( &pane );
                
                EuApp::wxEuApp->proc( rid_DrawCaption, MAKE_SEQ(s) );
            }
            else {
                
                wxAuiDefaultDockArt::DrawCaption( dc, window, text, rect, pane );
                
            }
            
        }
        
        void DrawGripper(wxDC& dc, wxWindow* window, const wxRect& rect, wxAuiPaneInfo& pane) {
            
            if ( rid_DrawGripper != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 4 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = MAKE_SEQ( r );
                s->base[4] = BOX_INT( &pane );
                
                EuApp::wxEuApp->proc( rid_DrawGripper, MAKE_SEQ(s) );
            }
            else {
                
                wxAuiDefaultDockArt::DrawGripper( dc, window, rect, pane );
                
            }
            
        }
        
        void DrawPaneButton(wxDC& dc, wxWindow* window, int button, int button_state, const wxRect& rect, wxAuiPaneInfo& pane) {
            
            if ( rid_DrawPaneButton != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 6 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = button;
                s->base[4] = button_state;
                s->base[5] = MAKE_SEQ( r );
                s->base[6] = BOX_INT( &pane );
                
                EuApp::wxEuApp->proc( rid_DrawPaneButton, MAKE_SEQ(s) );
            }
            else {
                
                wxAuiDefaultDockArt::DrawPaneButton( dc, window, button, button_state, rect, pane );
                
            }
            
        }
        
        void DrawSash(wxDC& dc, wxWindow* window, int orientation, const wxRect& rect) {
            
            if ( rid_DrawSash != -1 ) {
                
                s1_ptr r = NewS1( 4 );
                r->base[1] = rect.x;
                r->base[2] = rect.y;
                r->base[3] = rect.width;
                r->base[4] = rect.height;
                
                s1_ptr s = NewS1( 4 );
                s->base[1] = BOX_INT( &dc );
                s->base[2] = BOX_INT( window );
                s->base[3] = orientation;
                s->base[4] = MAKE_SEQ( r );
                
                EuApp::wxEuApp->proc( rid_DrawSash, MAKE_SEQ(s) );
            }
            else {
                
                wxAuiDefaultDockArt::DrawSash( dc, window, orientation, rect );
                
            }
            
        }

};

object WXEUAPI new_wxAuiDockArt( object params ) {
        
        EuAuiDockArt * dockArt = new EuAuiDockArt();
        
        wxDeRefDS( params );
        return BOX_INT( dockArt );
}

void WXEUAPI dockart_drawbackground_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawBackground = rid;
}

void WXEUAPI dockart_drawborder_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawBorder = rid;
}

void WXEUAPI dockart_drawcaption_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawCaption = rid;
}

void WXEUAPI dockart_drawgripper_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawGripper = rid;
}

void WXEUAPI dockart_drawpanebutton_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawPaneButton = rid;
}

void WXEUAPI dockart_drawsash_id( long dockArt, int rid ) {
        ((EuAuiDockArt*)dockArt)->rid_DrawSash = rid;
}

object WXEUAPI get_dockart_colour( long dockArt, int id ) {
        wxColour colour = ((EuAuiDockArt*)dockArt)->GetColour( id );
        return BOX_INT( new wxColour( colour ) );
}

object WXEUAPI get_dockart_font( long dockArt, int id ) {
        wxFont font = ((EuAuiDockArt*)dockArt)->GetFont( id );
        return BOX_INT( new wxFont( font ) );
}

object WXEUAPI get_dockart_metric( long dockArt, int id ) {
        return BOX_INT( ((EuAuiDockArt*)dockArt)->GetMetric( id ) );
}

void WXEUAPI set_dockart_colour( long dockArt, int id, long colour ) {
        ((EuAuiDockArt*)dockArt)->SetColour( id, *(wxColour*)colour );
}

void WXEUAPI set_dockart_font( long dockArt, int id, long font ) {
        ((EuAuiDockArt*)dockArt)->SetFont( id, *(wxFont*)font );
}

void WXEUAPI set_dockart_metric( long dockArt, int id, int new_val ) {
        ((EuAuiDockArt*)dockArt)->SetMetric( id, new_val );
}

}
