// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/bmpbuttn.h"


extern "C"{
object WXEUAPI  new_wxButton(object params)
{
	NEW_CONTROL( wxButton );
}

object WXEUAPI  new_wxDefButton(object params)
{
	NEW_CONTROL_NO_RETURN( wxButton, button );
	((wxTopLevelWindow *)get_int(params, 1))->SetDefaultItem( button );
	wxDeRefDS( params );
	return BOX_INT( button );
}

object WXEUAPI  new_wxBitmapButton(object params)
{
/*
--/li atom parent
--/li integer id
--/li atom /wxBitmap
--/li integer x [=-1]
--/li integer y [=-1]
--/li integer cx [=-1]
--/li integer cy [=-1]
--/li atom style [=-1]
*/
	int len = LENGTH( params );
	long style = wxBU_AUTODRAW;
	wxSize size = wxDefaultSize;
	wxPoint pos = wxDefaultPosition;
	wxBitmap * bitmap = &wxNullBitmap;
	wxWindowID id = -1;
	wxDeRefDS( params );
	
	switch( len ){
		case 8:
			style = get_int( params, 8 );
		case 7:
			size = wxSize( get_int(params, 6), get_int(params, 7) );
		case 6:
		case 5:
			pos = wxPoint( get_int(params, 4), get_int(params, 5) );
			
		case 4:
		case 3:
			bitmap = (wxBitmap*)get_int( params, 3 );
			
		case 2:
			id = (wxWindowID)get_int( params, 2 );
		
		default:
			wxBitmapButton * button = new wxBitmapButton( (wxWindow*)get_int(params, 1),
//				(wxWindowID)get_int(params, 2), *((wxBitmap*)get_int(params,3)),
//				pos, size, style );
				id, *bitmap, pos, size, style );

			return BOX_INT( button );
	}
	return 0;
}

void WXEUAPI  set_button_label(long button, object text )
{
	((wxButton*)button)->SetLabel( get_string( text ) );
	wxDeRefDS( text );
}

void WXEUAPI  set_bmpbutton(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapLabel( *((wxBitmap*)bitmap) );
}

void WXEUAPI  set_bitmap_disabled(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapDisabled( *((wxBitmap*)bitmap) );
}

void WXEUAPI  set_bitmap_focus(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapFocus( *((wxBitmap*)bitmap) );
}

void WXEUAPI  set_bitmap_hover(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapHover( *((wxBitmap*)bitmap) );
}
void WXEUAPI  set_bitmap_label(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapLabel( *((wxBitmap*)bitmap) );
}

void WXEUAPI  set_bitmap_selected(long button, long bitmap)
{
	((wxBitmapButton*)button)->SetBitmapSelected( *((wxBitmap*)bitmap) );
}

}
