// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/datetime.h"
#include "wx/calctrl.h"

extern "C"{
object WXEUAPI  new_wxCalendarCtrl(object params)
{

/*
wxCalendarCtrl(wxWindow* parent, 
wxWindowID id, 
const wxDateTime& date = wxDefaultDateTime, 
const wxPoint& pos = wxDefaultPosition, 
const wxSize& size = wxDefaultSize, 
intptr_t style = wxCAL_SHOW_HOLIDAYS, 
const wxString& name = wxCalendarNameStr)
*/
        int len = ((s1_ptr)SEQ_PTR(params))->length;
        wxDateTime date = wxDefaultDateTime;
        wxPoint pos = wxDefaultPosition;
        wxSize size = wxDefaultSize;
        intptr_t style = wxCAL_SHOW_HOLIDAYS;
        wxWindowID id = -1;

        wxDeRefDS( params );
        switch( len ){
                case 8:
                        style = get_int( params, 8 );
                
                case 7:
                        size = wxSize( get_int( params, 6 ), get_int( params, 7 ));
                
                case 6:
                case 5:
                        pos = wxPoint( get_int( params, 4 ), get_int( params, 5 ));
                
                case 3:
                        date = get_int( params, 3 );
                
                case 2:
                        id = get_int( params, 2 );
                default:
                        wxCalendarCtrl * cal = new wxCalendarCtrl( (wxWindow *)get_int( params, 1 ),
                        //      (wxWindowID) get_int( params, 2 ), date, pos, size, style );
                                id, date, pos, size, style );

                        return BOX_INT( cal );
        }
        return 0;
}


object WXEUAPI  get_date(intptr_t cal)
{
        wxDateTime date = ((wxCalendarCtrl *)cal)->GetDate();
        return get_datetime( date );
}

object WXEUAPI  get_date_time(intptr_t cal)
{
        return BOX_INT( new wxDateTime( ((wxCalendarCtrl*)cal)->GetDate() ) );
}

object WXEUAPI  get_days_in_month(int month, int year)
{
        return wxDateTime::GetNumberOfDays( ::month(month), year );
}

object WXEUAPI  get_cal_days_in_month(intptr_t cal)
{
        wxDateTime d = ((wxCalendarCtrl*)cal)->GetDate();
        return wxDateTime::GetNumberOfDays( d.GetMonth(), 
                d.GetYear() );
}



void WXEUAPI  set_date(intptr_t cal, object Date)
{

        wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        calendar->SetDate( get_datetime( Date ) );
        wxDeRefDS( Date );
}

wxCalendarDateAttr * get_attr( intptr_t cal, int day ){
        wxCalendarDateAttr * attr = ((wxCalendarCtrl *)cal)->GetAttr(day);
        if ( attr == NULL ){
                attr = new wxCalendarDateAttr();
                ((wxCalendarCtrl *)cal)->SetAttr( day, attr );
        }
        return attr;
}
void WXEUAPI  set_date_text_color(intptr_t cal, object day, intptr_t color)
{

        wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;
        wxColour c = *((wxColour *)color);
        
        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetTextColour( c );
                        
                }
        }
        else{
                attr = get_attr( cal, day );
                attr->SetTextColour( c );
                
        }
        wxDeRef( day );
}

void WXEUAPI  set_date_border(intptr_t cal, object day, int border)
{
wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;

        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetBorder( (wxCalendarDateBorder)border );
                        
                }
        }
        else{
                attr = get_attr( cal,  day );
                attr->SetBorder( (wxCalendarDateBorder) border );
                
        }
        wxDeRef( day );
}

void WXEUAPI  set_date_back_color(intptr_t cal, object day, intptr_t color)
{
        wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;
        wxColour c = *((wxColour *)color);

        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetBackgroundColour( c );
                        
                }
        }
        else{
                attr = get_attr( cal,  day );
                attr->SetBackgroundColour( c );
                
        }
        wxDeRef( day );
}

void WXEUAPI  set_date_border_color(intptr_t cal, object day, intptr_t color)
{
wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;
        wxColour c = *((wxColour *)color);

        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetBorderColour( c );
                        
                }
        }
        else{
                attr = get_attr( cal,  day );
                attr->SetBorderColour( c );
                
        }
        wxDeRef( day );
}

void WXEUAPI  set_date_font(intptr_t cal, object day, intptr_t font)
{
wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;
        wxFont f = *((wxFont *)font);

        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetFont( f );
                        
                }
        }
        else{
                attr = get_attr( cal,  day );
                attr->SetFont( f );
        }
        wxDeRef( day );
}

void WXEUAPI  set_date_holiday(intptr_t cal, object day, int holiday)
{
wxCalendarCtrl * calendar = (wxCalendarCtrl *)cal;
        wxCalendarDateAttr * attr;
        bool h = (bool)holiday;

        if( IS_SEQUENCE( day ) ){
                s1_ptr d = SEQ_PTR( day );
                for( int i = 1; i <= d->length; i++ ){
                        attr = get_attr( cal,  d->base[i] );
                        attr->SetHoliday( h );
                        
                }
        }
        else{
                attr = get_attr( cal,  day );
                attr->SetHoliday( h );
                
        }
        wxDeRef( day );
}

}
