// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/caret.h"


extern "C"{
object WXEUAPI  new_wxCaret( object params )
{
	int parent = get_int( params, 1 );
	int x = get_int( params, 2 );
	int y = get_int( params, 3 );
	wxDeRefDS( params );
	
	wxCaret * caret = new wxCaret( ((wxWindow*) parent), x, y );
	
	return BOX_INT( caret );
}

object WXEUAPI get_caret_blink_time( intptr_t caret )
{
	return ((wxCaret*) caret)->GetBlinkTime();
}

object WXEUAPI get_caret_position( intptr_t caret )
{
	wxPoint pos = ((wxCaret*) caret)->GetPosition();

	s1_ptr ret = NewS1(2);
	ret->base[1] = pos.x;
	ret->base[2] = pos.y;
	
	return MAKE_SEQ(ret);
}

object WXEUAPI get_caret_size( intptr_t caret )
{
	wxSize size = ((wxCaret*) caret)->GetSize();

	s1_ptr ret = NewS1(2);
	ret->base[1] = size.GetWidth();
	ret->base[2] = size.GetHeight();
	
	return MAKE_SEQ(ret);
}

object WXEUAPI get_caret_window( intptr_t caret )
{
	return BOX_INT( ((wxCaret*) caret)->GetWindow() );
}

void WXEUAPI hide_caret( intptr_t caret )
{
	((wxCaret*) caret)->Hide();
}

object WXEUAPI caret_isok( intptr_t caret )
{
	return ((wxCaret*) caret)->IsOk();
}

object WXEUAPI caret_isvisible( intptr_t caret )
{
	return ((wxCaret*) caret)->IsVisible();
}

void WXEUAPI caret_kill_focus( intptr_t caret )
{
	((wxCaret*) caret)->OnKillFocus();
}

void WXEUAPI caret_set_focus( intptr_t caret )
{
	((wxCaret*) caret)->OnSetFocus();
}

void WXEUAPI move_caret( intptr_t caret, int x, int y )
{
	((wxCaret*) caret)->Move( x, y );
}

void WXEUAPI set_caret_blink_time( intptr_t caret, int milliseconds )
{
	((wxCaret*) caret)->SetBlinkTime( milliseconds );
}

void WXEUAPI set_caret_size( intptr_t caret, int width, int height )
{
	((wxCaret*) caret)->SetSize( width, height );
}

void WXEUAPI show_caret( intptr_t caret )
{
	((wxCaret*) caret)->Show( true );
}

}
