// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "wx/tglbtn.h"
#include "alldefs.h"
#include "wxeu.h"


extern "C"{
object WXEUAPI  new_wxCheckBox(object params)
{
	NEW_CONTROL(wxCheckBox)
}

object WXEUAPI  get_checked(intptr_t box)
{
	
	return (int) ((wxCheckBox*)box)->IsChecked();
}

void WXEUAPI  set_checked(intptr_t box, int check)
{
	if( ((wxObject*)box)->IsKindOf(CLASSINFO(wxCheckBox)) ){
		((wxCheckBox*)box)->SetValue((bool)check);
	}
	else{
		((wxToggleButton*)box)->SetValue((bool)check);
	}
}

object WXEUAPI  get_radio_selection(intptr_t box)
{
	return ((wxRadioBox*)box)->GetSelection();
}

object WXEUAPI  new_wxRadioButton(object params)
{
	NEW_CONTROL(wxRadioButton)
}

object WXEUAPI  new_wxRadioBox(object params)
{
/*
--wxRadioBox(
--1  1  wxWindow* parent, 
--2  2  wxWindowID id,
--3  3  const wxString& label, 
--45 4  const wxPoint& point = wxDefaultPosition, 
--67 5  const wxSize& size = wxDefaultSize, 
--   6  int n = 0, 
--8  7  const wxString choices[] = NULL, 
--9  8  int majorDimension = 0, 
--10 9  intptr_t style = wxRA_SPECIFY_COLS, 
--  10  const wxValidator& validator = wxDefaultValidator, 
--  11  const wxString& name = "radioBox")
*/

	s1_ptr p = SEQ_PTR( params );
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	int n = 0;
	wxString * choices = NULL;
	int majorDimension = 0;
	wxRadioBox * radio = NULL;
	intptr_t style = wxRA_SPECIFY_COLS;
	object c;	

	switch( p->length ){
		case 10:
			style = get_int( params, 10 );
		
		case 9:
			majorDimension = get_int( params, 9 );
			
		case 8: 
			c = p->base[8];
			n = ((s1_ptr)SEQ_PTR(c))->length;

			choices = new wxString[n];
			for( int i = 0; i < n; i++ ){
				wxString choice( get_string( c, i+1));
				choices[i] = choice;//get_string( c, i + 1 );
			}
		case 7:
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );
		
		case 6:
		case 5:
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5 ) );
		
		default:
			radio = new wxRadioBox( (wxWindow *) get_int( params, 1 ),
				(wxWindowID) get_int(params, 2), get_string( params, 3 ),
				pos, size, n, choices, majorDimension, style );
			break;
	}

	wxDeRefDS( params );
	if( choices != NULL ) delete[] choices;
	return BOX_INT(radio);
}

void WXEUAPI  set_radiobox_selection(intptr_t box, int selection)
{
	((wxRadioBox*)box)->SetSelection( selection );
}

object WXEUAPI  new_wxToggleButton(object params)
{
	NEW_CONTROL(wxToggleButton)
}

}
