// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/clipbrd.h"
#include "wx/dnd.h"

extern "C"{


object WXEUAPI  get_clip_text()
{
	if( wxTheClipboard->Open() ){
		wxTextDataObject data;
		wxTheClipboard->GetData( data );
		object text = get_sequence( data.GetText() );
		wxTheClipboard->Close();
		return text;
	}

	return MAKE_SEQ(NewS1(0));
}

void WXEUAPI  set_clip_text(object text)
{

	if( wxTheClipboard->Open() ){
		wxTheClipboard->SetData( new wxTextDataObject( get_string( text ) ) );
		wxTheClipboard->Close();
	}
	wxDeRefDS( text );
}

typedef int WXEUAPI (*EuDnDFunction)(int,int);
class euFileDropTarget : public wxFileDropTarget{
	public:
		euFileDropTarget( EuDnDFunction cb, int r ): wxFileDropTarget(){
			call_back = cb;
			rid = r;
		}
		virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);

		EuDnDFunction call_back;
		int rid;
		object Files;
};

bool euFileDropTarget::OnDropFiles( wxCoord x, wxCoord y, const wxArrayString& filenames)
{

	s1_ptr files = NewS1( filenames.GetCount() );
	for( int i = 0; i < files->length; i++){
		files->base[i+1] = get_sequence(filenames[i] );
	}
	Files = MAKE_SEQ( files );
	
	call_back( rid, (intptr_t) this );
	
	return true;
}


object WXEUAPI get_drop_files( intptr_t target )
{
	return ((euFileDropTarget*)target)->Files;
}

void WXEUAPI  accept_files(intptr_t window, int rid, int cb )
{
	euFileDropTarget * target = new euFileDropTarget( (EuDnDFunction) cb, rid );
	((wxWindow*)window)->SetDropTarget( target );
}

void WXEUAPI use_primary_selection( int primary )
{
#ifdef __WXGTK__
	wxTheClipboard->UsePrimarySelection( primary );
#endif
}

}
