// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include <wx/display.h>
#if wxUSE_DISPLAY

extern "C" {

object WXEUAPI new_wxDisplay( object params )
{
	wxDeRefDS( params );
	int len = LENGTH( params );
	int index=0;
	
	if (len ==1) 
		index = get_int(params,1);
	
	wxDisplay *d = new wxDisplay(index);
		
	return BOX_INT(d);
}

object WXEUAPI display_change_mode( intptr_t display, object params )
{
	int w, h, d, f;
	
	wxDeRefDS( params );
	
	w = get_int(params,1);
	h = get_int(params,2);
	d = get_int(params,3);
	f = get_int(params,4);
	
	wxVideoMode m = wxVideoMode(w, h, d, f);
	
	return ((wxDisplay*)display)->ChangeMode(m);

}

object WXEUAPI display_get_client_area( intptr_t display )
{
	wxRect rect = ((wxDisplay*)display)->GetClientArea();
	
	s1_ptr eurect = NewS1(4);
	eurect->base[1] = rect.GetX();
	eurect->base[2] = rect.GetY();
	eurect->base[3] = rect.GetWidth();
	eurect->base[4] = rect.GetHeight();
	
	return MAKE_SEQ( eurect );
}

object WXEUAPI display_get_count( intptr_t display )
{
	return ((wxDisplay*)display)->GetCount();
}

object WXEUAPI display_get_current_mode( intptr_t display )
{
	wxVideoMode m = ((wxDisplay*)display)->GetCurrentMode();
	
	s1_ptr mode = NewS1(4);
	mode->base[1] = m.w;
	mode->base[2] = m.h;
	mode->base[3] = m.bpp;
	mode->base[4] = m.refresh;
	
	return MAKE_SEQ( mode );
}


object WXEUAPI display_get_from_point( intptr_t display, object params )
{
	wxDeRefDS( params );
	
	wxPoint pos = wxPoint( get_int( params, 1 ), get_int( params, 2) );
	return ((wxDisplay*)display)->GetFromPoint(pos);
}

object WXEUAPI display_get_from_window( intptr_t display, intptr_t window )
{
	return ((wxDisplay*)display)->GetFromWindow( (wxWindow *)window );
}

object WXEUAPI display_get_geometry( intptr_t display )
{
	wxRect rect = ((wxDisplay*)display)->GetGeometry();
	
	s1_ptr eurect = NewS1(4);
	eurect->base[1] = rect.GetX();
	eurect->base[2] = rect.GetY();
	eurect->base[3] = rect.GetWidth();
	eurect->base[4] = rect.GetHeight();
	
	return MAKE_SEQ( eurect );
}

object WXEUAPI display_get_modes( intptr_t display )
{
	wxVideoMode m;
	s1_ptr mseq;
	wxArrayVideoModes am = ((wxDisplay*)display)->GetModes();
	size_t cnt = am.GetCount();
	
	s1_ptr modes = NewS1(cnt);
	for (int i = 1;i <= cnt; i++) {
		m = am[i-1];
		mseq  = NewS1(4);
		mseq->base[1] = m.w;
		mseq->base[2] = m.h;
		mseq->base[3] = m.bpp;
		mseq->base[4] = m.refresh;

		modes->base[i] = MAKE_SEQ( mseq );
	}
	
	return MAKE_SEQ( modes );
}



object WXEUAPI display_get_name( intptr_t display )
{
	return get_sequence( ((wxDisplay*)display)->GetName() );
}

object WXEUAPI display_is_primary( intptr_t display )
{
	return ((wxDisplay*)display)->IsPrimary() ;
}

}
#endif
