// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include <wx/event.h>

extern "C" {

object WXEUAPI can_update( intptr_t window ){
	return 1 & wxUpdateUIEvent::CanUpdate( (wxWindow*) window );
}

void WXEUAPI check_ui( intptr_t update_event, int check ){
	((wxUpdateUIEvent*)update_event)->Check( check );
}

void WXEUAPI enable_ui( intptr_t update_event, int enable ){
	((wxUpdateUIEvent*)update_event)->Enable( enable );
}

void WXEUAPI show_ui( intptr_t update_event, int show ){
	((wxUpdateUIEvent*)update_event)->Show( show );
}

object WXEUAPI get_checked_ui( intptr_t update_event ){
	return 1 & ((wxUpdateUIEvent*)update_event)->GetChecked();
}

object WXEUAPI get_enabled_ui( intptr_t update_event ){
	return 1 & ((wxUpdateUIEvent*)update_event)->GetEnabled();
}

object WXEUAPI get_shown_ui( intptr_t update_event ){
	return 1 & ((wxUpdateUIEvent*)update_event)->GetShown();
}

object WXEUAPI get_text_ui( intptr_t update_event ){
	return get_sequence( ((wxUpdateUIEvent*)update_event)->GetText() );
}

object WXEUAPI get_mode_ui( intptr_t update_event ){
	return BOX_INT( ((wxUpdateUIEvent*)update_event)->GetMode() );
}

object WXEUAPI get_update_interval_ui(){
	return BOX_INT( wxUpdateUIEvent::GetUpdateInterval() );
}

void WXEUAPI set_ui_update_mode( int mode ){
	wxUpdateUIEvent::SetMode( (wxUpdateUIMode) mode );
}

void WXEUAPI set_text_ui( intptr_t update_event, object text ){
	((wxUpdateUIEvent*)update_event)->SetText( get_string( text ) );
	wxDeRefDS( text );
}

void WXEUAPI set_ui_update_interval( int updateInterval ){
	wxUpdateUIEvent::SetUpdateInterval( updateInterval );
}


}
