// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include <wx/filedlg.h>

extern "C"{

object WXEUAPI new_wxFileDialog(object params)
{
/*
parent Parent window.
message Message to show on the dialog.
defaultDir  The default directory, or the empty string.
defaultFile The default filename, or the empty string.
wildcard A wildcard, such as "*.*" or "BMP files (*.bmp)|*.bmp|GIF files (*.gif)|*.gif".
         Note that the native Motif dialog has some limitations with respect to wildcards; see the Remarks section above.
style A dialog style. See wxFD_* styles for more info.
pos Dialog position. Not implemented.
size Dialog size. Not implemented.
name Dialog name. Not implemented.

wxFileDialog(
	wxWindow* parent, 
	const wxString& message = "Choose a file", 
	const wxString& defaultDir = "", 
	const wxString& defaultFile = "", 
	const wxString& wildcard = "*.*", 
	intptr_t style = wxFD_DEFAULT_STYLE, 
	const wxPoint& pos = wxDefaultPosition, 
	const wxSize& sz = wxDefaultSize, 
	const wxString& name = "filedlg")
*/
	wxDeRefDS( params );
	s1_ptr p = SEQ_PTR( params );
	intptr_t len = p->length;
	wxWindow * parent = (wxWindow *) get_int( params, 1 );
	
	wxString
		message = wxT("Choose a file"),
		defaultDir = wxT(""),
		defaultFile = wxT(""),
		wildcard = wxT("*.*");
	intptr_t style = wxFD_DEFAULT_STYLE;
	switch( len ){
		case 6:
			style = get_int( params, 6 );
		case 5:
			wildcard = get_string( params, 5 );
		case 4:
			defaultFile = get_string( params, 4 );
		case 3:
			defaultDir = get_string( params, 3 );
		case 2:
			message = get_string( params, 2 );	
	}
	return BOX_INT( new wxFileDialog( parent, message, defaultDir, defaultFile, wildcard, style ) );
}

object WXEUAPI get_fd_filename( intptr_t fd )
{
	return get_sequence( reinterpret_cast<wxFileDialog*>( fd )->GetFilename() );
}

object WXEUAPI get_fd_filenames( intptr_t fd )
{
	wxArrayString names;
	reinterpret_cast<wxFileDialog*>( fd )->GetFilenames( names );
	s1_ptr s = NewS1( names.GetCount() );
	
	for( size_t i = 0; i < names.GetCount(); ++i ){
		s->base[i+1] = get_sequence( names[i] );
	}
	return MAKE_SEQ( s );
}

object WXEUAPI get_fd_filter_index( intptr_t fd )
{
	return reinterpret_cast<wxFileDialog*>( fd )->GetFilterIndex();
}

object WXEUAPI get_fd_message( intptr_t fd )
{
	return get_sequence( reinterpret_cast<wxFileDialog*>( fd )->GetMessage() );
}

object WXEUAPI get_fd_path( intptr_t fd )
{
	return get_sequence( reinterpret_cast<wxFileDialog*>( fd )->GetPath() );
}

object WXEUAPI get_fd_paths( intptr_t fd )
{
	wxArrayString paths;
	reinterpret_cast<wxFileDialog*>( fd )->GetPaths( paths );
	s1_ptr s = NewS1( paths.GetCount() );
	
	for( size_t i = 0; i < paths.GetCount(); ++i ){
		s->base[i+1] = get_sequence( paths[i] );
	}
	return MAKE_SEQ( s );
}
object WXEUAPI get_fd_wildcard( intptr_t fd )
{
	return get_sequence( reinterpret_cast<wxFileDialog*>( fd )->GetWildcard() );
}

void WXEUAPI set_fd_directory( intptr_t fd, object directory )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetDirectory( get_string( directory ) );
}

void WXEUAPI set_fd_filename( intptr_t fd, object filename )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetFilename( get_string( filename ) );
}


void WXEUAPI set_fd_filterindex( intptr_t fd, intptr_t filter_index )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetFilterIndex( filter_index );
}


void WXEUAPI set_fd_message( intptr_t fd, object message )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetMessage( get_string( message ) );
}


void WXEUAPI set_fd_path( intptr_t fd, object path )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetPath( get_string( path ) );
}


void WXEUAPI set_fd_wildcard( intptr_t fd, object wildcard )
{
	reinterpret_cast<wxFileDialog*>( fd )->SetWildcard( get_string( wildcard ) );
}

}
