// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/gauge.h"


extern "C"{
object WXEUAPI new_wxGauge(object params)
{
	int len = LENGTH( params );
	wxWindowID id = -1;
	intptr_t range;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	intptr_t style = wxGA_HORIZONTAL;
	//wxValidator validator = wxDefaultValidator;
	wxString name = wxT("gauge");
	
	switch (len)
	{
		case 9:
			name = get_string( params, 9 );
		case 8:
			style = (intptr_t)get_int( params, 8 );
		case 7:
			size = wxSize( get_int(params, 6), get_int(params, 7) );
		case 6:
		case 5:
			pos = wxPoint( get_int(params, 4), get_int(params, 5) );
		default:
			range = (intptr_t)get_int( params, 3 );
			id = (wxWindowID)get_int( params, 2 );
	}
	
	wxGauge * gauge = new wxGauge( (wxWindow *)get_int(params, 1), id,
		range, pos, size, style, wxDefaultValidator, name );
	wxDeRefDS( params )
	
	return BOX_INT( gauge );
}

object WXEUAPI get_bezel_face(intptr_t gauge)
{
	return ((wxGauge*)gauge)->GetBezelFace();
}

object WXEUAPI get_range(intptr_t gauge)
{
	return ((wxGauge*)gauge)->GetRange();
}

object WXEUAPI get_shadow_width(intptr_t gauge)
{
	return ((wxGauge*)gauge)->GetShadowWidth();
}

object WXEUAPI get_value(intptr_t gauge)
{
	return ((wxGauge*)gauge)->GetValue();
}

object WXEUAPI is_gauge_vertical(intptr_t gauge)
{
	return ((wxGauge*)gauge)->IsVertical();
}

void WXEUAPI set_bezel_face(intptr_t gauge, int width)
{
	((wxGauge*)gauge)->SetBezelFace(width);
}

void WXEUAPI set_range(intptr_t gauge, int range)
{
	((wxGauge*)gauge)->SetRange(range);
}

void WXEUAPI set_shadow_width(intptr_t gauge, int width)
{
	((wxGauge*)gauge)->SetShadowWidth(width);
}

void WXEUAPI set_value(intptr_t gauge, int pos)
{
	((wxGauge*)gauge)->SetValue(pos);
}

void WXEUAPI pulse(intptr_t gauge)
{
	((wxGauge*)gauge)->Pulse();
}

}
