// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "wx/image.h"
#include "wx/icon.h"
#include "wx/dc.h"
#include "wx/imaglist.h"
#include "alldefs.h"
#include "wxeu.h"
#include "wx/brush.h"
#include "wx/region.h"
#include "wx/arrstr.h"

#include <wx/hashset.h>
#include "wx/fontenum.h"

#ifdef WXEUMSW
#include <windows.h>
#include "wx/fontutil.h"
#include "wx/fontmap.h"
#include "wx/fontenc.h"
#include "wx/msw/private.h"
#else
#include "pango/pango.h"
#ifdef __WXGTK20__
#include "gtk/gtk.h"
extern GtkWidget *wxGetRootWindow();
#endif // __WXGTK20__
#endif

#define BM_FROM_FILE   1
#define BM_IN_MEMORY   2
#define BM_XPM         3
#define BM_FROM_IMAGE  4

extern "C"{

wxPen WXEUAPI null_pen = wxNullPen;
wxBrush WXEUAPI null_brush = wxNullBrush;
object WXEUAPI  get_font_encoding(intptr_t font)
{
	return BOX_INT( ((wxFont*)font)->GetEncoding() );
}

object WXEUAPI new_wxPaintDC( object window )
{
	wxPaintDC * dc = new wxPaintDC( (wxWindow *) get_int( window, 1 ) );
	wxDeRef(window);
	return BOX_INT( dc );
}

object WXEUAPI  get_font_name(intptr_t font)
{
	return get_sequence( ((wxFont*)font)->GetFaceName());
}

object WXEUAPI  get_font_underlined(intptr_t font)
{
	return ((wxFont*)font)->GetUnderlined();
}

object WXEUAPI  get_font_weight(intptr_t font)
{
	return ((wxFont*)font)->GetWeight();
}

object WXEUAPI  get_font_style(intptr_t font)
{
	return ((wxFont*)font)->GetStyle();
}

object WXEUAPI  get_font_pointsize(intptr_t font)
{
	return ((wxFont*)font)->GetPointSize();
}

object WXEUAPI  get_font_family(intptr_t font)
{
	return ((wxFont*)font)->GetFamily();
}

object WXEUAPI  get_font_members(intptr_t font)
{
	s1_ptr members = NewS1(7);
	int i = 1;	
	members->base[i++] = get_font_pointsize( font );
	members->base[i++] = get_font_family( font );
	members->base[i++] = get_font_style( font );
	members->base[i++] = get_font_weight( font );
	members->base[i++] = get_font_underlined( font );
	members->base[i++] = get_font_name( font );
	members->base[i++] = get_font_encoding( font );
			
	return MAKE_SEQ( members );
}
//wxFont(
//1 int pointSize, 
//2 wxFontFamily family, 
//3 int style,
//4 wxFontWeight weight,
//5 const bool underline = false, 
//6 const wxString& faceName = "",
//7  wxFontEncoding encoding = wxFONTENCODING_DEFAULT)
object WXEUAPI  new_wxFont(object params)
{
	wxFontEncoding encoding = wxFONTENCODING_DEFAULT;
	
	if( ((s1_ptr)SEQ_PTR(params))->length > 6 ){
		encoding = (wxFontEncoding)get_int( params, 7 );
	}
	int pointSize = get_int(params, 1 );
	wxFontFamily family = (wxFontFamily) get_int(params, 2 );
	int style = get_int(params, 3 );
	wxFontWeight weight = (wxFontWeight) get_int(params, 4 );
	bool underline = get_int(params, 5 );
	wxString faceName = get_string(params, 6 );
	
	wxFont * font = new wxFont( 
		pointSize,
		family,
		style,
		weight,
		underline,
		faceName,
		encoding );
	wxDeRefDS(params);
	return BOX_INT(font);
}

void WXEUAPI set_default_font_encoding( intptr_t font, int encoding )
{
	((wxFont*)font)->SetDefaultEncoding( (wxFontEncoding) encoding );
}

void WXEUAPI set_font_face_name( intptr_t font, object face_name )
{
	wxDeRefDS( face_name );
	((wxFont*)font)->SetFaceName( get_string( face_name ) );
}

void WXEUAPI set_font_familty( intptr_t font, intptr_t family )
{
	((wxFont*)font)->SetFamily( (wxFontFamily) family );
}

object WXEUAPI set_native_font_info( intptr_t font, object info )
{
	wxDeRefDS( info );
	return 1 & ((wxFont*)font)->SetNativeFontInfo( get_string( info ) );
}

object WXEUAPI get_native_font_info( intptr_t font )
{
	return get_sequence( ((wxFont*)font)->GetNativeFontInfoDesc() );
}

object WXEUAPI get_native_font_info_user_desc( intptr_t font )
{
	return get_sequence( ((wxFont*)font)->GetNativeFontInfoUserDesc() );
}

object WXEUAPI set_native_font_info_user_desc( intptr_t font, object info )
{
	wxDeRefDS( info );
	return 1 & ((wxFont*)font)->SetNativeFontInfoUserDesc( get_string( info ) );
}

void WXEUAPI set_font_style( intptr_t font, int style )
{
	((wxFont*)font)->SetStyle( style );
}

void WXEUAPI set_font_underlined( intptr_t font, int underlined )
{
	((wxFont*)font)->SetUnderlined( underlined );
}

void WXEUAPI set_font_weight( intptr_t font, int weight )
{
	((wxFont*)font)->SetWeight( (wxFontWeight) weight );
}



void WXEUAPI  set_font(intptr_t dc,intptr_t font)
{
	if(!font) ((wxDC*)dc)->SetFont( wxNullFont );
	else ((wxDC *)dc)->SetFont( *((wxFont*)font ));
}

void WXEUAPI  set_default_font(intptr_t win, intptr_t font)
{
	((wxWindow *)win)->SetFont( *((wxFont*)font));
}

void WXEUAPI  wx_puts(object win, object text)
{

	wxDeRef(win);
	wxDeRefDS(text);
	
	wxString str = get_string( text );
	int x = 0;
	int y = 0;
	wxDC *dc = NULL;
	bool del = true;
	if( IS_SEQUENCE(win) ){
		x = get_int( win, 2 );
		y = get_int( win, 3 );

		if( ((s1_ptr)SEQ_PTR(win))->length > 3 ){
			dc = (wxDC *)get_int( win, 4 );
			del = false;
		}
		win = get_int( win, 1 );
	}
	
	
	if( del ){
		dc = new wxPaintDC((wxWindow *) get_int( win ));
	}


	dc->DrawText( str, x, y );

	if( del )
		delete dc;
}

void WXEUAPI  set_pen(intptr_t dc, intptr_t pen)
{
	((wxDC*)dc)->SetPen( *((wxPen*)pen));
}

void WXEUAPI  draw_line(intptr_t dc, object points)
{
	((wxDC*)dc)->DrawLine( get_int( points, 1 ), get_int( points, 2 ),
		get_int( points, 3 ), get_int( points, 4 ) );
	wxDeRefDS( points );
}

void WXEUAPI  set_text_back_color(intptr_t dc, object color)
{
	if( IS_SEQUENCE( color ) ){
		((wxDC*)dc)->SetTextBackground( 
			wxColour( (unsigned char ) get_int( color, 1 ),
				(unsigned char ) get_int( color, 2 ),
				(unsigned char ) get_int( color, 3 )));
		wxDeRefDS( color );
	}
	else{
		((wxDC*)dc)->SetTextBackground( *((wxColour*) get_int(color)));
		wxDeRef( color );
	}
	

}

void WXEUAPI  set_text_color(intptr_t dc, intptr_t color )
{
	((wxDC *)dc)->SetTextForeground( *((wxColour*)color) );
	
}

object WXEUAPI  new_wxColour(object params)
{
	object p = ((s1_ptr)SEQ_PTR(params))->base[1];
	wxColour * colour = NULL;
	if( IS_SEQUENCE(p) and ((s1_ptr)SEQ_PTR(p))->length ){
		// color by name
		wxString name = get_string( params, 1 );
		colour = new wxColour( name );
	}
	else{
		colour = new wxColour( (unsigned char) get_int(params, 1 ),
			(unsigned char) get_int( params, 2 ),
			(unsigned char) get_int( params, 3 ));
	}
	wxDeRefDS(params);
	return BOX_INT(colour);
}

char ** new_xpm( object xpm_object ){
	s1_ptr xpm = SEQ_PTR( xpm_object );
	int len = xpm->length;
	intptr_t * bits = new intptr_t[len];
	intptr_t * ptr = bits;
	for( int i = 1; i <= len; i++ ){
		s1_ptr xpm_ix = SEQ_PTR( xpm->base[i] );
		char * line = new char[xpm_ix->length + 1];
		*ptr = (intptr_t)line;
		ptr++;
		for( int j = 1; j <= xpm_ix->length; j++ ){
			*(line++) = (char) xpm_ix->base[j];
		}
		*line = 0;
		
	}
	return (char **) bits;
}

object WXEUAPI  new_wxBitmap(object params)
{
	int bmp_kind = get_int( params, 1 );
	wxBitmap * bmp = NULL;
	wxImage  * image = NULL;
	wxString name;
	int depth;
	int len;
	int bmp_type;
	char ** xpm;
	s1_ptr xs;
	switch( bmp_kind ){
		case BM_FROM_FILE:
			name = get_string( params, 2 );
			bmp_type = get_int( params, 3 );
			{
			wxImage img = wxImage( name, bmp_type );
			bmp = new wxBitmap( img );
			}
			break;
			
		case BM_IN_MEMORY:
			len = ((s1_ptr)SEQ_PTR(params))->length;
			depth = -1;
			switch( len ){
				case 4:
					depth = get_int( params, 4 );
				
				default:
					bmp = new wxBitmap( get_int( params, 2 ), get_int( params, 3 ), depth );
			}
			break;
			
		case BM_XPM:
			xpm = new_xpm( ((s1_ptr)SEQ_PTR(params))->base[2]  );
			bmp = new wxBitmap( xpm );
			len = LENGTH( ((s1_ptr)SEQ_PTR(params))->base[2]);
			for( int i = 0; i < len; i++){
				delete[] xpm[i];
			}
			delete[] xpm;
			break;
			
		case BM_FROM_IMAGE:
			len = ((s1_ptr)SEQ_PTR(params))->length;
			image = (wxImage*)get_int( params, 2 );
			depth = -1;
			switch( len ){
				case 3:
					depth = get_int( params, 3 );
					
				default:
					bmp = new wxBitmap( *image, depth );
			}
			break;
			
		default:
			bmp = NULL;
			break;
	}
	wxDeRefDS(params);
	return BOX_INT(bmp);
}

object WXEUAPI  load_icon(intptr_t icon, object file, int icon_type, int height, int width)
{
	int ret = ((wxIcon*)icon)->LoadFile( get_string( file ), (wxBitmapType)icon_type );
	wxDeRefDS( file );
	return ret;
}

object WXEUAPI  new_wxIcon(object params)
{
	
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	int width = -1;
	int height = -1;
	wxIcon * icon;
	char ** xpm;
	switch( len ){
		case 4:
			height = get_int( params, 4 );
		
		case 3:
			width = get_int( params, 3 );
		
		case 2:
			icon = new wxIcon( get_string( params, 1 ),(wxBitmapType) get_int( params, 2 ), width, height );
			break;
		
		case 1:
			xpm = new_xpm( ((s1_ptr)SEQ_PTR(params))->base[1]);
			icon = new wxIcon( xpm );
			
			len = LENGTH( ((s1_ptr)SEQ_PTR(params))->base[1]);
			for( int i = 0; i < len; i++){
				delete[] xpm[i];
			}
			delete[] xpm;
			break;
		default:
			icon = NULL;
			break;
	}
	wxDeRefDS(params);
	return BOX_INT( icon );
}

void WXEUAPI  set_bitmap_size(intptr_t bm, int cx, int cy)
{
	((wxBitmap*)bm)->SetHeight( cy );
	((wxBitmap*)bm)->SetWidth( cx );
}

object WXEUAPI  get_bitmap_size(intptr_t bitmap)
{
	s1_ptr size = NewS1(2);
	size->base[1] = ((wxBitmap*)bitmap)->GetWidth();
	size->base[2] = ((wxBitmap*)bitmap)->GetHeight();
	return MAKE_SEQ( size );
}

void WXEUAPI  draw_icon(intptr_t dc, intptr_t icon, int x, int y)
{
	((wxDC *)dc)->DrawIcon( *((wxIcon *)icon), x, y);
}

void WXEUAPI  draw_bitmap(intptr_t dc, intptr_t bitmap, int x, int y, int trans)
{
	((wxDC *)dc)->DrawBitmap( *((wxBitmap *)bitmap), x, y, trans );

}

void WXEUAPI  set_mask(int bmp, int mask)
{
	((wxBitmap*)bmp)->SetMask( (wxMask*) mask );
}

void WXEUAPI  draw_bitmap2(object bitmap, int dest, int xsrc, int ysrc, int xdest, int ydest, int width, int height, int logical_func, int use_mask)
{

}

void WXEUAPI  draw_polygon(intptr_t dc, object points, int x, int y, int style)
{
	s1_ptr p = SEQ_PTR( points );
	int len = p->length;
	wxPoint * point_array = new wxPoint[len/2];
	for( int i = 0; i < len/2; i += 1 ){
		point_array[i].x = p->base[2*i+1];
		point_array[i].y = p->base[2*i+2];
	}
	((wxDC*)dc)->DrawPolygon( len/2, point_array, x, y, style );
	delete[] point_array;
	wxDeRefDS(points);
}

object WXEUAPI  get_regions(intptr_t window)
{
/*
	atom region, iter
	region = cpp:call_member( wxWindowBase_GetUpdateRegion, window, {})

	iter = wxeu:create( wxRegionIterator, region)

	return iter
*/
	wxRegion region = ((wxWindow*)window)->GetUpdateRegion();
	wxRegionIterator * iter = new wxRegionIterator( region );
	return BOX_INT( iter );
}

object WXEUAPI  get_region(intptr_t iter)
{
/*
	rect = call_member( wxRegionIterator_GetX, iter, {} ) &
	call_member( wxRegionIterator_GetY, iter, {} ) &
	call_member( wxRegionIterator_GetW, iter, {} ) &
	call_member( wxRegionIterator_GetH, iter, {} )	
	return rect
*/
	s1_ptr rect = NewS1( 4 );
	wxRegionIterator * ri = (wxRegionIterator*) iter;
	rect->base[1] = ri->GetX();
	rect->base[2] = ri->GetY();
	rect->base[3] = ri->GetW();
	rect->base[4] = ri->GetH();
	return MAKE_SEQ( rect );
}

object WXEUAPI  get_first_region(intptr_t iter)
{
	wxRegionIterator * iterator = (wxRegionIterator*)iter;
	iterator->Reset();
	s1_ptr s;
	if( !iterator->HaveRects()){
		s = NewS1(0);
		return MAKE_SEQ(s);
	}
	
	s = NewS1(4);
	s->base[1] = iterator->GetX();
	s->base[2] = iterator->GetY();
	s->base[3] = iterator->GetW();
	s->base[4] = iterator->GetH();
	return MAKE_SEQ(s);
}

object WXEUAPI  get_next_region(intptr_t iter)
{
	wxRegionIterator * iterator = (wxRegionIterator*)iter;
	(*iterator)++;
	s1_ptr s;
	if( !iterator->HaveRects()){
		s = NewS1(0);
		return MAKE_SEQ(s);
	}
	
	s = NewS1(4);
	s->base[1] = iterator->GetX();
	s->base[2] = iterator->GetY();
	s->base[3] = iterator->GetW();
	s->base[4] = iterator->GetH();
	return MAKE_SEQ(s);
}

void WXEUAPI  begin_drawing(intptr_t dc)
{
	// Deprecated
	//((wxDC*)dc)->BeginDrawing();
}

void WXEUAPI  end_drawing(intptr_t dc)
{
	// Deprecated
	//((wxDC*)dc)->EndDrawing();
}

void WXEUAPI  set_brush(intptr_t dc, intptr_t brush)
{
	((wxDC*)dc)->SetBrush( *((wxBrush*)brush) );
}

void WXEUAPI  set_back_brush(intptr_t dc, intptr_t brush)
{
	((wxDC*)dc)->SetBackground(*((wxBrush*)brush));
}

void WXEUAPI  clear_dc(intptr_t dc)
{
	((wxDC*)dc)->Clear();
}

void WXEUAPI  select_object(intptr_t dc, intptr_t obj)
{
	((wxMemoryDC*)dc)->SelectObject(*((wxBitmap*)obj));
}

object WXEUAPI  new_wxMemoryDC(object params)
{
	wxMemoryDC * dc = new wxMemoryDC();
	if( LENGTH( params ) ){
		dc->SelectObject( *((wxBitmap*)get_int(params, 1)) );
	}
	wxDeRefDS(params);
	return BOX_INT( dc );
}

void WXEUAPI  blit(intptr_t dstDC, int dstX, int dstY, intptr_t srcDC, int srcX, int srcY, int width, int height, int operation)
{
/*
bool Blit(wxCoord xdest, wxCoord ydest, wxCoord width, wxCoord height, 
wxDC* source, wxCoord xsrc, wxCoord ysrc, int logicalFunc = wxCOPY, 
bool useMask = false, wxCoord xsrcMask = -1, wxCoord ysrcMask = -1)
*/ 
	((wxDC*)dstDC)->Blit( (wxCoord)dstX, (wxCoord)dstY, (wxCoord)width, 
		(wxCoord)height, (wxDC*)srcDC, 
		(wxCoord)srcX, (wxCoord)srcY, operation );
}

void WXEUAPI  set_background_mode(intptr_t dc, int mode)
{
	((wxDC*)dc)->SetBackgroundMode( mode );
}

object WXEUAPI  get_sys_color(intptr_t color)
{
	wxColour *syscolor = new wxColour(wxSystemSettings::GetColour((wxSystemColour)color));
	return BOX_INT( syscolor );
}

object WXEUAPI  new_wxImageList(object params)
{
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	int initialCount = 1;
	bool mask = true;
	wxImageList * list;
	switch( len ){
		case 4:
			initialCount = get_int( params, 4 );
		
		case 3:
			mask = (bool) get_int( params, 3 );
		
		default:
			list = new wxImageList( get_int( params, 1 ), get_int( params, 2 ), mask, initialCount );
			wxDeRefDS(params);
			return BOX_INT( list );
	}
	wxDeRefDS(params);
	return 0;
}

object WXEUAPI  add_image(intptr_t ilist, intptr_t image, object mask)
{

	wxBitmap mask_bmp = wxNullBitmap;
	int ix;	
	if( IS_SEQUENCE( mask ) ){
		if( ((s1_ptr)SEQ_PTR(mask))->length ){
			wxColour mask_colour = wxColour( (unsigned char) get_int(mask, 1 ),
				(unsigned char) get_int( mask, 2 ),
				(unsigned char) get_int( mask, 3 ));
			ix = ((wxImageList *)ilist)->Add( *((wxBitmap *) image),  mask_colour );
		
		}
		else{
			ix = ((wxImageList *)ilist)->Add( *((wxBitmap *)image) );
		}

		return BOX_INT( ix );
	}
	
	if( mask ) mask_bmp = *((wxBitmap *)get_int( mask ));
	ix = ((wxImageList *)ilist)->Add( *((wxBitmap *)image), wxNullBitmap ); //mask_bmp );
	wxDeRef(mask);
	return BOX_INT( ix );
}

object WXEUAPI remove_all_images( intptr_t ilist ){
	return ((wxImageList*)ilist)->RemoveAll();
}

object WXEUAPI remove_image( intptr_t ilist, int index ){
	return ((wxImageList*)ilist)->Remove( index );
}

object WXEUAPI replace_image( intptr_t ilist, int index, intptr_t bmp, intptr_t mask ){
	wxBitmap mask_bmp = mask ? *reinterpret_cast<wxBitmap*>( mask ) : wxNullBitmap;
	return reinterpret_cast<wxImageList*>( ilist )->Replace( index, *reinterpret_cast<wxBitmap*>( bmp ), mask_bmp );
}

object WXEUAPI  new_wxBrush(object params)
{
	int style = wxSOLID;
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	if( len == 2 ){
		style = get_int( params, 2 );
	}
	wxBrush * brush = new wxBrush( *((wxColour*)get_int(params, 1 )), style );
	wxDeRefDS(params);
	return BOX_INT( brush );
}

object WXEUAPI  get_dc_text_extent(intptr_t dc, object text)
{
/*
void GetTextExtent(const wxString& string, wxCoord *w, wxCoord *h,
wxCoord *descent = NULL, wxCoord *externalLeading = NULL, wxFont *font = NULL)
*/
	int  w;
	int  h;
	((wxDC*)dc)->GetTextExtent( get_string( text ), &w, &h);
	s1_ptr ext = NewS1(2);
	ext->base[1] = w;
	ext->base[2] = h;
	wxDeRefDS( text );
	return MAKE_SEQ(ext);
}

object WXEUAPI  get_user_scale(intptr_t dc)
{
	double  x;
	double  y;
	((wxDC*)dc)->GetUserScale( &x, &y );
	
	s1_ptr scale = NewS1( 2 );
	scale->base[1] = NewDouble( x );
	scale->base[2] = NewDouble( y );
	return MAKE_SEQ( scale );
}

void WXEUAPI  set_user_scale(intptr_t dc, double x, double y)
{
	((wxDC*)dc)->SetUserScale( x, y );
}

object WXEUAPI  get_dc_size(intptr_t dc)
{
	int x;
	int y;
	((wxDC*)dc)->GetSize(&x, &y);
	
	s1_ptr size = NewS1(2);
	size->base[1] = x;
	size->base[2] = y;
	return MAKE_SEQ(size);
}

void WXEUAPI  set_point_size(intptr_t font, intptr_t points)
{
	((wxFont*)font)->SetPointSize(points);
}

object WXEUAPI  get_point_size(intptr_t font)
{
	return ((wxFont*)font)->GetPointSize();
}

void WXEUAPI  set_pen_size(intptr_t pen, int width)
{
	((wxPen*)pen)->SetWidth( width );
}

void WXEUAPI  set_pen_color(intptr_t pen, intptr_t color)
{
	((wxPen*)pen)->SetColour( *((wxColour*)color));
}

WX_DECLARE_HASH_SET( int, wxIntegerHash, wxIntegerEqual, IntSet );
WX_DECLARE_HASH_MAP( wxString,      // type of the keys
                     IntSet*,    // type of the values
                     wxStringHash,     // hasher
                     wxStringEqual,   // key equality predicate
                     FaceSizes); // name of the class
class euFontEnumerator : public wxFontEnumerator {
	public:
		euFontEnumerator() {}
		virtual bool OnFaceSize( wxString name,int * sizes, int n );
		bool EnumerateFaceSizes(wxFontEncoding encoding,
                                          bool fixedWidthOnly);
		FaceSizes GetFaceSizes(wxFontEncoding encoding, bool fixedWidthOnly)
                                          { EnumerateFaceSizes(encoding,fixedWidthOnly); return m_faceSizes; }
	private:
		FaceSizes m_faceSizes;
};

bool euFontEnumerator::OnFaceSize( wxString name, int* sizes, int n ){
	
	IntSet* size;
	FaceSizes::iterator it = m_faceSizes.find( name );
	
	if( it == m_faceSizes.end() ){
		size = new IntSet();
		m_faceSizes[name] = size;
	}
	else{
		size = it->second;
	}
	
	for( int i = 0; i < n; i++ ) size->insert( sizes[i] );
	return true;
}

#ifdef WXEUMSW
// the helper class which calls ::EnumFontFamilies() and whose OnFont() is
// called from the callback passed to this function and, in its turn, calls the
// appropariate wxFontEnumerator method
class euFontEnumeratorHelper
{
public:
    euFontEnumeratorHelper(euFontEnumerator *fontEnum);

    // control what exactly are we enumerating
        // we enumerate fonts with given enocding
    bool SetEncoding(wxFontEncoding encoding);
        // we enumerate fixed-width fonts
    void SetFixedOnly(bool fixedOnly) { m_fixedOnly = fixedOnly; }
        // we enumerate the encodings available in this family
    void SetFamily(const wxString& family);

    // call to start enumeration
    void DoEnumerate();

    // called by our font enumeration proc
    bool OnFont(const LPLOGFONT lf, const LPTEXTMETRIC tm, const DWORD FontType) const;

private:
    // the object we forward calls to OnFont() to
    euFontEnumerator *m_fontEnum;

    // if != -1, enum only fonts which have this encoding
    int m_charset;

    // if not empty, enum only the fonts with this facename
    wxString m_facename;

    // if not empty, enum only the fonts in this family
    wxString m_family;

    // if true, enum only fixed fonts
    bool m_fixedOnly;

    // if true, we enumerate the encodings, not fonts
    bool m_enumEncodings;

    // the list of charsets we already found while enumerating charsets
    wxArrayInt m_charsets;

    // the list of facenames we already found while enumerating facenames
    wxArrayString m_facenames;

    DECLARE_NO_COPY_CLASS(euFontEnumeratorHelper)
};

// ----------------------------------------------------------------------------
// private functions
// ----------------------------------------------------------------------------

#ifndef __WXMICROWIN__
intptr_t CALLBACK euFontEnumeratorProc(LPLOGFONT lplf, LPTEXTMETRIC lptm,
                                  DWORD dwStyle, LONG lParam);
#endif
// ============================================================================
// implementation
// ============================================================================

// ----------------------------------------------------------------------------
// euFontEnumeratorHelper
// ----------------------------------------------------------------------------

euFontEnumeratorHelper::euFontEnumeratorHelper(euFontEnumerator *fontEnum)
{
    m_fontEnum = fontEnum;
    m_charset = DEFAULT_CHARSET;
    m_fixedOnly = false;
    m_enumEncodings = false;
}

void euFontEnumeratorHelper::SetFamily(const wxString& family)
{
    m_enumEncodings = true;
    m_family = family;
}

bool euFontEnumeratorHelper::SetEncoding(wxFontEncoding encoding)
{
    return true;
}

#if defined(__GNUWIN32__) && !defined(__CYGWIN10__) && !wxCHECK_W32API_VERSION( 1, 1 ) && !wxUSE_NORLANDER_HEADERS
    #define euFONTENUMPROC int(*)(ENUMLOGFONTEX *, NEWTEXTMETRICEX*, int, LPARAM)
#else
    #define euFONTENUMPROC FONTENUMPROC
#endif

void euFontEnumeratorHelper::DoEnumerate()
{
#ifndef __WXMICROWIN__
    HDC hDC = ::GetDC(NULL);

#ifdef __WXWINCE__
    ::EnumFontFamilies(hDC,
                       m_facename.empty() ? NULL : m_facename.c_str(),
                       (euFONTENUMPROC)euFontEnumeratorProc,
                       (LPARAM)this) ;
#else // __WIN32__
    LOGFONT lf;
    lf.lfCharSet = (BYTE)m_charset;
    wxStrncpy(lf.lfFaceName, m_facename, WXSIZEOF(lf.lfFaceName));
    lf.lfPitchAndFamily = 0;
    ::EnumFontFamiliesEx(hDC, &lf, (euFONTENUMPROC)euFontEnumeratorProc,
                         (LPARAM)this, 0 /* reserved */) ;
#endif // Win32/CE

    ::ReleaseDC(NULL, hDC);
#endif
}

bool euFontEnumeratorHelper::OnFont(const LPLOGFONT lf,
                                    const LPTEXTMETRIC tm,
                                    const DWORD FontType) const
{
    if ( m_enumEncodings )
    {
        // is this a new charset?
        int cs = lf->lfCharSet;
        if ( m_charsets.Index(cs) == wxNOT_FOUND )
        {
            wxConstCast(this, euFontEnumeratorHelper)->m_charsets.Add(cs);

            wxFontEncoding enc = wxGetFontEncFromCharSet(cs);
            return m_fontEnum->OnFontEncoding(lf->lfFaceName,
                                              wxFontMapper::GetEncodingName(enc));
        }
        else
        {
            // continue enumeration
            return true;
        }
    }

    if ( m_fixedOnly )
    {
        // check that it's a fixed pitch font (there is *no* error here, the
        // flag name is misleading!)
        if ( tm->tmPitchAndFamily & TMPF_FIXED_PITCH )
        {
            // not a fixed pitch font
            return true;
        }
    }

    if ( m_charset != DEFAULT_CHARSET )
    {
        // check that we have the right encoding
        if ( lf->lfCharSet != m_charset )
        {
            return true;
        }
    }
    else // enumerating fonts in all charsets
    {
        // we can get the same facename twice or more in this case because it
        // may exist in several charsets but we only want to return one copy of
        // it (note that this can't happen for m_charset != DEFAULT_CHARSET)
        if ( m_facenames.Index(lf->lfFaceName) != wxNOT_FOUND )
        {
            // continue enumeration
            return true;
        }

        wxConstCast(this, euFontEnumeratorHelper)->
            m_facenames.Add(lf->lfFaceName);
    }
	int* sizes = (int*) malloc( 4 );
	int size_count = 0;
	if( FontType == TRUETYPE_FONTTYPE ){
		*sizes = 0;
	}
	else{
		size_count = 1;
		// lfHeight = -MulDiv(PointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
		 HDC hDC = ::GetDC(NULL);
		*sizes = MulDiv( lf->lfHeight, 72, GetDeviceCaps( hDC, LOGPIXELSY ) );
		::ReleaseDC(NULL, hDC);
	}
    bool ret = m_fontEnum->OnFaceSize(wxString(lf->lfFaceName), sizes, size_count);
    free( sizes );
    return ret;
    //return m_fontEnum->OnFacename(lf->lfFaceName);
}

intptr_t CALLBACK euFontEnumeratorProc(LPLOGFONT lplf, LPTEXTMETRIC lptm,
                                  DWORD FontType, LONG lParam)
{

    euFontEnumeratorHelper* fontEnum = (euFontEnumeratorHelper *) lParam;
    return fontEnum->OnFont( lplf, lptm, FontType );
}

bool euFontEnumerator::EnumerateFaceSizes(wxFontEncoding encoding,
                                          bool fixedWidthOnly)
{
    euFontEnumeratorHelper fe(this);
    if ( fe.SetEncoding(encoding) )
    {
        fe.SetFixedOnly(fixedWidthOnly);

        fe.DoEnumerate();
    }
    // else: no such fonts, unkown encoding

    return true;
}


#else // WXEUMSW

extern "C" int wxCMPFUNC_CONV
wxCompareFamilies (const void *a, const void *b)
{
  const char *a_name = pango_font_family_get_name (*(PangoFontFamily **)a);
  const char *b_name = pango_font_family_get_name (*(PangoFontFamily **)b);

  return g_utf8_collate (a_name, b_name);
}

bool euFontEnumerator::EnumerateFaceSizes(wxFontEncoding encoding,
                                          bool fixedWidthOnly)
{
    if ( encoding != wxFONTENCODING_SYSTEM && encoding != wxFONTENCODING_UTF8 )
    {
        // Pango supports only UTF-8 encoding (and system means any, so we
        // accept it too)
        return false;
    }

    {
        PangoFontFamily **families = NULL;
        gint n_families = 0;
        pango_context_list_families (
#ifdef __WXGTK20__
            gtk_widget_get_pango_context( wxGetRootWindow() ),
#else
            wxTheApp->GetPangoContext(),
#endif
            &families, &n_families );
        qsort (families, n_families, sizeof (PangoFontFamily *), wxCompareFamilies);

        for (int i=0; i<n_families; i++)
        {
#if defined(__WXGTK24__) || defined(HAVE_PANGO_FONT_FAMILY_IS_MONOSPACE)
            if (!fixedWidthOnly || (
#ifdef __WXGTK24__
                !gtk_check_version(2,4,0) &&
#endif
                pango_font_family_is_monospace(families[i])
                                   ) )
#endif
            {
                const gchar *name = pango_font_family_get_name(families[i]);
                
                PangoFontFace** faces = NULL;
                int n_faces;
                
                pango_font_family_list_faces        ( families[i],
                                                      &faces,
                                                      &n_faces);
                for(int j=0; j < n_faces; j++ ){
                	int *sizes = NULL;
                	int n_sizes;
			pango_font_face_list_sizes( faces[j], &sizes, &n_sizes);
			g_free( sizes );
			OnFaceSize(wxString(name, wxConvUTF8), sizes, n_sizes);
		}
                
            }
        }
        g_free(families);
    }

    return true;
}

#endif

int CompareInts(int n1, int n2){
    return n1 - n2;
}


WX_DEFINE_SORTED_ARRAY_INT(int, ArrayOfSortedInts);

object WXEUAPI get_facesizes(object params)
{
	int len = LENGTH( params );
	wxFontEncoding encoding = wxFONTENCODING_SYSTEM;
	bool fixed = wxFalse;
	euFontEnumerator enumerator;
	switch( len ){
		case 2:
			fixed = (bool) get_int( params, 2 );
		case 1:
			encoding = (wxFontEncoding)get_int( params, 1 );
		default:
			break;
	}
	FaceSizes faceSizes = enumerator.GetFaceSizes(encoding, fixed);
	
	int face_count = faceSizes.size();

	s1_ptr ret = NewS1( 2 );
	s1_ptr names = NewS1( face_count );
	s1_ptr sizes_seq = NewS1( face_count );
	
	ret->base[1] = MAKE_SEQ( names );
	ret->base[2] = MAKE_SEQ( sizes_seq );
	
	FaceSizes::iterator fs_it = faceSizes.begin();
	wxArrayString faceArray;
	
	faceArray.Alloc( face_count );
	for( unsigned int i = 0; i < face_count; i++, fs_it++ ){
		faceArray.Add( fs_it->first );
	}
	faceArray.Sort();
	
	for( unsigned int i = 0; i < face_count; i++ ){
		
		names->base[i+1] = get_sequence( faceArray[i] );
		
		IntSet* sizes = faceSizes[faceArray[i]];
		
		ArrayOfSortedInts intArray( CompareInts );
		intArray.Alloc( sizes->size() );
		IntSet::iterator s_it = sizes->begin();
		for( int j = 0; j < sizes->size(); j++, s_it++ ){
			intArray.Add( *s_it );
		}
		s1_ptr size_seq = NewS1( sizes->size() );
		for( int j = 0; j < intArray.GetCount(); j++  ){
			size_seq->base[j+1] = BOX_INT( intArray[j] );
		}
		sizes_seq->base[i+1] = MAKE_SEQ( size_seq );
		
	}
	wxDeRefDS(params);
	return MAKE_SEQ( ret );
}

object WXEUAPI  get_facenames(object params)
{
	int len = LENGTH( params );
	wxFontEncoding encoding = wxFONTENCODING_SYSTEM;
	bool fixed = wxFalse;
	wxFontEnumerator enumerator;
	switch( len ){
		case 2:
			fixed = (bool) get_int( params, 2 );
		case 1:
			encoding = (wxFontEncoding)get_int( params, 1 );
		default:
			break;
	}
	wxArrayString fn = enumerator.GetFacenames(encoding, fixed);
	
	s1_ptr names = NewS1( fn.GetCount() );
	for( unsigned int i = 0; i < fn.GetCount(); i++ ){
		wxString face = fn.Item(i);
		names->base[i+1] = get_sequence( face );
	}
	wxDeRefDS(params);
	return MAKE_SEQ( names );
}

object WXEUAPI  get_encodings(object fontname)
{
	wxFontEnumerator enumerator;
	enumerator.EnumerateEncodings( get_string( fontname ) );
	wxArrayString fn = enumerator.GetEncodings();
	
	s1_ptr names = NewS1( fn.GetCount() );
	for( unsigned int i = 0; i < fn.GetCount(); i++ ){
		wxString face = fn.Item(i);
		names->base[i+1] = get_sequence( face );
	}
	wxDeRefDS( fontname );
	return MAKE_SEQ( names );
}

object WXEUAPI  convert_to_image(intptr_t bitmap)
{
	wxImage * img = new wxImage( ((wxBitmap*)bitmap)->ConvertToImage() );
	return 	BOX_INT( img );
}

object WXEUAPI  get_alpha(object params)
{
	intptr_t image = get_int( params, 1 );
	int x = get_int( params, 2 );
	int y = get_int( params, 3 );
	wxDeRefDS( params );
	return (object)((wxImage*)image)->GetAlpha(x, y);
}

object WXEUAPI  get_red(object params)
{
	if ( IS_SEQUENCE(params) ) {
		intptr_t image = get_int( params, 1 );
		int x = get_int( params, 2 );
		int y = get_int( params, 3 );
		wxDeRefDS( params );
		return (object)((wxImage*)image)->GetRed(x, y);

	} else {
		return (object)((wxColour*)params)->Red();

	}
}

object WXEUAPI  get_green(object params)
{
	if ( IS_SEQUENCE(params) ) {
		intptr_t image = get_int( params, 1 );
		int x = get_int( params, 2 );
		int y = get_int( params, 3 );
		wxDeRefDS( params );
		return (object)((wxImage*)image)->GetGreen(x, y);

	} else {
		return (object)((wxColour*)params)->Green();

	}
}

object WXEUAPI  get_blue(object params)
{
	if ( IS_SEQUENCE(params) ) {
		intptr_t image = get_int( params, 1 );
		int x = get_int( params, 2 );
		int y = get_int( params, 3 );
		wxDeRefDS( params );
		return (object)((wxImage*)image)->GetBlue(x, y);

	} else {
		return (object)((wxColour*)params)->Blue();

	}
}

object WXEUAPI  find_color( object params )
{
	wxDeRefDS( params );
	wxColour *c = new wxColour( wxTheColourDatabase->Find(get_string(params)) );
	return BOX_INT( c );
}

object WXEUAPI new_wxPen( object params )
{
	wxPen * pen = new wxPen( *((wxColour*)get_int(params, 1)),
		get_int( params, 2 ), get_int(params, 3 ) );
	wxDeRefDS(params);
	return BOX_INT( pen );
}

object WXEUAPI new_wxClientDC( object params )
{
	wxClientDC * dc = new wxClientDC( (wxWindow *) get_int(params, 1 ) );
	wxDeRefDS(params);
	return BOX_INT(dc);
}

object WXEUAPI new_wxMask( object params )
{
	wxBitmap * bitmap = (wxBitmap*)get_int(params, 1);
	wxColour * colour = (wxColour*)get_int(params, 2);
	wxMask * mask = new wxMask( *bitmap, *colour );
	wxDeRefDS(params);
	return BOX_INT( mask );
}

object WXEUAPI  new_wxImage(object params)
{
	
	int len = LENGTH(params);
	int width = get_int( params, 1 );
	int height = get_int( params, 2 );
	int data = 0;
	int flag = 0;
	
	switch( len ){
		case 4:
			flag = get_int( params, 4 );
		case 3:
			data = get_int( params, 3 );
		default:
			break;
	}
	wxImage * img = 0;
	if ( data ) {
		img = new wxImage( width, height, ((unsigned char*)data), ((bool)flag) );
	} else {
		img = new wxImage( width, height, ((bool)flag) );
	}
	
	wxDeRefDS(params);
	return BOX_INT(img);
}

object WXEUAPI convert_to_greyscale(intptr_t image)
{
	wxImage * img = new wxImage( ((wxImage*)image)->ConvertToGreyscale() );
	return BOX_INT( img );
}

object WXEUAPI convert_to_mono(intptr_t image, object rgb)
{
	int r = get_int( rgb, 1 );
	int g = get_int( rgb, 2 );
	int b = get_int( rgb, 3 );
	wxDeRefDS( rgb );
	wxImage * img = new wxImage( ((wxImage*)image)->ConvertToMono(r, g, b) );
	return BOX_INT( img );
}

object WXEUAPI blur(intptr_t image, int blurRadius)
{
	wxImage * img = new wxImage( ((wxImage*)image)->Blur(blurRadius) );
	return BOX_INT( img );
}

object WXEUAPI blur_horizontal(intptr_t image, int blurRadius)
{
	wxImage * img = new wxImage( ((wxImage*)image)->BlurHorizontal(blurRadius) );
	return BOX_INT( img );
}

object WXEUAPI blur_vertical(intptr_t image, int blurRadius)
{
	wxImage * img = new wxImage( ((wxImage*)image)->BlurVertical(blurRadius) );
	return BOX_INT( img );
}

object WXEUAPI mirror(intptr_t image, int horizontal)
{
	wxImage * img = new wxImage( ((wxImage*)image)->Mirror(horizontal) );
	return BOX_INT( img );
}

object WXEUAPI rescale(intptr_t image, int width, int height, int quality)
{
	wxImage * img = new wxImage( ((wxImage*)image)->Rescale(width, height, quality) );
	return BOX_INT( img );
}

object WXEUAPI resize(intptr_t image, object size, object pos)
{
	wxSize  s1 = wxSize( get_int(size, 1), get_int(size, 2) );
	wxPoint p1 = wxPoint( get_int(pos, 1), get_int(pos, 2) );
	wxDeRefDS( size );
	wxDeRefDS( pos );
	wxImage * img = new wxImage( ((wxImage*)image)->Resize(s1, p1) );
	return BOX_INT( img );
}

object WXEUAPI rotate(intptr_t image, object angle, object center, int interpolating, object offset)
{
	wxPoint rotationCentre = wxPoint( get_int(center, 1), get_int(center, 2) );
	wxPoint * offsetAfterRotation = NULL;
	if ( IS_SEQUENCE(offset) ) {
		offsetAfterRotation = new wxPoint( get_int(offset, 1), get_int(offset, 2) );
		wxDeRefDS( offset );
	}
	wxDeRefDS(angle);
	wxDeRefDS(center);
	wxImage * img = new wxImage( ((wxImage*)image)->Rotate(get_double(angle), rotationCentre, interpolating, offsetAfterRotation) );
	return BOX_INT( img );
}

object WXEUAPI rotate_90(intptr_t image, int clockwise)
{
	wxImage * img = new wxImage( ((wxImage*)image)->Rotate90(clockwise) );
	return BOX_INT( img );
}

object WXEUAPI  get_palette(intptr_t bmp)
{
	return BOX_INT( ((wxBitmap*)bmp)->GetPalette() );
}

object WXEUAPI  save_bitmap(intptr_t bmp, object name, int type, intptr_t palette)
{
	wxDeRefDS( name );
	return ((wxBitmap*)bmp)->SaveFile( get_string(name), (wxBitmapType)type, (wxPalette*)palette );
}

void WXEUAPI  set_option( intptr_t image, object name, object value )
{
	if ( IS_SEQUENCE(value) ) {
		((wxImage*)image)->SetOption( get_string(name), get_string(value) );
		wxDeRefDS( value );
	} else {
		((wxImage*)image)->SetOption( get_string(name), get_int(value) );
	}

	wxDeRefDS( name )

}

object WXEUAPI  get_option( intptr_t image, object name )
{
	wxDeRefDS( name );
	return get_sequence( ((wxImage*)image)->GetOption(get_string(name)) );
}

object WXEUAPI  get_option_int( intptr_t image, object name )
{
	wxDeRefDS( name );
	return BOX_INT( ((wxImage*)image)->GetOptionInt(get_string(name)) );
}

object WXEUAPI  has_option( intptr_t image, object name )
{
	wxDeRefDS( name );
	return ((wxImage*)image)->HasOption( get_string(name) );
}

void WXEUAPI  draw_label(intptr_t dc, object text, intptr_t bitmap, object rect, int alignment)
{
	wxDeRefDS( text );
	wxDeRefDS( rect );
	((wxDC*)dc)->DrawLabel( get_string(text), *((wxBitmap*)bitmap),
		wxRect(get_int(rect,1),get_int(rect,2),get_int(rect,3),get_int(rect,4)), alignment );
}

object WXEUAPI  get_font(intptr_t dc)
{
	return BOX_INT( &((wxDC*)dc)->GetFont() );
}

void WXEUAPI  draw_arc(intptr_t dc, int x1, int y1, int x2, int y2, int xc, int yc)
{
	((wxDC*)dc)->DrawArc( x1, y1, x2, y2, xc, yc );
}

void WXEUAPI  draw_check_mark(intptr_t dc, int x, int y, int width, int height)
{
	((wxDC*)dc)->DrawCheckMark( x, y, width, height );
}

void WXEUAPI  draw_circle(intptr_t dc, int x, int y, int radius)
{
	((wxDC*)dc)->DrawCircle( x, y, radius );
}

void WXEUAPI  draw_ellipse(intptr_t dc, int x, int y, int width, int height)
{
	((wxDC*)dc)->DrawEllipse( x, y, width, height );
}

void WXEUAPI  draw_elliptic_arc(intptr_t dc, int x, int y, int width, int height, object angle_start, object angle_end)
{
	wxDeRefDS( angle_start );
	wxDeRefDS( angle_end );

	((wxDC*)dc)->DrawEllipticArc( x, y, width, height, get_double(angle_start), get_double(angle_end) );
}

void WXEUAPI  draw_point(intptr_t dc, int x, int y)
{
	((wxDC*)dc)->DrawPoint( x, y );
}

void WXEUAPI  draw_rectangle(intptr_t dc, int x, int y, int width, int height)
{
	((wxDC*)dc)->DrawRectangle( x, y, width, height );
}

void WXEUAPI  draw_rounded_rectangle(intptr_t dc, int x, int y, int width, int height, object radius)
{
	wxDeRef( radius );
	((wxDC*)dc)->DrawRoundedRectangle( x, y, width, height, get_double(radius) );
}

void WXEUAPI  flood_fill(intptr_t dc, int x, int y, int color, int style)
{
	((wxDC*)dc)->FloodFill( x, y, *((wxColour*)get_int(color)), style );
}

void WXEUAPI  gradient_fill(intptr_t dc, object rect, int initialColor, int destColor, int nDirection)
{
	wxDeRefDS( rect );
	((wxDC*)dc)->GradientFillLinear(
		wxRect(get_int(rect,1),get_int(rect,2),get_int(rect,3),get_int(rect,4)),
		*((wxColour*)get_int(initialColor)), *((wxColour*)get_int(destColor)), (wxDirection)nDirection );
}

object WXEUAPI get_dc_gdk_window( intptr_t windowdc )
{
#ifdef WXEUMSW
	return 0;
#else
	return BOX_INT( reinterpret_cast<wxWindowDC*>( windowdc )->m_window );
#endif
}

object WXEUAPI get_default_font_encoding()
{
	return BOX_INT( wxFont::GetDefaultEncoding() );
}
#if wxUSE_GRAPHICS_CONTEXT
object WXEUAPI new_wxGraphicsMatrix( object params )
{
	wxDouble 
		a( 1.0 ), 
		b( 0.0 ), 
		c( 0.0 ), 
		d( 1.0 ), 
		tx( 0.0 ),
		ty( 0.0 );
	s1_ptr p = SEQ_PTR( params );
	switch( p->length ){
		case 6:
			ty = get_double( p->base[6] );
		case 5:
			tx = get_double( p->base[5] );
		case 4:
			d = get_double( p->base[4] );
		case 3:
			c = get_double( p->base[3] );
		case 2:
			b = get_double( p->base[2] );
		case 1:
			a = ty = get_double( p->base[1] );
		default:
			break;
	}
	wxGraphicsMatrix m = wxGraphicsRenderer::GetDefaultRenderer()->CreateMatrix( a, b, c, d, tx, ty );
	return BOX_INT( new wxGraphicsMatrix( m ) );
}

void WXEUAPI graphics_matrix_concat( intptr_t m1, intptr_t m2 )
{
	wxGraphicsMatrix *a = reinterpret_cast<wxGraphicsMatrix*>( m1 );
	wxGraphicsMatrix *b = reinterpret_cast<wxGraphicsMatrix*>( m2 );
	
	a->Concat( b );
}

object WXEUAPI graphics_matrix_get( intptr_t matrix )
{
	wxDouble a, b, c, d, tx, ty;
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Get( &a, &b, &c, &d, &tx, &ty );
	
	s1_ptr s = NewS1( 6 );
	s->base[1] = NewDouble( (eudouble) a );
	s->base[2] = NewDouble( (eudouble) b );
	s->base[3] = NewDouble( (eudouble) c );
	s->base[4] = NewDouble( (eudouble) d );
	s->base[5] = NewDouble( (eudouble) tx );
	s->base[6] = NewDouble( (eudouble) ty );
	return MAKE_SEQ( s );
}

object WXEUAPI graphics_matrix_get_native( intptr_t matrix )
{
	return BOX_INT( reinterpret_cast<wxGraphicsMatrix*>( matrix )->GetNativeMatrix() );
}

void WXEUAPI graphics_matrix_invert( intptr_t matrix )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Invert();
}

object WXEUAPI graphics_matrix_equal( intptr_t matrix, intptr_t other )
{
	return reinterpret_cast<wxGraphicsMatrix*>( matrix )->IsEqual( reinterpret_cast<wxGraphicsMatrix*>( other ) );
}

object WXEUAPI graphics_matrix_identity( intptr_t matrix )
{
	return reinterpret_cast<wxGraphicsMatrix*>( matrix )->IsIdentity();
}

void WXEUAPI graphics_matrix_rotate( intptr_t matrix, double angle )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Rotate( angle );
}

void WXEUAPI graphics_matrix_scale( intptr_t matrix, double x, double y )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Scale( x, y );
}

void WXEUAPI graphics_matrix_translate( intptr_t matrix, double x, double y )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Translate( x, y );
}

void WXEUAPI graphics_matrix_set( intptr_t matrix, double a, double b, double c, double d, double tx, double ty )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->Set( a, b, c, d, tx, ty );
}

object WXEUAPI graphics_matrix_transform_point( intptr_t matrix, double x, double y )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->TransformPoint( &x, &y );
	
	s1_ptr s = NewS1( 2 );
	s->base[1] = NewDouble( (eudouble) x );
	s->base[2] = NewDouble( (eudouble) y );
	return MAKE_SEQ( s );
}

object WXEUAPI graphics_matrix_transform_distance( intptr_t matrix, double dx, double dy )
{
	reinterpret_cast<wxGraphicsMatrix*>( matrix )->TransformDistance( &dx, &dy );
	s1_ptr s = NewS1( 2 );
	s->base[1] = NewDouble( (eudouble) dx );
	s->base[2] = NewDouble( (eudouble) dy );
	return MAKE_SEQ( s );
}

object WXEUAPI graphics_matrix_renderer( intptr_t matrix )
{
	return BOX_INT( reinterpret_cast<wxGraphicsMatrix*>( matrix )->GetRenderer() );
}


object WXEUAPI graphics_matrix_isnull( intptr_t matrix )
{
	return reinterpret_cast<wxGraphicsMatrix*>( matrix )->IsNull();
}

object WXEUAPI get_graphics_object_renderer( intptr_t graphics_object )
{
	return BOX_INT( reinterpret_cast<wxGraphicsObject*>( graphics_object )->GetRenderer() );
}

object WXEUAPI graphics_object_isnull( intptr_t graphics_object )
{
	return reinterpret_cast<wxGraphicsObject*>( graphics_object )->IsNull();
}

enum GRAPHICSCONTEXTFROM{
	DC,
	WINDOW,
	NATIVE_CONTEXT,
	NATIVE_WINDOW
};
object WXEUAPI new_wxGraphicsContext( object param )
{
	GRAPHICSCONTEXTFROM from = (GRAPHICSCONTEXTFROM) get_int( param, 1 );
	intptr_t ptr = get_int( param, 2 );
	wxGraphicsContext *context;
	switch( from ){
		case DC:
			context = wxGraphicsRenderer::GetDefaultRenderer()->CreateContext( *reinterpret_cast<wxWindowDC*>( ptr ) );
			break;
		case WINDOW:
			context = wxGraphicsRenderer::GetDefaultRenderer()->CreateContext( reinterpret_cast<wxWindow*>( ptr ) );
			break;
		case NATIVE_CONTEXT:
			context = wxGraphicsRenderer::GetDefaultRenderer()->CreateContextFromNativeContext( reinterpret_cast<void*>( ptr ) );
			break;
		case NATIVE_WINDOW:
			context = wxGraphicsRenderer::GetDefaultRenderer()->CreateContextFromNativeWindow( reinterpret_cast<void*>( ptr ) );
		default:
			EuApp::RTFatal("Unknown wxGraphicsContext create method");
	}
	wxDeRefDS( param );
	return BOX_INT( context );
}

object WXEUAPI new_wxGraphicsPen( object param )
{
	wxGraphicsContext *gc  = reinterpret_cast<wxGraphicsContext*>( get_int( param, 1 ) );
	wxPen             *pen = reinterpret_cast<wxPen*>( get_int( param, 2 ) );
	
	wxDeRefDS( param );
	
	return BOX_INT( new wxGraphicsPen( gc->CreatePen( *pen ) ) );
}

object WXEUAPI new_wxGraphicsBrush( object param )
{
	wxGraphicsContext *gc    = reinterpret_cast<wxGraphicsContext*>( get_int( param, 1 ) );
	wxBrush           *brush = reinterpret_cast<wxBrush*>( get_int( param, 2 ) );
	
	wxDeRefDS( param );
	
	return BOX_INT( new wxGraphicsBrush( gc->CreateBrush( *brush ) ) );
}

object WXEUAPI get_default_graphics_renderer()
{
	return BOX_INT( wxGraphicsRenderer::GetDefaultRenderer() );
}

object WXEUAPI create_linear_gradient_brush( intptr_t renderer, double x1, double y1, double x2, double y2, intptr_t c1, intptr_t c2 )
{
	wxGraphicsRenderer *gr = reinterpret_cast<wxGraphicsRenderer*>( renderer );
	wxGraphicsBrush brush = gr->CreateLinearGradientBrush( x1, y1, x2, y2, reinterpret_cast<wxColour&>( c1 ), reinterpret_cast<wxColour&>( c2 ) );
	return BOX_INT( new wxGraphicsBrush( brush ) );
}

object WXEUAPI create_radial_gradient_brush( intptr_t renderer, double xo, double yo, double xc, double yc, double radius, intptr_t o_color, intptr_t c_color )
{
	wxGraphicsRenderer *gr = reinterpret_cast<wxGraphicsRenderer*>( renderer );
	wxGraphicsBrush brush = gr->CreateRadialGradientBrush( xo, yo, xc, yc, radius,
										reinterpret_cast<wxColour&>( o_color ), reinterpret_cast<wxColour&>( c_color ) );
	return BOX_INT( new wxGraphicsBrush( brush ) );
}

object WXEUAPI create_graphics_font( intptr_t renderer, intptr_t font, intptr_t color )
{
	wxGraphicsFont gf = reinterpret_cast<wxGraphicsContext*>( renderer )->CreateFont( 
		reinterpret_cast<wxFont&>( font ), reinterpret_cast<wxColour&>( color ) );
	return BOX_INT( new wxGraphicsFont( gf ) );
}

object WXEUAPI new_wxGraphicsPath( object param )
{
	wxGraphicsPath path;
	switch( LENGTH( param ) ){
		case 1:
			path = reinterpret_cast<wxGraphicsRenderer*>( get_int( param, 1 ) )->CreatePath();
			break;
		default:
			path = wxGraphicsRenderer::GetDefaultRenderer()->CreatePath();
	}
	wxDeRefDS( param );
	return BOX_INT( new wxGraphicsPath( path ) );
}

void WXEUAPI path_move_to( intptr_t path, double x, double y )
{
	reinterpret_cast<wxGraphicsPath*>( path )->MoveToPoint( x, y );
}

void WXEUAPI path_add_arc( intptr_t path, double x, double y, double r, double start_angle, double end_angle, int clockwise )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddArc( x, y, r, start_angle, end_angle, clockwise );
}

void WXEUAPI path_add_arc_to_point( intptr_t path, double x1, double y1, double x2, double y2, double r )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddArcToPoint( x1, y1, x2, y2, r );
}

void WXEUAPI path_add_circle( intptr_t path, double x, double y, double r )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddCircle( x, y, r );
}

void WXEUAPI path_add_curve_to_point( intptr_t path, double cx1, double cy1, double cx2, double cy2, double x, double y )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddCurveToPoint( cx1, cy1, cx2, cy2, x, y );
}

void WXEUAPI path_add_ellipse( intptr_t path, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddEllipse( x, y, w, h );
}

void WXEUAPI path_add_line_to_point( intptr_t path, double x, double y )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddLineToPoint( x, y );
}

void WXEUAPI path_add( intptr_t path, intptr_t path_to_add )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddPath( reinterpret_cast<wxGraphicsPath&>( path_to_add ) );
}

void WXEUAPI path_add_quad_curve_to_point( intptr_t path, double cx, double cy, double x, double y )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddQuadCurveToPoint( cx, cy, x, y );
}

void WXEUAPI path_add_rectangle( intptr_t path, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddRectangle( x, y, w, h );
}

void WXEUAPI path_add_rounded_rectangle( intptr_t path, double x, double y, double w, double h, double radius )
{
	reinterpret_cast<wxGraphicsPath*>( path )->AddRoundedRectangle( x, y, w, h, radius );
}

void WXEUAPI path_close_subpath( intptr_t path )
{
	reinterpret_cast<wxGraphicsPath*>( path )->CloseSubpath();
}

object WXEUAPI path_contains( intptr_t path, double x, double y, int fill_style )
{
	return reinterpret_cast<wxGraphicsPath*>( path )->Contains( x, y, fill_style );
}

object WXEUAPI path_get_box( intptr_t path )
{
	wxDouble x, y, w, h;
	reinterpret_cast<wxGraphicsPath*>( path )->GetBox( &x, &y, &w, &h );
	
	s1_ptr box = NewS1( 4 );
	box->base[1] = NewDouble( (eudouble) x );
	box->base[2] = NewDouble( (eudouble) y );
	box->base[3] = NewDouble( (eudouble) w );
	box->base[4] = NewDouble( (eudouble) h );
	return MAKE_SEQ( box );
}

object WXEUAPI path_get_current_point( intptr_t path )
{
	wxDouble x, y;
	reinterpret_cast<wxGraphicsPath*>( path )->GetCurrentPoint( &x, &y );
	
	s1_ptr point = NewS1( 2 );
	point->base[1] = NewDouble( (eudouble) x );
	point->base[2] = NewDouble( (eudouble) y );
	return MAKE_SEQ( point );
}

object WXEUAPI path_transform( intptr_t path, intptr_t matrix )
{
	reinterpret_cast<wxGraphicsPath*>( path )->Transform( *reinterpret_cast<wxGraphicsMatrix*>( matrix ) );
}

object WXEUAPI path_get_native( intptr_t path )
{
	return BOX_INT( reinterpret_cast<wxGraphicsPath*>( path )->GetNativePath() );
}

object WXEUAPI path_unget_native_path( intptr_t path, intptr_t native )
{
	reinterpret_cast<wxGraphicsPath*>( path )->UnGetNativePath( reinterpret_cast<void*>( native ) );
}

void WXEUAPI gc_clip( intptr_t context, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsContext*>( context )->Clip( x, y, w, h );
}

void WXEUAPI gc_reset_clip( intptr_t context )
{
	reinterpret_cast<wxGraphicsContext*>( context )->ResetClip();
}

void WXEUAPI gc_draw_bitmap( intptr_t context, intptr_t bmp, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawBitmap( 
					*reinterpret_cast<wxBitmap*>( bmp ), x, y, w, h );
}

void WXEUAPI gc_draw_ellipse( intptr_t context, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawEllipse( x, y, w, h );
}

void WXEUAPI gc_draw_icon( intptr_t context, intptr_t icon, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawIcon( *reinterpret_cast<wxIcon*>( icon ), x, y, w, h );
}

void gc_draw_lines( intptr_t context, object points, int fill_style )
{
	s1_ptr points_s1 = SEQ_PTR( points );
	size_t n = LENGTH( points );
	wxPoint2DDouble *pts = new wxPoint2DDouble[n];
	
	for( size_t i = 0; i < n; ++i ){
		object eu_point = points_s1->base[i+1];
		pts[i] = wxPoint2DDouble( get_double( eu_point, 1 ), get_double( eu_point, 2 ) );
	}
	wxDeRefDS( points );
	reinterpret_cast<wxGraphicsContext*>( context )->DrawLines( n, pts, fill_style );
	delete[] pts;
}

void WXEUAPI gc_draw_path( intptr_t context, intptr_t path, int fill_style )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawPath( *reinterpret_cast<wxGraphicsPath*>( path ), fill_style );
}

void WXEUAPI gc_draw_rectangle( intptr_t context, double x, double y, double w, double h )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawRectangle( x, y, w, h );
}

void WXEUAPI gc_draw_rounded_rectangle( intptr_t context, double x, double y, double w, double h, double radius )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawRoundedRectangle( x, y, w, h, radius );
}

void WXEUAPI gc_draw_text( intptr_t context, object str, double x, double y, double angle )
{
	reinterpret_cast<wxGraphicsContext*>( context )->DrawText( get_string( str ), x, y, angle );
}

void WXEUAPI gc_fill_path( intptr_t context, intptr_t path, int fill_style )
{
	reinterpret_cast<wxGraphicsContext*>( context )->FillPath( *reinterpret_cast<wxGraphicsPath*>( path ), fill_style );
}

void WXEUAPI gc_stroke_path( intptr_t context, intptr_t path )
{
	reinterpret_cast<wxGraphicsContext*>( context )->StrokePath( *reinterpret_cast<wxGraphicsPath*>( path ) );
}

object WXEUAPI gc_get_native_context( intptr_t context )
{
	return BOX_INT( reinterpret_cast<wxGraphicsContext*>( context )->GetNativeContext() );
}

object WXEUAPI gc_get_partial_text_extents( intptr_t context, object text )
{
	wxArrayDouble widths;
	reinterpret_cast<wxGraphicsContext*>( context )->GetPartialTextExtents( get_string( text ), widths );
	wxDeRefDS( text );
	size_t n = widths.GetCount();
	s1_ptr swidths = NewS1( n );
	for( size_t i = 0; i < n; ++i ){
		swidths->base[i+1] = NewDouble( (eudouble) widths[i] );
	}
	return MAKE_SEQ( swidths );
}

object WXEUAPI gc_get_text_extent( intptr_t context, object text )
{
	wxDouble width, height, descent, external_leading;
	reinterpret_cast<wxGraphicsContext*>( context )->GetTextExtent( get_string( text ), &width, &height, &descent, &external_leading );
	wxDeRefDS( text );
	
	s1_ptr extent = NewS1( 4 );
	extent->base[1] = NewDouble( (eudouble) width );
	extent->base[2] = NewDouble( (eudouble) height );
	extent->base[3] = NewDouble( (eudouble) descent );
	extent->base[4] = NewDouble( (eudouble) external_leading );
	return MAKE_SEQ( extent );
}

void WXEUAPI gc_rotate( intptr_t context, double angle )
{
	reinterpret_cast<wxGraphicsContext*>( context )->Rotate( angle );
}

void WXEUAPI gc_scale( intptr_t context, double x_scale, double y_scale )
{
	reinterpret_cast<wxGraphicsContext*>( context )->Scale( x_scale, y_scale );
}

void WXEUAPI gc_translate( intptr_t context, double dx, double dy )
{
	reinterpret_cast<wxGraphicsContext*>( context )->Translate( dx, dy );
}

object WXEUAPI gc_get_transform( intptr_t context )
{
	return BOX_INT( new wxGraphicsMatrix( reinterpret_cast<wxGraphicsContext*>( context )->GetTransform() ) );
}

void WXEUAPI gc_set_transform( intptr_t context, intptr_t matrix )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetTransform( *reinterpret_cast<wxGraphicsMatrix*>( matrix ) );
}

void WXEUAPI gc_concat_transform( intptr_t context, intptr_t matrix )
{
	reinterpret_cast<wxGraphicsContext*>( context )->ConcatTransform( *reinterpret_cast<wxGraphicsMatrix*>( matrix ) );
}

void WXEUAPI gc_set_brush( intptr_t context, intptr_t brush )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetBrush( *reinterpret_cast<wxBrush*>( brush ) );
}

void WXEUAPI gc_set_graphics_brush( intptr_t context, intptr_t brush )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetBrush( *reinterpret_cast<wxGraphicsBrush*>( brush ) );
}

void WXEUAPI gc_set_font( intptr_t context, intptr_t font, intptr_t color )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetFont( *reinterpret_cast<wxFont*>( font ), *reinterpret_cast<wxColour*>( color ) );
}

void WXEUAPI gc_set_graphics_font( intptr_t context, intptr_t font )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetFont( *reinterpret_cast<wxGraphicsFont*>( font ) );
}

void WXEUAPI gc_set_pen( intptr_t context, intptr_t pen )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetPen( *reinterpret_cast<wxPen*>( pen ) );
}

void WXEUAPI gc_set_graphics_pen( intptr_t context, intptr_t pen )
{
	reinterpret_cast<wxGraphicsContext*>( context )->SetPen( *reinterpret_cast<wxGraphicsPen*>( pen ) );
}

void WXEUAPI gc_stroke_line( intptr_t context, double x1, double y1, double x2, double y2 )
{
	reinterpret_cast<wxGraphicsContext*>( context )->StrokeLine( x1, y1, x2, y2 );
}

void WXEUAPI gc_stroke_lines( intptr_t context, object points )
{
	s1_ptr ps1 = SEQ_PTR( points );
	size_t n = LENGTH( points );
	wxPoint2DDouble *points2d = new wxPoint2DDouble[n];
	for( size_t i = 0; i < n; ++i ){
		object eu_pt = ps1->base[i+1];
		points2d[i] = wxPoint2DDouble( get_double( eu_pt, 1 ), get_double( eu_pt, 2 ) );
	}
	wxDeRefDS( points );
	reinterpret_cast<wxGraphicsContext*>( context )->StrokeLines( n, points2d );
}



#endif // wxUSE_GRAPHICS_CONTEXT

}
