// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/html/htmlwin.h"
#include "wx/filename.h"
#include "wx/html/htmlcell.h"
#include "wx/html/htmprint.h"

extern "C"{

/* -- DEPRECIATED! --

typedef object WXEUAPI (*euOnLinkClicked)(const wxHtmlWindow&,const wxHtmlLinkInfo&,int);
typedef object WXEUAPI (*euOnOpeningURL)(const wxHtmlWindow&,wxHtmlURLType,int);

class euHtmlWindow : public wxHtmlWindow
{
	public:
		euHtmlWindow(wxWindow *parent, 
					 wxWindowID id = -1, 
					 const wxPoint& pos = wxDefaultPosition, 
					 const wxSize& size = wxDefaultSize, 
					 intptr_t style = wxHW_DEFAULT_STYLE, 
					 const wxString& name = wxT("htmlWindow"))
		: wxHtmlWindow(parent, id, pos, size, style, name)
		{
			_link = NULL;
			_url = NULL;
		}
		
		//virtual void OnLinkClicked(const wxHtmlLinkInfo& link );
		//virtual wxHtmlOpeningStatus OnOpeningURL(wxHtmlURLType type,const wxString& url, wxString *redirect);
		
		euOnLinkClicked _link;
		intptr_t link_rid;
		
		euOnOpeningURL _url;
		int url_rid;

};
*/

object WXEUAPI  new_wxHtmlWindow(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxHtmlWindow, wxHW_SCROLLBAR_AUTO );
}

void WXEUAPI  set_link_event(intptr_t htmlwin, int rid, int cb)
{ /*
	((euHtmlWindow*)htmlwin)->link_rid = rid;
	((euHtmlWindow*)htmlwin)->_link = (euOnLinkClicked) cb;
  */
}

void WXEUAPI  set_open_url_event(intptr_t htmlwin, int rid, int cb )
{ /*
	((euHtmlWindow*)htmlwin)->url_rid = rid;
	((euHtmlWindow*)htmlwin)->_url = (euOnOpeningURL) cb;
  */
}

void WXEUAPI  load_html_file(intptr_t htmlwin, object file)
{
	wxFileName fn( get_string( file ) );
	((wxHtmlWindow*)htmlwin)->LoadFile( fn );
	wxDeRefDS( file );
}

void WXEUAPI  load_html_page(intptr_t htmlwin, object page)
{
	((wxHtmlWindow*)htmlwin)->LoadPage( get_string( page ) );
	wxDeRefDS( page );
}

void WXEUAPI  set_html_page(intptr_t htmlwin, object source)
{
	((wxHtmlWindow*)htmlwin)->SetPage( get_string( source ) );
	wxDeRefDS( source );
}

void WXEUAPI  html_back(intptr_t htmlwin)
{
	((wxHtmlWindow*)htmlwin)->HistoryBack();
}

void WXEUAPI  html_forward(intptr_t htmlwin)
{
	((wxHtmlWindow*)htmlwin)->HistoryForward();
}

void WXEUAPI  html_append(intptr_t htmlwin, object source)
{
	((wxHtmlWindow*)htmlwin)->AppendToPage( get_string( source ) );
	wxDeRefDS( source );
}

object WXEUAPI  get_link_href(intptr_t link)
{
	return get_sequence( ((wxHtmlLinkInfo*)link)->GetHref() );
}

object WXEUAPI  get_link_target(intptr_t link)
{
	return get_sequence( ((wxHtmlLinkInfo*)link)->GetTarget() );
}


void WXEUAPI  set_related_frame(intptr_t htmlwin, intptr_t frame, object format, int status_slot)
{
	((wxHtmlWindow*)htmlwin)->SetRelatedFrame( (wxFrame*)frame, get_string(format));
	((wxHtmlWindow*)htmlwin)->SetRelatedStatusBar( status_slot);
	wxDeRefDS( format );
}

object WXEUAPI  get_html_page_title(intptr_t htmlwin)
{
	return get_sequence( ((wxHtmlWindow*)htmlwin)->GetOpenedPageTitle());
}

void WXEUAPI  clear_html_history(intptr_t htmlwin)
{
	((wxHtmlWindow*)htmlwin)->HistoryClear();
}

object WXEUAPI  get_html_anchor(intptr_t htmlwin)
{
	return get_sequence( ((wxHtmlWindow*)htmlwin)->GetOpenedAnchor() );
}

object WXEUAPI  get_html_page(intptr_t htmlwin)
{
	return get_sequence( ((wxHtmlWindow*)htmlwin)->GetOpenedPage() );
}

void WXEUAPI launch_default_browser( object url )
{
	wxLaunchDefaultBrowser( get_string( url ) );
	wxDeRefDS( url );
}

object WXEUAPI get_link_event_info( intptr_t event )
{
	wxHtmlLinkInfo * info = new wxHtmlLinkInfo( ((wxHtmlLinkEvent*)event)->GetLinkInfo() );
	return BOX_INT( info );
}

object WXEUAPI selection_to_text(intptr_t htmlwin)
{
	return get_sequence( ((wxHtmlWindow*)htmlwin)->SelectionToText() );
}

object WXEUAPI new_wxHtmlEasyPrinting( object params )
{
	wxDeRefDS( params );
	wxString name = wxT("Printing");
	wxWindow * parentWindow = 0;
	switch( LENGTH( params ) ){
	case 2:
		name = get_string( params, 1 );
	case 1:
		parentWindow = (wxWindow*)get_int( params, 2 );
	default:
		return BOX_INT( new wxHtmlEasyPrinting( name, parentWindow ) );
	}
}

object WXEUAPI get_html_easy_printing_parent( intptr_t easy )
{
	return BOX_INT( ((wxHtmlEasyPrinting*)easy)->GetParentWindow() );
}

object WXEUAPI get_html_easy_print_data( intptr_t easy )
{
	return BOX_INT( ((wxHtmlEasyPrinting*)easy)->GetPrintData() );
}

object WXEUAPI get_html_easy_print_setup( intptr_t easy )
{
	return BOX_INT( ((wxHtmlEasyPrinting*)easy)->GetPageSetupData() );
}

object WXEUAPI get_html_easy_print_preview_file( intptr_t easy, object html_file )
{
	wxDeRefDS( html_file );
	return 1 & ((wxHtmlEasyPrinting*)easy)->PreviewFile( get_string( html_file ) );
}

object WXEUAPI get_html_easy_print_preview_text( intptr_t easy, object html_text, object base_path )
{
	wxDeRefDS( html_text );
	wxDeRefDS( base_path );
	return 1 & ((wxHtmlEasyPrinting*)easy)->PreviewText( get_string( html_text ), get_string( base_path ) );
}

object WXEUAPI print_html_file( intptr_t easy, object html_file )
{
	wxDeRefDS( html_file );
	return 1 & ((wxHtmlEasyPrinting*)easy)->PrintFile( get_string( html_file ) );
}

object WXEUAPI print_html_text( intptr_t easy, object html_text, object base_path )
{
	wxDeRefDS( html_text );
	wxDeRefDS( base_path );
	return 1 & ((wxHtmlEasyPrinting*)easy)->PrintText( get_string( html_text ), get_string( base_path ) );
}

void WXEUAPI html_easy_page_setup( intptr_t easy )
{
	((wxHtmlEasyPrinting*)easy)->PageSetup();
}

void WXEUAPI html_easy_fonts( intptr_t easy, object normal_face, object fixed_face, object font_size )
{
	int sizes[7];
	wxDeRefDS( normal_face );
	wxDeRefDS( fixed_face );
	wxDeRefDS( font_size );
	if( LENGTH(font_size) != 7 ){
		wxString msg;
		msg.Printf( wxT("Expected 7 font sizes.  Received %d."), LENGTH(font_size) );
		s1_ptr s = NewS1( 1 );
		s->base[1] = get_sequence( msg );
		EuApp::proc( EuApp::error_rid, MAKE_SEQ( s ) );
	}
	
	for(int i = 0;i < 7;i++)
		sizes[i] = get_int( font_size, i + 1 );
	
	((wxHtmlEasyPrinting*)easy)->SetFonts( get_string( normal_face ), get_string( fixed_face ), sizes );
}

void WXEUAPI html_easy_header( intptr_t easy, object header, int pg )
{
	wxDeRefDS( header );
	((wxHtmlEasyPrinting*)easy)->SetHeader( get_string( header ), pg );
}

void WXEUAPI html_easy_footer( intptr_t easy, object footer, int pg )
{
	wxDeRefDS( footer );
	((wxHtmlEasyPrinting*)easy)->SetFooter( get_string( footer ), pg );
}

void WXEUAPI html_easy_parent( intptr_t easy, intptr_t window )
{
	((wxHtmlEasyPrinting*)easy)->SetParentWindow( (wxWindow*) window );
}

}
