// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/listctrl.h"
#include <wx/bmpcbox.h>

extern "C"{
object WXEUAPI  new_wxListBox(object params)
{
/*
--wxListBox(
--1  1  wxWindow* parent, 
--2  2  wxWindowID id, 
--34 3  const wxPoint& pos = wxDefaultPosition, 
--56 4  const wxSize& size = wxDefaultSize, 
--   5  int n, 
--7  6  const wxString choices[] = NULL, 
--8  7  intptr_t style = 0, 
--9  8  const wxValidator& validator = wxDefaultValidator, 
--10 9  const wxString& name = "listBox")
*/

	s1_ptr p = SEQ_PTR( params );
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	int n = 0;
	wxString * choices = NULL;
	wxListBox * list = NULL;
	intptr_t style = 0;
	object c;
	wxWindowID id = -1;
	
	switch( p->length ){
		case 8:
			style = get_int( params, 8 );
		
			
		case 7:
			c = p->base[7];
			n = ((s1_ptr)SEQ_PTR(c))->length;
			choices = new wxString[n];
			
			for( int i = 0; i < n; i++ ){
				choices[i] = get_string( c, i + 1 );
			}

		case 6:
			size = wxSize( get_int( params, 5 ), get_int( params, 6 ) );

		case 5:
		case 4:
			pos = wxPoint( get_int( params, 3 ), get_int( params, 4 ) );

		case 3:
		case 2:
			id = get_int( params, 2); 
		default:
			list = new wxListBox( (wxWindow *) get_int( params, 1 ),
				id, 
				pos, size, n, choices, style );

			break;
	}
	wxDeRefDS( params );
	return BOX_INT(list);
}

void WXEUAPI  insert_item(intptr_t list, int position, object text)
{

	if( ((wxObject*)list)->IsKindOf(CLASSINFO( wxBitmapComboBox ))  ){
		( (wxBitmapComboBox*)list)->Insert( get_string( text, 1 ), *((wxBitmap *) get_int( text, 2 )), position );

	} 
	else {
		int len = LENGTH( text );
		wxArrayString array = wxArrayString();
		s1_ptr s;
		if( len == 0 ){
			s = NewS1(1);
			s->base[1] = text;
		}
		else if( !IS_SEQUENCE(((s1_ptr)SEQ_PTR(text))->base[1]) ){
			s = NewS1(1);
			s->base[1] = text;
		}
		else{
			s = SEQ_PTR( text );
		}
		text = MAKE_SEQ( s );
		for( int i = 0; i < s->length; i++){
			array.Add( get_string( text, i+1 ) );
		}
		
		((wxListBox*)list)->InsertItems( array, position );
	}
	wxDeRefDS( text );
	
}

void WXEUAPI  add_item(intptr_t list, object text)
{
	int type;
	if( ((wxObject*)list)->IsKindOf(CLASSINFO( wxChoice )) ){
		type = 1;
	}
	else if( ((wxObject*)list)->IsKindOf(CLASSINFO( wxBitmapComboBox ))  ){
		type = 2;
	}
	else if( ((wxObject*)list)->IsKindOf(CLASSINFO( wxComboBox ))  ){
		type = 3;
	}
	else {
		type = 4;
	}

	int len = LENGTH( text );
	s1_ptr s;
	object seqTmp;
	wxBitmap *b;
	bool delS = false;
	
	// text will always be a sequence if type == 2
	if (type != 2) {
		if( len == 0 ){
			s = NewS1(1);
			s->base[1] = text;
			len = 1;
			delS = true;
		}
		else if( !IS_SEQUENCE(((s1_ptr)SEQ_PTR(text))->base[1]) ){
			s = NewS1(1);
			s->base[1] = text;
			len = 1;
			delS = true;
		}
		else{
			s = SEQ_PTR( text );
		}
		text = MAKE_SEQ( s );
	} else {
		if( (len == 2) && (!IS_SEQUENCE(((s1_ptr)SEQ_PTR(text))->base[1]) ) ){
			s = NewS1(1);
			s->base[1] = text;
			len = 1;
			delS = true;
			text = MAKE_SEQ( s );
		}
	}
	
	for( int i = 0; i < len; i++){
		switch( type ){
			case 1:
				((wxChoice*)list)->Append( get_string( text, i+1 ) );
				break;
			case 2:
				seqTmp = ((s1_ptr)SEQ_PTR(text))->base[i+1];
				((wxBitmapComboBox*)list)->Append( get_string( seqTmp, 1 ), *((wxBitmap *) get_int( seqTmp, 2 )) );
				break;
			case 3:
				((wxComboBox*)list)->Append( get_string( text, i+1 ) );
				break;
			case 4:
				((wxListBox*)list)->Append( get_string( text, i+1 ) );
				break;
			default:
				break;
		}
	}
	
	wxDeRefDS( text );
	if( delS ) free(s);
}

object WXEUAPI  get_selection(intptr_t control)
{

	wxObject * obj = (wxObject*)control;
	if( obj->IsKindOf( CLASSINFO( wxListBox ) )){
		//return ((wxListBox*)control)->GetSelection();
		
		wxListBox * list = ((wxListBox*)control);
		wxArrayInt ai;
		int count = list->GetSelections( ai );
		s1_ptr sel = NewS1( count );
		
		for( int i = 1; i <= count; i++ ){
			sel->base[i] = ai[i-1];
		}
		return MAKE_SEQ( sel );
	}
	else if( obj->IsKindOf( CLASSINFO( wxListCtrl ) ) ){
		wxListCtrl * list = ((wxListCtrl*)control);
		int count = list->GetSelectedItemCount();
		s1_ptr sel = NewS1( count );
		intptr_t item = -1;
		for( int i = 1; i <= count; i++ ){
			item = list->GetNextItem( item, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
			sel->base[i] = item;
		}
		return MAKE_SEQ( sel );
	}
	else if( obj->IsKindOf( CLASSINFO( wxComboBox ) ) ){
		return ((wxComboBox*)control)->GetSelection();
	}
	else if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) ) ){
		return ((wxBitmapComboBox*)control)->GetSelection();
	}
	else if( obj->IsKindOf( CLASSINFO( wxMultiChoiceDialog ) ) ){
	
		wxMultiChoiceDialog * list = ((wxMultiChoiceDialog*)control);
		wxArrayInt ai = list->GetSelections();
		int count = ai.GetCount();
		s1_ptr sel = NewS1( count );

		for( int i = 1; i <= count; i++ ){
			sel->base[i] = ai[i-1];
		}
		return MAKE_SEQ( sel );
	}
	else if( obj->IsKindOf( CLASSINFO( wxSingleChoiceDialog ) ) ){

		wxSingleChoiceDialog * list = ((wxSingleChoiceDialog*)control);
		return list->GetSelection();
	}
	else{
		return ((wxChoice*)control)->GetSelection();
	}
	return 0;
}

object WXEUAPI  list_count(intptr_t list)
{
	wxObject * obj = (wxObject*)list;
	if( obj->IsKindOf( CLASSINFO( wxListBox ) )){
		return ((wxListBox*)list)->GetCount();
	}
	else if( obj->IsKindOf( CLASSINFO( wxListCtrl ) ) ){
		return ((wxListCtrl*)list)->GetItemCount();
	} else {
		return -1;
	}

//	return ((wxListBox*)list)->GetCount();
}

object WXEUAPI  choice_count(intptr_t choice)
{
	return ((wxChoice*)choice)->GetCount();
}

object WXEUAPI  combobox_count(intptr_t combobox)
{
	wxObject * obj = (wxObject*)combobox;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		return ((wxBitmapComboBox*)combobox)->GetCount();
	}
	else {
		return ((wxComboBox*)combobox)->GetCount();
	}
}

object WXEUAPI  get_list_string(intptr_t list, intptr_t item)
{

	if( ((wxObject*)list)->IsKindOf(CLASSINFO(wxListCtrl) ) ){
		return get_sequence( ((wxListCtrl*)list)->GetItemText( item ) );
	}
	else{
		return get_sequence( ((wxListBox*)list)->GetString( item ) );
	}
	return 0;
}

object WXEUAPI  get_string_selection(intptr_t control)
{
	wxObject * obj = (wxObject*)control;
	if( obj->IsKindOf( CLASSINFO( wxChoice ) )){
		return get_sequence(((wxChoice*)control)->GetStringSelection());
	}
	else if( obj->IsKindOf( CLASSINFO( wxComboBox ) )){
		return get_sequence(((wxComboBox*)control)->GetStringSelection());
	}
	else if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		return get_sequence(((wxBitmapComboBox*)control)->GetStringSelection());
	}
	else if( obj->IsKindOf( CLASSINFO( wxListBox ) )){
		return get_sequence(((wxListBox*)control)->GetStringSelection());
	}
	return 0;
}

object WXEUAPI  get_combo_string(intptr_t combo)
{
	wxObject * obj = (wxObject*)combo;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		return get_sequence( ((wxBitmapComboBox*)combo)->GetValue() );
	} 
	else {
		return get_sequence( ((wxComboBox*)combo)->GetValue() );
	}
}

object WXEUAPI  get_combo_item_string(intptr_t combo, intptr_t item)
{
	wxObject * obj = (wxObject*)combo;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		return get_sequence( ((wxBitmapComboBox*)combo)->GetString( item ) );
	}
	else {
		return get_sequence( ((wxComboBox*)combo)->GetString( item ) );
	}
}

object WXEUAPI  new_wxComboBox(object params)
{
/*
--1/li atom parent
--2/li integer id [=-1]
--3/li sequence value [=""]
--4/li integer x [=-1]
--5/li integer y [=-1]
--6/li integer cx [=-1]
--7/li integer cy [=-1]
--8/li sequence choices  [={}]
--9/li atom style [=0]
*/

	s1_ptr p = SEQ_PTR( params );
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	int n = 0;
	wxString * choices = NULL;
	wxComboBox * combo = NULL;
	intptr_t style = 0;
	wxString value(wxT(""));
	object c;
	wxWindowID id = -1;
	
	switch( p->length ){
		case 9:
			style = get_int( params, 9 );

		case 8:
			c = p->base[8];
			n = ((s1_ptr)SEQ_PTR(c))->length;
			choices = new wxString[n];
			for( int i = 0; i < n; i++ ){
				choices[i] = get_string( c, i + 1 );
			}

		case 7:
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );

		case 6:
		case 5:
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5 ) );

		case 4:
		case 3:
			value = get_string( params, 3 );
		case 2:
			id = -1;
		default:
			combo = new wxComboBox( (wxWindow *) get_int( params, 1 ),
				id, value,
				pos, size, n, choices, style );
			break;
	}
	wxDeRefDS( params );
	return BOX_INT(combo);
}

object WXEUAPI  new_wxChoice(object params)
{
/*
--1 wxChoice(wxWindow *parent, 
--2 wxWindowID id, 
--34 const wxPoint& pos, 
--56 const wxSize& size, 
--int n, 
--7 const wxString choices[], 
--8 intptr_t style = 0, 
--const wxValidator& validator = wxDefaultValidator, 
--const wxString& name = "choice")
*/

	s1_ptr p = SEQ_PTR( params );
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	int n = 0;
	wxString * choices;
	wxChoice * choice = NULL;
	wxWindowID id = -1;
	intptr_t style = 0;
	object c;
	
	switch( p->length ){
		case 8:

			style = get_int( params, 8 );
		
			
		case 7:

			c = p->base[7];
			n = ((s1_ptr)SEQ_PTR(c))->length;

			choices = new wxString[n];
			for( int i = 0; i < n; i++ ){
				choices[i] =  get_string( c, i + 1 );
			}
		
		case 6:

			size = wxSize( get_int( params, 5 ), get_int( params, 6 ) );
		
		case 5:
		case 4:

			pos = wxPoint( get_int( params, 3 ), get_int( params, 4 ) );
		
		case 3:
		case 2:
			id = get_int( params, 2 );
		default:

			choice = new wxChoice( (wxWindow *) get_int( params, 1 ),
				id, pos, size, n, choices, style );
			break;
	}
	wxDeRefDS( params );
	return BOX_INT(choice);
	
}

void WXEUAPI  clear_items(intptr_t control)
{
	wxObject * obj = (wxObject*) control;
	if( obj->IsKindOf(CLASSINFO(wxListBox)) ){
		((wxListBox*)control)->Clear();
	}
	else if( obj->IsKindOf(CLASSINFO(wxListCtrl)) ){
		((wxListCtrl*)control)->DeleteAllItems();
	}
	else if( obj->IsKindOf(CLASSINFO(wxComboBox)) ){
		((wxComboBox*)control)->Clear();
	}
	else if( obj->IsKindOf(CLASSINFO(wxBitmapComboBox)) ){
		((wxBitmapComboBox*)control)->Clear();
	}
	else{
		((wxChoice*)control)->Clear();
	}
}

void WXEUAPI  clear_list(intptr_t list)
{
	((wxListBox*)list)->Clear();
}

void WXEUAPI  clear_choice(intptr_t choice)
{
	((wxChoice*)choice)->Clear();
}

void WXEUAPI  clear_combo(intptr_t combo)
{
	wxObject * obj = (wxObject*)combo;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		((wxBitmapComboBox*)combo)->Clear();
	}
	else {
		((wxComboBox*)combo)->Clear();
	}

}

void WXEUAPI  set_combo_value(intptr_t combo, object text)
{

	wxObject * obj = (wxObject*)combo;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		((wxBitmapComboBox*)combo)->SetValue( get_string( text ) );
	}
	else {
		((wxComboBox*)combo)->SetValue( get_string( text ) );
	}
	wxDeRefDS( text );
}

void WXEUAPI  set_choice(intptr_t choice, object text)
{

	((wxChoice*)choice)->SetStringSelection( get_string( text ) );
	wxDeRefDS(text);
}

object WXEUAPI  find_list_string(intptr_t list, object string)
{
	wxDeRefDS(string);
	return ((wxListBox*)list)->FindString( get_string( string ) );
}

object WXEUAPI  find_choice_string(intptr_t choice, object string)
{
	wxDeRefDS(string);
	return ((wxChoice*)choice)->FindString( get_string( string ) );
}

object WXEUAPI  find_combo_string(intptr_t combo, object string)
{
	wxDeRefDS(string);
	
	wxObject * obj = (wxObject*)combo;

	if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) )){
		return   ((wxBitmapComboBox*)combo)->FindString( get_string( string ) );
	}
	else {
		return  ((wxComboBox*)combo)->FindString( get_string( string ) );
	} 

}

object WXEUAPI  find_string(intptr_t control, object string)
{
	wxObject* obj = (wxObject*)control;
	if( obj->IsKindOf( CLASSINFO( wxListBox ) ) ){
		return find_list_string( control, string );
	}
	else{
		return find_choice_string( control, string );
	}
}

void WXEUAPI  set_list_selection(intptr_t list, object select)
{
	if( IS_SEQUENCE( select ) ){
		select = find_list_string( list, select );
	}
	((wxListBox*)list)->SetSelection( select );
	
}

void WXEUAPI  delete_list_item(intptr_t list, object item)
{
	if( IS_SEQUENCE( item ) ){
		item = find_list_string( list, item );
	}
	
	((wxListBox*)list)->Delete( item );
}

void WXEUAPI  delete_combo_item(intptr_t combo, intptr_t item)
{
	if( ((wxObject*)combo)->IsKindOf( CLASSINFO( wxChoice ) ) ){
		((wxChoice*)combo)->Delete( item );
	}
	else if( ((wxObject*)combo)->IsKindOf( CLASSINFO( wxBitmapComboBox ) ) ){
		((wxBitmapComboBox*)combo)->Delete( item );
	}
	else{
		((wxComboBox*)combo)->Delete( item );
	}
}

void WXEUAPI  delete_item(intptr_t control, intptr_t item)
{
	wxObject * obj = (wxObject*) control;
	if( obj->IsKindOf( CLASSINFO( wxListCtrl ) ) ){
		((wxListCtrl*)control)->DeleteItem( item );
	}
	else if( obj->IsKindOf( CLASSINFO( wxListBox ) ) ){
		((wxListBox*)control)->Delete( item );
	}
	else{
		delete_combo_item( control, item );
	}
}

void WXEUAPI  set_selection(intptr_t control, object item)
{

	wxObject * obj = (wxObject*) control;
	if( obj->IsKindOf( CLASSINFO( wxListBox ) ) ){
		//((wxListBox*)control)->SetSelection(item);
		if ( IS_SEQUENCE(item) && get_int( item, 2 ) == -1 ) {
			((wxListBox*)control)->Deselect( get_int(item, 1) );
		}
		else {
			((wxListBox*)control)->SetSelection(item);
		}
	}
	else if( obj->IsKindOf( CLASSINFO( wxListCtrl ) ) ){
		if(IS_SEQUENCE(item))
			((wxListCtrl*)control)->SetItemState( get_int(item,1), 0, 
				wxLIST_STATE_SELECTED | wxLIST_STATE_FOCUSED );
		
			((wxListCtrl*)control)->SetItemState( item, wxLIST_STATE_SELECTED | wxLIST_STATE_FOCUSED,
				wxLIST_STATE_SELECTED | wxLIST_STATE_FOCUSED );
	}

	else if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) ) ){
		((wxBitmapComboBox*)control)->SetSelection( item );
	}

	else if( obj->IsKindOf( CLASSINFO( wxComboBox ) ) ){
		((wxComboBox*)control)->SetSelection( item );
	}

	else if( obj->IsKindOf( CLASSINFO( wxMultiChoiceDialog ) ) ){
		wxArrayInt * ai = new wxArrayInt();

		if(IS_SEQUENCE(item)) {
			s1_ptr p = SEQ_PTR( item );

			for (int i = 1; i <= p->length; i++ ) {
				ai->Add( get_int( item, i ) );
			}
		} else {
			ai->Add( (intptr_t) item );
		}
		
		((wxMultiChoiceDialog *)control)->SetSelections( *ai );
	
	}
	else if(  obj->IsKindOf( CLASSINFO( wxSingleChoiceDialog ) ) ){
		wxSingleChoiceDialog *scd = reinterpret_cast<wxSingleChoiceDialog*>( obj );
		scd->SetSelection( item );
	}
	else{
		((wxChoice*)control)->SetSelection( item );
	}
	wxDeRef(item);
}

void WXEUAPI  set_string(intptr_t control, intptr_t item, object string)
{

	wxObject * obj = (wxObject*) control;
	wxString str = get_string( string );
	if( obj->IsKindOf( CLASSINFO( wxListBox ) ) ){
		((wxListBox*)control)->SetString(item, str);
	}
	else if( obj->IsKindOf( CLASSINFO( wxListCtrl ) ) ){
		((wxListCtrl*)control)->SetItemText( item, str );
		
	}
	else if( obj->IsKindOf( CLASSINFO( wxBitmapComboBox ) ) ){
		((wxBitmapComboBox*)control)->SetStringSelection( str );
	}
	else if( obj->IsKindOf( CLASSINFO( wxComboBox ) ) ){
		((wxComboBox*)control)->SetStringSelection( str );
	}
	else{
		((wxChoice*)control)->SetString( item, str );
	}	
	wxDeRefDS(string);
}

object WXEUAPI  new_wxListCtrl(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxListCtrl, wxLC_REPORT );
	
}

object WXEUAPI  insert_listctrl_item(intptr_t list, int index, object text, int image)
{
	s1_ptr s = SEQ_PTR( text );
	intptr_t item;
	if( (s->length) && IS_SEQUENCE( s->base[1] ) ){
		item = ((wxListCtrl*)list)->InsertItem( index, get_string( text, 1 ), image );
		for( int i = 2; i <= s->length; i++){
		//intptr_t SetItem(intptr_t index, int col, const wxString& label, int imageId = -1)
			((wxListCtrl*)list)->SetItem( index, i-1, get_string( text, i ) );
		}
	}
	else{
		item = ((wxListCtrl*)list)->InsertItem( index, get_string( text ), image  );
	}
	wxDeRefDS(text);
	return BOX_INT( item );
}

void WXEUAPI  list_imagelist(intptr_t list, intptr_t il, int which)
{
	((wxListCtrl*)list)->SetImageList( (wxImageList*)il, which );
}

object WXEUAPI  insert_list_column(intptr_t list, int col, object text, int format, int width)
{

	intptr_t ret = ((wxListCtrl*)list)->InsertColumn( col, get_string( text ),
		format, width );
		wxDeRefDS(text);
	return BOX_INT( ret );
}

void WXEUAPI  set_list_item_image(intptr_t list, intptr_t item, int image)
{
	((wxListCtrl*)list)->SetItemImage( item, image );
}

void WXEUAPI  set_column_label(intptr_t list, int column, object text)
{

	wxListItem item = wxListItem();
	item.SetText( get_string( text ) );
	item.SetMask(wxLIST_MASK_TEXT);
	((wxListCtrl*)list)->SetColumn( column, item );
	wxDeRefDS(text);
}

void WXEUAPI  list_ensure_visible(intptr_t list, intptr_t item)
{
	((wxListBox*)list)->EnsureVisible( item );
}

void WXEUAPI  set_first_list_item(intptr_t list, object item)
{

	if( IS_SEQUENCE( item ) ){
		((wxListBox*)list)->SetFirstItem( get_string( item ) );
	}
	else {
		((wxListBox*)list)->SetFirstItem( item );
	}
	wxDeRef(item);
}

void WXEUAPI  set_list_item_back_color(intptr_t list, intptr_t item, intptr_t color)
{
//void = cpp:call_member( wxListCtrl_SetItemBackgroundColour, list, {item, color})
	((wxListCtrl*)list)->SetItemBackgroundColour( item, *((wxColour*)color) );
}

object WXEUAPI get_list_event_column( int event )
{
	return ((wxListEvent*)event)->GetColumn();
}

object WXEUAPI  new_wxBitmapComboBox(object params)
{
/*
--1/li atom parent
--2/li integer id [=-1]
--3/li sequence value [=""]
--4/li integer x [=-1]
--5/li integer y [=-1]
--6/li integer cx [=-1]
--7/li integer cy [=-1]
--8/li sequence choices  [={}]
--9/li atom style [=0]
*/

	s1_ptr p = SEQ_PTR( params );
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	int n = 0;
	wxString * choices = NULL;
	wxBitmapComboBox * combo = NULL;
	intptr_t style = 0;
	wxString value(wxT(""));
	object c;
	wxWindowID id = -1;
	
	switch( p->length ){
		case 9:
			style = get_int( params, 9 );

		case 8:
			c = p->base[8];
			n = ((s1_ptr)SEQ_PTR(c))->length;
			choices = new wxString[n];
			for( int i = 0; i < n; i++ ){
				choices[i] = get_string( c, i + 1 );
			}

		case 7:
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );

		case 6:
		case 5:
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5 ) );

		case 4:
		case 3:
			value = get_string( params, 3 );
		case 2:
			//id = -1;    // why was this -1 ?
			id = get_int( params, 2 );
		default:
			combo = new wxBitmapComboBox( (wxWindow *) get_int( params, 1 ),
				id, value,
				pos, size, n, choices, style );
			break;
	}
	wxDeRefDS( params );
	return BOX_INT(combo);
}

object WXEUAPI get_combo_bitmap_size(intptr_t combo)
{

	wxSize s = ((wxBitmapComboBox *)combo)->GetBitmapSize();
	s1_ptr eusize = NewS1(2);
	
	eusize->base[1] = s.GetWidth();
	eusize->base[2] = s.GetHeight();
	
	return MAKE_SEQ( eusize );

}

object WXEUAPI get_combo_item_bitmap(intptr_t combo, int index)
{
	wxBitmap b = ((wxBitmapComboBox *)combo)->GetItemBitmap( (unsigned) index );
	
	return BOX_INT( new wxBitmap( b ) );

}

void WXEUAPI set_combo_item_bitmap(intptr_t combo, int index, intptr_t bitmap)
{
	((wxBitmapComboBox *)combo)->SetItemBitmap( ((unsigned) index), *((wxBitmap *)bitmap) );

}

object WXEUAPI list_hit_test( intptr_t list, int x, int y, int flags )
{
	return BOX_INT( ((wxListCtrl*)list)->HitTest( wxPoint( x, y ), flags ) );
}

void WXEUAPI set_list_item( intptr_t list, intptr_t index, int col, object label, int image )
{
	
	((wxListCtrl*)list)->SetItem( index, col, get_string(label), image );
	wxDeRefDS( label );
}

}
