// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "alldefs.h"
#include "wxeu.h"

#include <wx/intl.h>
#include <wx/strconv.h>

extern "C" {

object WXEUAPI new_wxLocale( object params )
{
	int language = wxLANGUAGE_DEFAULT;
	int flags = wxLOCALE_LOAD_DEFAULT | wxLOCALE_CONV_ENCODING;
	
	switch( LENGTH( params ) ){
		case 2:
			flags = get_int( params, 2 );
		case 1:
			language = get_int( params, 1 );
	}
	wxDeRefDS( params )
	return BOX_INT( new wxLocale( language, flags ) );
}


object WXEUAPI get_language( intptr_t locale )
{
	return BOX_INT( reinterpret_cast<wxLocale*>( locale )->GetLanguage() );
}

object WXEUAPI get_canonical_language_name( intptr_t locale )
{
	return get_sequence( reinterpret_cast<wxLocale*>( locale)->GetCanonicalName() );
}

object WXEUAPI get_language_name( int lang )
{
	return get_sequence( wxLocale::GetLanguageName( lang ) );
}

object WXEUAPI get_locale( intptr_t locale )
{
	return get_sequence( reinterpret_cast<wxLocale*>( locale )->GetLocale() );
}

object WXEUAPI get_locale_name( intptr_t locale )
{
	return get_sequence( reinterpret_cast<wxLocale*>( locale )->GetName() );
}

object WXEUAPI get_locale_sys_name( intptr_t locale )
{
	return get_sequence( reinterpret_cast<wxLocale*>( locale )->GetSysName() );
}

object WXEUAPI get_system_encoding()
{
	return BOX_INT( wxLocale::GetSystemEncoding() );
}

object WXEUAPI get_system_encoding_name()
{
	return get_sequence( wxLocale::GetSystemEncodingName() );
}

object WXEUAPI get_system_language()
{
	return BOX_INT( wxLocale::GetSystemLanguage() );
}

object WXEUAPI is_locale_available( int lang )
{
	return wxLocale::IsAvailable( lang );
}

object WXEUAPI new_wxCSConv( object params )
{
	wxCSConv *conv;
	s1_ptr p = SEQ_PTR( params );
	if( IS_ATOM( p->base[1] ) ){
		conv = new wxCSConv( (wxFontEncoding) get_int( params, 1 ) );
	}
	else{
		wxString charset = get_string( params, 1 );
		conv = new wxCSConv( charset );
	}
	
	wxDeRefDS( params );
	return BOX_INT( conv );
}

object WXEUAPI conv_ok( intptr_t conv )
{
	return reinterpret_cast<wxCSConv*>( conv )->IsOk();
}

object WXEUAPI conv_mb2wc( intptr_t conv, object in_seq )
{
	if( IS_ATOM( in_seq ) ){
		return in_seq;
	}
	char *in = get_char( in_seq );
	int len = LENGTH(in_seq) + 1;
	wchar_t *buf = new wchar_t[len];
	size_t size = reinterpret_cast<wxCSConv*>( conv )->MB2WC( buf, in, len );
	object out;
	if( size == wxCONV_FAILED ){
		out = 0;
	}
	else{
		out = get_sequence( buf, size );
	}
	delete[] buf;
	delete[] in;
	return out;
}

object WXEUAPI conv_wc2mb( intptr_t conv, object in_seq )
{
	if( IS_ATOM( in_seq ) ){
		return in_seq;
	}
	
	wchar_t *in = get_wchar( in_seq );
	int len = (1 + LENGTH(in_seq)) * sizeof( wchar_t );
	char *buf = new char[len];
	size_t size = reinterpret_cast<wxCSConv*>( conv )->WC2MB( buf, in, len );
	object out;
	if( size == wxCONV_FAILED ){
		out = 0;
	}
	else{
		out = get_sequence( buf, size );
	}
	delete[] buf;
	delete[] in;
	return out;
}

}