// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include <wx/mdi.h>


extern "C"{
object WXEUAPI  new_wxMDIParentFrame(object params)
{
	NEW_CONTROL_STYLE( wxMDIParentFrame, mdi, wxDEFAULT_FRAME_STYLE|wxVSCROLL|wxHSCROLL );
}

object WXEUAPI  new_wxMDIClientWindow(object params)
{
	intptr_t style = 0;
	if( LENGTH( params ) > 1 ) style = get_int( params, 2 );
	wxMDIClientWindow * client = new wxMDIClientWindow( (wxMDIParentFrame*)get_int(params, 1), style);
	wxDeRefDS( params );
	return BOX_INT( client );
}

object WXEUAPI  new_wxMDIChildFrame(object params)
{
	s1_ptr p = SEQ_PTR( params );
	wxString text(wxT(""));
	wxWindowID id = -1;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	intptr_t style = wxDEFAULT_FRAME_STYLE;
	switch( p->length ){
		case 10:
		case 9:
		case 8:
			style = get_int( params, 8 );
		case 7:
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );
		case 6:
		case 5:
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5) );
		case 4:
		case 3:
			text = get_string( params, 3 );
		case 2:
			id = get_int( params, 2 );
		default:
			break;
	}
	wxMDIChildFrame * frame = new wxMDIChildFrame( (wxMDIParentFrame *)get_int(params, 1),
			id, text, pos, size, style );
	wxDeRefDS( params );
	return BOX_INT( frame );
}

void WXEUAPI  restore_child(intptr_t child)
{
	((wxMDIChildFrame*)child)->Restore();
}

void WXEUAPI  activate_child(intptr_t child)
{
	((wxMDIChildFrame*)child)->Activate();
}

void WXEUAPI  maximize_child(intptr_t child, int maximize)
{
	((wxMDIChildFrame*)child)->Maximize();
}

void WXEUAPI  arrange_mdi_icons(intptr_t parent)
{
	((wxMDIParentFrame*)parent)->ArrangeIcons();
}

void WXEUAPI  cascade_mdi(intptr_t parent)
{
	((wxMDIParentFrame*)parent)->Cascade();
}

void WXEUAPI  tile_mdi(intptr_t parent, int orient)
{
	((wxMDIParentFrame*)parent)->Tile( (wxOrientation)orient );
}

void WXEUAPI  set_mdi_child_title(intptr_t child_frame, object title)
{
#ifdef WXEUMSW
	((wxFrame*)child_frame)->SetTitle( get_string(title) );
#endif
	wxDeRefDS( title );
}

void WXEUAPI activate_next_mdi( intptr_t parent_frame )
{
	((wxMDIParentFrame*)parent_frame)->ActivateNext();
}

void WXEUAPI activate_prev_mdi( intptr_t parent_frame )
{
	((wxMDIParentFrame*)parent_frame)->ActivatePrevious();
}

object WXEUAPI get_active_mdi_child( intptr_t parent_frame )
{
	return BOX_INT( ((wxMDIParentFrame*)parent_frame)->GetActiveChild() );
}

object WXEUAPI get_client_window( intptr_t parent_frame )
{
	return BOX_INT( ((wxMDIParentFrame*)parent_frame)->GetClientWindow() );
}

object WXEUAPI get_mdi_window_menu( intptr_t parent_frame )
{
#ifdef WXEUMSW
	return BOX_INT( ((wxMDIParentFrame*)parent_frame)->GetWindowMenu() );
#else
	return 0;
#endif
}

void WXEUAPI set_mdi_toolbar( intptr_t parent_frame, intptr_t toolbar )
{
	((wxMDIParentFrame*)parent_frame)->SetToolBar( (wxToolBar*)toolbar );
}

void WXEUAPI set_mdi_window_menu( intptr_t parent_frame, intptr_t menu )
{
#ifdef WXEUMSW
	((wxMDIParentFrame*)parent_frame)->SetWindowMenu( (wxMenu*)menu );
#endif
}

}
