// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#if wxUSE_MEDIACTRL

#include <wx/mediactrl.h>
#include <wx/sound.h>

extern "C"{

object WXEUAPI new_wxMediaCtrl( object params ){
	NEW_CONTROL(wxMediaCtrl);
}

object WXEUAPI load_media( intptr_t media, object file ){
	wxDeRefDS( file );
	return ((wxMediaCtrl*)media)->Load( get_string( file ) );
}

object WXEUAPI load_media_uri( intptr_t media, object uri ){
	wxDeRefDS( uri );
	return ((wxMediaCtrl*)media)->Load( wxURI( get_string(uri) ) );
}

object WXEUAPI play_media( intptr_t media ){
	return ((wxMediaCtrl*)media)->Play();
}

object WXEUAPI pause_media( intptr_t media ){
	return ((wxMediaCtrl*)media)->Pause();
}

object WXEUAPI stop_media( intptr_t media ){
	return ((wxMediaCtrl*)media)->Stop();
}

object WXEUAPI show_player_controls( intptr_t media, int flags ){
	return ((wxMediaCtrl*)media)->ShowPlayerControls( (wxMediaCtrlPlayerControls)flags );
}

object WXEUAPI set_media_volume( intptr_t media, object volume ){
	wxDeRef( volume );
	if( !IS_ATOM_INT( volume ) ){
		return ((wxMediaCtrl*)media)->SetVolume( DBL_PTR(volume)->dbl );
	}
	else{
		return ((wxMediaCtrl*)media)->SetVolume( (double) volume );
	}
}

object WXEUAPI get_media_volume( intptr_t media ){
	double vol = ((wxMediaCtrl*)media)->GetVolume();
	return (object)NewDouble(vol);
}

object WXEUAPI get_media_state( intptr_t media ){
	return ((wxMediaCtrl*)media)->GetState();
}

object WXEUAPI get_media_length( intptr_t media ){
	return BOX_INT( ((wxMediaCtrl*)media)->Length() );
}

object WXEUAPI get_media_position( intptr_t media ){
	return BOX_INT( ((wxMediaCtrl*)media)->Tell() );
}

void WXEUAPI seek_media( intptr_t media, int where, int mode ){
	((wxMediaCtrl*)media)->Seek( where, (wxSeekMode)mode );
}


object WXEUAPI new_wxSound( object params ){
/*
--/li sequence fileName
--/li int isResource = false
*/
	s1_ptr p = SEQ_PTR( params );
	bool isResource = false;
	
	wxSound * s = NULL;
	if (p->length == 0) {
		s = new wxSound();
		
	} else { 
		if (p->length == 2) {
			isResource = (bool) get_int( params, 2);
		}
		s = new wxSound( get_string( params, 1 ), isResource);
	}
	
	return BOX_INT( s );
}

object WXEUAPI sound_create(intptr_t sound, object file, int isResource ){
	return ((wxSound *)sound)->Create( get_string( file ), (bool)isResource );
}

object WXEUAPI sound_is_ok(intptr_t sound) {
	return ((wxSound *)sound)->IsOk();
}

object WXEUAPI sound_play(intptr_t sound, int flags) {
	return ((wxSound *)sound)->Play((unsigned) flags);
}

void WXEUAPI sound_stop() {
	wxSound::Stop();
}

}
#endif
