// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"



extern "C"{
object WXEUAPI  new_wxMenuBar(object params)
{

        wxMenuBar *bar = new wxMenuBar();
        wxFrame *frame = (wxFrame *) get_int( params, 1 );
        frame->SetMenuBar( bar );
        wxDeRefDS( params );
        return BOX_INT(bar);
}

object WXEUAPI  new_wxMenuItem(object params)
{
        int len = ((s1_ptr)SEQ_PTR(params))->length;
        int quality = wxIMAGE_QUALITY_NORMAL;
        int width = -1;
        int height = -1;
        bool resize = false;
        wxBitmap bitmap = wxNullBitmap;
        bool use_bitmap = false;
        wxMenu * subMenu= NULL;
        wxItemKind kind = wxITEM_NORMAL;
        wxString helpString = _T("");
        wxString text = _T("");
        int id = wxID_SEPARATOR;
        wxMenu * parentMenu = NULL;
        wxMenuItem * item;
        
        switch( len ){
                case 10:
                        quality = get_int( params, 10 );
                        
                case 9:
                        width = get_int( params, 8 );
                        height = get_int( params, 9 );
                        resize = true;
                        
                case 8:
                case 7:
                        {
                                // take a copy of the bitmap
                                wxBitmap * temp = (wxBitmap *) get_int( params, 7 );
                                bitmap = temp->GetSubBitmap(wxRect( 0, 0, temp->GetWidth(), temp->GetHeight() ));
                                use_bitmap = true;
                                
                                if ( resize ) {
                                        wxImage image = bitmap.ConvertToImage();
                                        image = image.Rescale( width, height, quality );
                                        bitmap = wxBitmap( image );
                                }
                        }
                case 6:
                        subMenu = (wxMenu *) get_int( params, 6 );
                
                case 5:
                        kind = (wxItemKind) get_int( params, 5 );
                
                case 4:
                        helpString = get_string( params, 4 );
                
                case 3:
                        text = get_string( params, 3 );
                
                case 2:
                        id = get_int( params, 2 );
                
                default:
                        parentMenu = (wxMenu *) get_int( params, 1 );
                        if ( text == wxT("-") ) {
                            /* append a separator instead */
                            item = NULL;
                            parentMenu->AppendSeparator();
                        }
                        else {
                            item = new wxMenuItem( parentMenu, id, text, helpString, kind, subMenu );
                            if (use_bitmap) item->SetBitmap( bitmap );
                            parentMenu->Append( item );
                        }
        }
        wxDeRefDS( params );
        return BOX_INT(item);
}

void WXEUAPI  add_menu(intptr_t menubar, intptr_t menu, object title)
{
        ((wxMenuBar*)menubar)->Append( (wxMenu*)menu, get_string( title ) );
        wxDeRefDS( title );
}

void WXEUAPI  insert_menu(intptr_t menubar, intptr_t menu, object title, int index)
{
        ((wxMenuBar*)menubar)->Insert( index, (wxMenu*)menu, get_string( title ) );
        wxDeRefDS( title );
}

object WXEUAPI  new_wxMenu(object params)
{
        wxDeRefDS( params );
        wxMenu * menu;
        int len = LENGTH(params);
        if ( len < 2 ){
                if ( len == 0 )
                        menu = new wxMenu(0);
                else
                        menu = new wxMenu( get_int( params, 1 ) );
                
                return BOX_INT(menu);
        }
        
        if( len > 2 )
                menu = new wxMenu( get_int( params, 3 ) );
        else
                menu = new wxMenu(0);
        
        wxMenuBar * parent = (wxMenuBar *) get_int( params, 1 );
        if ( parent != NULL ){
                if ( len == 4 ){
                        parent->Insert( get_int( params, 4 ), menu, get_string( params, 2 ) );
                }
                else {
                        parent->Append( menu, get_string( params, 2 ) );
                }
        }

        return BOX_INT(menu);
}

object WXEUAPI  get_menuitem_id(intptr_t item)
{
        return BOX_INT( ((wxMenuItem*)item)->GetId());
}

object WXEUAPI  get_menuevent_id(intptr_t event)
{
        return BOX_INT( ((wxMenuEvent*)event)->GetMenuId() );
}

object WXEUAPI  get_menuitem_count(intptr_t menu)
{
        return BOX_INT( ((wxMenu*)menu)->GetMenuItemCount() );
}

object WXEUAPI  insert_menuitem(intptr_t menu, int position, int id, object text, object help, int checkable)
{
        wxMenuItem * item;
        if( checkable ){
                item = ((wxMenu*)menu)->InsertCheckItem(position, id, get_string( text ), get_string( help ));
        }
        else{
                item = ((wxMenu*)menu)->Insert(position, id, get_string( text ), get_string( help ));
        }

        wxDeRefDS( text );
        wxDeRefDS( help );
        return BOX_INT( item );
}

void WXEUAPI  set_menu_label(intptr_t menu, int id, object label)
{
        ((wxMenu*)menu)->SetLabel( id, get_string( label ) );
        wxDeRefDS( label );
}

object WXEUAPI  is_menuitem_checked(intptr_t menuitem)
{
        return ((wxMenuItem*)menuitem)->IsChecked();
}

void WXEUAPI  check_menuitem(intptr_t menuitem, int check)
{
        ((wxMenuItem*)menuitem)->Check( check );
}

void WXEUAPI  enable_menuitem(intptr_t menuitem, int enable)
{
        ((wxMenuItem *)menuitem)->Enable( enable );
}

void WXEUAPI  remove_menuitem(intptr_t menu, intptr_t item)
{
        ((wxMenu*)menu)->Remove( (wxMenuItem*)item);
}

void WXEUAPI append_separator( intptr_t menu )
{
        ((wxMenu*)menu)->AppendSeparator();
}

void WXEUAPI insert_separator( intptr_t menu, int pos )
{
        ((wxMenu*)menu)->InsertSeparator(pos);
}

object WXEUAPI get_menu_by_index( intptr_t menubar, int pos )
{
        return BOX_INT( ((wxMenuBar*)menubar)->GetMenu(pos) );
}

object WXEUAPI get_menu_by_label( intptr_t menubar, object label )
{
        int pos = ((wxMenuBar*)menubar)->FindMenu( get_string( label ) );
        wxDeRefDS( label );
        
        if (pos != wxNOT_FOUND) {
                return BOX_INT( ((wxMenuBar*)menubar)->GetMenu(pos) );
        } else {
                return 0;
        }
}

object WXEUAPI find_menuitem_id( intptr_t menu, object label )
{
        wxDeRefDS( label );
        return BOX_INT( ((wxMenu*)menu)->FindItem( get_string( label ) ) );
}

object WXEUAPI find_menuitem_by_position( intptr_t menu, int position )
{
        return BOX_INT( ((wxMenu*)menu)->FindItemByPosition( (size_t)position ) );
}

void WXEUAPI set_menuitem_bitmap( intptr_t item, intptr_t bmp )
{
        #ifdef WXEUMSW
        ((wxMenuItem *)item)->SetBitmaps( *((wxBitmap *)bmp), wxNullBitmap );
        #else
        ((wxMenuItem *)item)->SetBitmap( *((wxBitmap *)bmp) );
        #endif
}

object WXEUAPI find_menuitem_by_id( intptr_t menu, intptr_t id )
{
	return BOX_INT( reinterpret_cast<wxMenu*>( menu )->FindItem( id ) );
}

}
