// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include "wx/notebook.h"
#include "wx/choicebk.h"
#include <wx/listbook.h>
#include <wx/treebook.h>
#include <wx/toolbook.h>
extern "C"{
object WXEUAPI  new_wxNotebook(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxNotebook, 0 )
}

object WXEUAPI  new_wxChoicebook(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxChoicebook, 0 )
}

object WXEUAPI  new_wxListbook(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxListbook, 0 )
}

object WXEUAPI  new_wxTreebook(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxTreebook, 0 )
}

object WXEUAPI  new_wxToolbook(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxToolbook, 0 )
}


void WXEUAPI  add_page(intptr_t book, intptr_t page, object text, int select, int image)
{
	wxString str = get_string( text );
	((wxBookCtrlBase *)book)->AddPage((wxWindow *)page, str,(bool) select, image );
	wxDeRefDS( text );
}

void WXEUAPI  show_page(intptr_t book, intptr_t page)
{
	((wxBookCtrlBase *)book)->ChangeSelection( page );
}

void WXEUAPI  set_page_text(intptr_t book, intptr_t page, object text)
{
	((wxBookCtrlBase *)book)->SetPageText( page, get_string( text ) );
	wxDeRefDS( text );
}

void WXEUAPI  notebook_imagelist(intptr_t book, intptr_t ilist)
{
	((wxBookCtrlBase *)book)->SetImageList((wxImageList *)ilist );

}

void WXEUAPI  delete_all_pages(intptr_t book)
{
	((wxBookCtrlBase *)book)->DeleteAllPages();
}

void WXEUAPI  insert_page(int position, intptr_t book, intptr_t page, object text, int select, int image)
{
	((wxBookCtrlBase *)book)->InsertPage( position,(wxNotebookPage*)page, get_string( text ), select, image );

}

object WXEUAPI  get_current_page(intptr_t book)
{
	return BOX_INT(((wxBookCtrlBase *)book)->GetCurrentPage());
}

object WXEUAPI  notebook_event_selection(intptr_t event)
{
	return (object)((wxNotebookEvent *)event)->GetSelection();
}

object WXEUAPI  get_next_page(intptr_t book, int show)
{
	return 0;
}

object WXEUAPI  get_page_count(intptr_t book)
{
	return ((wxBookCtrlBase *)book)->GetPageCount();
}

object WXEUAPI  get_page_image(intptr_t book, intptr_t page)
{
	return ((wxBookCtrlBase *)book)->GetPageImage( page );
}

object WXEUAPI  get_page_text(intptr_t book, intptr_t page)
{
	return get_sequence( ((wxBookCtrlBase *)book)->GetPageText(page) );
}

void WXEUAPI  remove_page(intptr_t book, intptr_t page)
{
	((wxBookCtrlBase *)book)->RemovePage( page );
}

void WXEUAPI  set_padding(intptr_t book, object size)
{
	((wxNotebook *)book)->SetPadding( wxSize( get_int( size, 1 ), get_int( size, 2 ) ) );
	wxDeRefDS( size );
}

void WXEUAPI  set_page_image(intptr_t book, intptr_t page, int image)
{
	((wxBookCtrlBase *)book)->SetPageImage( page, image );
}

void WXEUAPI  set_page_selection(intptr_t book, intptr_t page)
{
	((wxBookCtrlBase *)book)->ChangeSelection( page );
}

void WXEUAPI  set_tab_size(intptr_t book, object size)
{
	((wxNotebook *)book)->SetTabSize( wxSize( get_int( size, 1), get_int( size, 2) ) );
	wxDeRefDS( size );
}

void WXEUAPI  advance_selection(intptr_t book, int forward)
{
	((wxNotebook *)book)->AdvanceSelection((bool) forward );
}

void WXEUAPI  delete_page(intptr_t book, intptr_t page)
{
	((wxBookCtrlBase *)book)->DeletePage( page );
}

}
