// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include <wx/pickerbase.h>
#include <wx/clrpicker.h>
#include <wx/filepicker.h>
#include <wx/fontpicker.h>
#include <wx/datectrl.h>
#include "alldefs.h"
#include "wxeu.h"

#include <wx/colour.h>
#include <wx/datetime.h>
#include <wx/font.h>
#include <wx/dateevt.h>

#if \
	wxUSE_DIRPICKERCTRL == 1 \
	|| wxUSE_COLOURPICKERCTRL == 1 \
	|| wxUSE_DATEPICKCTRL == 1 \
	|| wxUSE_FILEPICKERCTRL == 1 \
	|| wxUSE_FONTPICKERCTRL == 1

extern "C"{

void WXEUAPI set_picker_internal_margin( intptr_t picker, int margin )
{
	reinterpret_cast<wxPickerBase*>( picker )->SetInternalMargin( margin );
}

object WXEUAPI get_picker_internal_margin( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->GetInternalMargin() );
}

void WXEUAPI set_picker_textctrl_proportion( intptr_t picker, int prop )
{
	reinterpret_cast<wxPickerBase*>( picker )->SetTextCtrlProportion( prop );
}

object WXEUAPI get_picker_textctrl_proportion( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->GetTextCtrlProportion( ) );
}

void WXEUAPI set_pickerctrl_proportion( intptr_t picker, int prop )
{
	reinterpret_cast<wxPickerBase*>( picker )->SetPickerCtrlProportion( prop );
}

object WXEUAPI get_pickerctrl_proportion( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->GetPickerCtrlProportion() );
}

object WXEUAPI picker_has_textctrl( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->HasTextCtrl() );
}

object WXEUAPI get_picker_textctrl( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->GetTextCtrl() );
}

object WXEUAPI picker_is_textctrl_growable( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->IsTextCtrlGrowable() );
}

object WXEUAPI picker_is_pickerctrl_growable( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxPickerBase*>( picker )->IsPickerCtrlGrowable() );
}

void WXEUAPI set_pickerctrl_growable( intptr_t picker, int grow )
{
	reinterpret_cast<wxPickerBase*>( picker )->SetPickerCtrlGrowable( grow );
}

void WXEUAPI set_picker_textctrl_growable( intptr_t picker, int grow )
{
	reinterpret_cast<wxPickerBase*>( picker )->SetTextCtrlGrowable( grow );
}


#if wxUSE_DIRPICKERCTRL == 1

object WXEUAPI new_wxDirPickerCtrl( object params ){
	wxWindow *parent;
	wxWindowID id = -1;
	wxString path = wxEmptyString;
	wxString message = wxT("Select a folder");
	wxPoint pos = wxDefaultPosition;
	wxSize  size = wxDefaultSize;
	long style = 0;
	
	switch( SEQ_PTR( params )->length ){
		case 9:
			style   = get_int( params, 9 );
		case 8:
			size    = wxSize( get_int( params, 7 ), get_int( params, 8 ) );
		case 6:
			pos.x   = get_int( params, 5 );
			pos.y   = get_int( params, 6 );
		case 4:
			message = get_string( params, 4 );
		case 3:
			path    = get_string( params, 3 );
		case 2:
			id     = get_int( params, 2 );
		default:
			parent = reinterpret_cast<wxWindow*>(  get_int( params, 1 ) );
			
	}
	wxDeRefDS(params);
	wxDirPickerCtrl *picker = new wxDirPickerCtrl( parent, id, path, message, pos, size, style );
	return BOX_INT( picker );
}

object WXEUAPI get_dirpicker_path( intptr_t picker )
{
		return get_sequence( reinterpret_cast<wxDirPickerCtrl*>( picker )->GetPath() );
}

void WXEUAPI set_dirpicker_path( intptr_t picker, object path )
{
	reinterpret_cast<wxDirPickerCtrl*>( picker )->SetPath( get_string( path ) );
}
#endif

#if wxUSE_COLOURPICKERCTRL == 1

object WXEUAPI new_wxColourPickerCtrl( object params )
{
	wxWindow *parent;
	wxWindowID id = wxNewId();
	wxColour color = *wxBLACK;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	long style = 0;
	
	switch( SEQ_PTR( params )->length ){
		case 10:
			style   = get_int( params, 10 );
		case 9:
			size    = wxSize( get_int( params, 8 ), get_int( params, 9 ) );
		case 7:
			pos.x   = get_int( params, 6 );
			pos.y   = get_int( params, 7 );
		case 5:
			pos.x   = get_int( params, 4 );
			pos.y   = get_int( params, 5 );
		case 3:
			color  = *reinterpret_cast<wxColour*>( get_int( params, 3 ) );
		case 2:
			id     = get_int( params, 2 );
		default:
			parent = reinterpret_cast<wxWindow*>(  get_int( params, 1 ) );
			
	}
	wxDeRefDS( params );
	wxColourPickerCtrl *picker = new wxColourPickerCtrl( parent, id, color, pos, size, style );
	return BOX_INT( picker );
}

object WXEUAPI get_picker_color( intptr_t picker )
{
	wxColour *color = new wxColour( reinterpret_cast<wxColourPickerCtrl*>( picker)->GetColour() );
	return BOX_INT( color );
}

void WXEUAPI set_picker_color( intptr_t picker, intptr_t color )
{
	reinterpret_cast<wxColourPickerCtrl*>( picker)->SetColour( *reinterpret_cast<wxColour*>( color ) );
}

object WXEUAPI get_colorpickerevent_color( intptr_t event )
{
	wxColour *color = new wxColour( reinterpret_cast<wxColourPickerEvent*>( event )->GetColour() );
	return BOX_INT( color );
}
#endif

#if wxUSE_DATEPICKCTRL == 1

object WXEUAPI new_wxDatePickerCtrl( object params )
{
	wxWindow *parent;
	wxWindowID id = -1;
	wxDateTime dt = wxDefaultDateTime;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	long style = wxDP_DEFAULT | wxDP_SHOWCENTURY;
	
	switch( LENGTH( params ) ){
		case 10:
			style   = get_int( params, 10 );
		case 9:
			size    = wxSize( get_int( params, 8 ), get_int( params, 9 ) );
		case 7:
			pos.x   = get_int( params, 6 );
			pos.y   = get_int( params, 7 );
		case 4:
			pos.x   = get_int( params, 4 );
			pos.y   = get_int( params, 5 );
		case 3:
			dt      = *reinterpret_cast<wxDateTime*>( get_int( params, 3 ) );
		case 2:
			id     = get_int( params, 2 );
		default:
			parent = reinterpret_cast<wxWindow*>(  get_int( params, 1 ) );
			
	}
	wxDeRefDS( params );
	wxDatePickerCtrl *picker = new wxDatePickerCtrl( parent, id, dt, pos, size, style );
	return BOX_INT( picker );
}

object WXEUAPI get_picker_range( intptr_t picker )
{
	wxDateTime dt1, dt2;
	
	bool ok = reinterpret_cast<wxDatePickerCtrl*>( picker )->GetRange( &dt1, &dt2 );
	if( ok ){
		s1_ptr range = NewS1( 2 );
		range->base[1] = get_datetime( dt1 );
		range->base[2] = get_datetime( dt2 );
		return MAKE_SEQ( range );
	}
	else{
		return 0;
	}
}

object WXEUAPI get_picker_date( intptr_t picker )
{
	wxDateTime *dt = new wxDateTime( reinterpret_cast<wxDatePickerCtrl*>( picker )->GetValue() );
	return BOX_INT( dt );
}

void WXEUAPI set_picker_range( intptr_t picker, object dt1, object dt2 )
{
	reinterpret_cast<wxDatePickerCtrl*>( picker )->SetRange( get_datetime( dt1 ), get_datetime( dt2 ) );
}

void WXEUAPI set_picker_date( intptr_t picker, object dt )
{
	reinterpret_cast<wxDatePickerCtrl*>( picker )->SetValue( get_datetime( dt ) );
}

object WXEUAPI get_dateevent_date( intptr_t event )
{
	return get_datetime( reinterpret_cast<wxDateEvent*>( event )->GetDate() );
}

#endif

#if wxUSE_FILEPICKERCTRL || wxUSE_DIRPICKERCTRL

object WXEUAPI get_filedirpicker_event_path( intptr_t event )
{
	return get_sequence( reinterpret_cast<wxFileDirPickerEvent*>( event )->GetPath() );
}
#endif

#if wxUSE_FILEPICKERCTRL == 1

object WXEUAPI new_wxFilePickerCtrl( object params )
{
	wxWindow *parent;
	wxWindowID id = -1;
	wxString path = wxEmptyString;
	wxString message = wxT("Select a file");
	wxString wildcard = wxT("*.*");
	wxPoint pos = wxDefaultPosition;
	wxSize  size = wxDefaultSize;
	long style = 0;
	
	switch( SEQ_PTR( params )->length ){
		case 10:
			style   = get_int( params, 10 );
		case 9:
			size    = wxSize( get_int( params, 8 ), get_int( params, 9 ) );
		case 7:
			pos.x   = get_int( params, 6 );
			pos.y   = get_int( params, 7 );
		case 5:
			wildcard = get_string( params, 5 );
		case 4:
			message = get_string( params, 4 );
		case 3:
			path    = get_string( params, 3 );
		case 2:
			id     = get_int( params, 2 );
		default:
			parent = reinterpret_cast<wxWindow*>(  get_int( params, 1 ) );
			
	}
	wxDeRefDS(params);
	wxFilePickerCtrl *picker = new wxFilePickerCtrl( parent, id, path, message, wildcard, pos, size, style );
	return BOX_INT( picker );
}

object WXEUAPI get_filepicker_path( intptr_t picker )
{
	return get_sequence( reinterpret_cast<wxFilePickerCtrl*>( picker )->GetPath() );
}

void WXEUAPI set_filepicker_path( intptr_t picker, object path )
{
	reinterpret_cast<wxFilePickerCtrl*>( picker )->SetPath( get_string( path ) );
}


#endif

#if wxUSE_FONTPICKERCTRL == 1

object WXEUAPI new_wxFontPickerCtrl( object params )
{
	wxWindow *parent;
	wxWindowID id = -1;
	wxFont font = wxNullFont;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	long style = 0;
	
	switch( SEQ_PTR( params )->length ){
		case 10:
			style   = get_int( params, 10 );
		case 9:
			size    = wxSize( get_int( params, 8 ), get_int( params, 9 ) );
		case 7:
			pos.x   = get_int( params, 6 );
			pos.y   = get_int( params, 7 );
		case 5:
			pos.x   = get_int( params, 4 );
			pos.y   = get_int( params, 5 );
		case 3:
			font  = *reinterpret_cast<wxFont*>( get_int( params, 3 ) );
		case 2:
			id     = get_int( params, 2 );
		default:
			parent = reinterpret_cast<wxWindow*>(  get_int( params, 1 ) );
			
	}
	wxDeRefDS( params );
	wxFontPickerCtrl *picker = new wxFontPickerCtrl( parent, id, font, pos, size, style );
	return BOX_INT( picker );
}

object WXEUAPI get_picker_font( intptr_t picker )
{
	wxFont *font = new wxFont();
	*font = reinterpret_cast<wxFontPickerCtrl*>( picker )->GetSelectedFont();
	return BOX_INT( font );
}

void WXEUAPI set_picker_font( intptr_t picker, intptr_t font )
{
	reinterpret_cast<wxFontPickerCtrl*>( picker )->SetSelectedFont( *reinterpret_cast<wxFont*>( font ) );
}

object WXEUAPI get_picker_max_point( intptr_t picker )
{
	return BOX_INT( reinterpret_cast<wxFontPickerCtrl*>( picker )->GetMaxPointSize() );
}

void WXEUAPI set_picker_max_point( intptr_t picker, int max )
{
	reinterpret_cast<wxFontPickerCtrl*>( picker )->SetMaxPointSize( max );
}

object WXEUAPI get_fontpicker_event_font( intptr_t event )
{
	wxFont *font = new wxFont();
	*font = reinterpret_cast<wxFontPickerEvent*>( event )->GetFont();
	return BOX_INT( font );
}

#endif

}

#endif
