// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include <wx/platinfo.h>

extern "C"{

object WXEUAPI check_os_version( int major, int minor )
{
	return 1 & wxPlatformInfo::Get().CheckOSVersion( major, minor );
}

object WXEUAPI check_toolkit_version( int major, int minor )
{
	return 1 & wxPlatformInfo::Get().CheckToolkitVersion( major, minor );
}

object WXEUAPI get_arch_from_name( object arch )
{
	wxDeRefDS( arch );
	return BOX_INT( wxPlatformInfo::GetArch( get_string( arch ) ) );
}

object WXEUAPI get_arch_name_from_enum( int arch )
{
	return get_sequence( wxPlatformInfo::GetArchName( (wxArchitecture) arch ) );
}

object WXEUAPI get_arch_name()
{
	return get_sequence( wxPlatformInfo::Get().GetArchName() );
}

object WXEUAPI get_arch()
{
	return BOX_INT( wxPlatformInfo::Get().GetArchitecture() );
}

object WXEUAPI get_endianness_from_name(object endian)
{
	wxDeRefDS( endian );
	return BOX_INT( wxPlatformInfo::GetEndianness( get_string( endian ) ) );
}

object WXEUAPI get_endianness()
{
	return BOX_INT( wxPlatformInfo::Get().GetEndianness() );
}

object WXEUAPI get_endianness_name_from_enum( int endian )
{
	return get_sequence( wxPlatformInfo::GetEndiannessName((wxEndianness)endian) );
}

object WXEUAPI get_endianness_name()
{
	return get_sequence( wxPlatformInfo::Get().GetEndiannessName());
}

object WXEUAPI get_os_major_version()
{
	return BOX_INT(wxPlatformInfo::Get().GetOSMajorVersion());
}

object WXEUAPI get_os_minor_version()
{
	return BOX_INT(wxPlatformInfo::Get().GetOSMinorVersion());
}

object WXEUAPI get_os_family_name_from_enum( int os )
{
	return get_sequence( wxPlatformInfo::GetOperatingSystemFamilyName((wxOperatingSystemId)os));
}

object WXEUAPI get_os_family_name()
{
	return get_sequence( wxPlatformInfo::Get().GetOperatingSystemFamilyName() );
}

object WXEUAPI get_os_id_from_name( object os )
{
	wxDeRefDS( os );
	return BOX_INT( wxPlatformInfo::GetOperatingSystemId( get_string( os ) ) );
}

object WXEUAPI get_os_id()
{
	return BOX_INT( wxPlatformInfo::Get().GetOperatingSystemId() );
}

object WXEUAPI get_os_id_name_from_enum( int os )
{
	return get_sequence( wxPlatformInfo::GetOperatingSystemIdName( (wxOperatingSystemId) os ) );
}

object WXEUAPI get_os_id_name()
{
	return get_sequence( wxPlatformInfo::Get().GetOperatingSystemIdName() );
}

object WXEUAPI get_port_id_from_name( object portname )
{
	wxDeRefDS( portname );
	return BOX_INT( wxPlatformInfo::GetPortId( get_string( portname ) ) );
}

object WXEUAPI get_port_id()
{
	return BOX_INT( wxPlatformInfo::Get().GetPortId() );
}

object WXEUAPI get_port_id_name_from_enum( int port, int using_universal )
{
	return get_sequence( wxPlatformInfo::GetPortIdName( (wxPortId) port, using_universal ) );
}

object WXEUAPI get_port_id_name()
{
	return get_sequence( wxPlatformInfo::Get().GetPortIdName() );
}

object WXEUAPI get_port_id_short_name_from_enum( int port, int using_universal )
{
	return get_sequence( wxPlatformInfo::GetPortIdShortName( (wxPortId) port, using_universal) );
}

object WXEUAPI get_port_id_short_name()
{
	return get_sequence( wxPlatformInfo::Get().GetPortIdShortName() );
}

object WXEUAPI get_toolkit_major_version()
{
	return BOX_INT( wxPlatformInfo::Get().GetToolkitMajorVersion() );
}

object WXEUAPI get_toolkit_minor_version()
{
	return BOX_INT( wxPlatformInfo::Get().GetToolkitMinorVersion() );
}

object WXEUAPI platform_info_ok()
{
	return 1 & wxPlatformInfo::Get().IsOk();
}

object WXEUAPI using_universal_widgets()
{
	return 1 & wxPlatformInfo::Get().IsUsingUniversalWidgets();
}


} // extern "C"
