// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include <wx/print.h>


extern "C"{
object WXEUAPI  new_wxPreviewFrame(object params)
{
/*
wxPreviewFrame(
1  wxPrintPreview* preview, 
2  wxWindow* parent, 
3  const wxString& title, 
45 const wxPoint& pos = wxDefaultPosition, 
67 const wxSize& size size = wxDefaultSize, 
8  intptr_t style = wxDEFAULT_FRAME_STYLE, 
const wxString& name = "frame")
*/
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	intptr_t style = wxDEFAULT_FRAME_STYLE;
	switch( LENGTH(params) ){
		case 10:
		case 9:
		case 8:
			style = get_int( params, 8 );
		case 7:
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );
		case 6:
		case 5:
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5) );

		default:
			break;
	}
	wxPreviewFrame * frame = new wxPreviewFrame( (wxPrintPreview *)get_int(params, 1),
			(wxWindow*)get_int(params, 2), get_string( params, 3 ), pos, size, style );
	wxDeRefDS( params );
	return BOX_INT( frame );
}




object WXEUAPI  get_printout_dc(intptr_t printout)
{
	return BOX_INT( ((wxPrintout*)printout)->GetDC() );
}




typedef object WXEUAPI (*euPreparePrinting)(wxPrintout&);
typedef object WXEUAPI (*euPrintPage)(wxPrintout&,int);

class euPrintout : public wxPrintout{
	public:
		euPrintout(const wxString& title = wxT("Printout"), int prepare=-1, int print=-1) :
			wxPrintout(title)
		{
			_minPage = 0;
			_maxPage = 0;
			prepare_rid = prepare;
			print_page_rid = print;
		}
		
		virtual void OnPreparePrinting();
		virtual bool OnPrintPage(int pageNum );
		virtual bool HasPage(int pageNum );
		virtual void GetPageInfo(int *minPage, int *maxPage, int *pageFrom, int *pageTo);
		int prepare_rid;
		int print_page_rid;

		int _minPage;
		int _maxPage;
};

void WXEUAPI  set_page_info(intptr_t printout, int min, int max)
{
	((euPrintout*)printout)->_maxPage = max;
	((euPrintout*)printout)->_minPage = min;
}

void euPrintout::GetPageInfo(int *minPage, int *maxPage, int *pageFrom, int *pageTo)
{
	*minPage = _minPage;
	*maxPage = _maxPage;
	*pageFrom = _minPage;
	*pageTo = _maxPage;
}

bool euPrintout::HasPage( int pageNum )
{
	if( pageNum >= _minPage && pageNum <= _maxPage )
		return true;
	else
		return false;
}

bool euPrintout::OnPrintPage(int pageNum )
{
	s1_ptr s = NewS1(3);
	s->base[1] = BOX_INT(this);
	s->base[2] = pageNum;
	s->base[3] = BOX_INT( GetDC() );
	EuApp::the_object = MAKE_SEQ( s );
	return EuApp::callFunc( print_page_rid );
	
}

void euPrintout::OnPreparePrinting()
{
	if( prepare_rid == -1 ) return;
	s1_ptr s = NewS1(1);
	s->base[1] = BOX_INT(this);
	EuApp::proc( prepare_rid, MAKE_SEQ( s ) );
}

object WXEUAPI  new_wxPrintout(object params)
{
	wxString title(wxT("Printout"));
	int prepare_rid = -1;
	int print_page_rid = -1;
	
	switch( LENGTH( params ) ){
		case 3:
			print_page_rid = get_int( params, 3 );
		case 2:
			print_page_rid = get_int( params, 2 );
		case 1:
			title = get_string( params, 1 );
		default:
			break;
	}

	wxDeRefDS( params );

	return BOX_INT( new euPrintout( title, prepare_rid, print_page_rid ) );
}

object WXEUAPI  get_preview_frame(intptr_t preview)
{
	return BOX_INT( ((wxPrintPreview*)preview)->GetFrame() );
}

void WXEUAPI  set_preview_frame(intptr_t preview, intptr_t frame)
{
	((wxPrintPreview*)preview)->SetFrame( (wxFrame*)frame );
}

object WXEUAPI  new_wxPrintPreview(object params)
{
//wxPrintPreview(wxPrintout* printout, wxPrintout* printoutForPrinting, wxPrintData* data=NULL)
	wxPrintData *data = NULL;
	if( LENGTH( params ) == 3 ) data = (wxPrintData*) get_int( params, 3 );
	
	wxPrintPreview * preview = new wxPrintPreview( (wxPrintout*)get_int(params, 1),
		(wxPrintout*) get_int( params, 2 ), data );
	wxDeRefDS( params );
	return BOX_INT( preview );
}

object WXEUAPI  get_ppi_printer(intptr_t printout)
{
	int w, h;
	((wxPrintout*)printout)->GetPPIPrinter(&w, &h);
	
	s1_ptr s = NewS1( 2 );
	s->base[1] = w;
	s->base[2] = h;
	return MAKE_SEQ( s );
}

object WXEUAPI  get_ppi_screen(intptr_t printout)
{
	int w, h;
	((wxPrintout*)printout)->GetPPIScreen(&w, &h);
	
	s1_ptr s = NewS1( 2 );
	s->base[1] = w;
	s->base[2] = h;
	return MAKE_SEQ( s );
}

object WXEUAPI  get_page_pixels(intptr_t printout)
{
	int w, h;
	((wxPrintout*)printout)->GetPageSizePixels(&w, &h);
	
	s1_ptr s = NewS1( 2 );
	s->base[1] = w;
	s->base[2] = h;
	return MAKE_SEQ( s );
}

object WXEUAPI  get_page_mm(intptr_t printout)
{
	int w, h;
	((wxPrintout*)printout)->GetPageSizeMM(&w, &h);
	
	s1_ptr s = NewS1( 2 );
	s->base[1] = w;
	s->base[2] = h;
	return MAKE_SEQ( s );
}

object WXEUAPI  is_preview(intptr_t printout)
{
	return ((wxPrintout*)printout)->IsPreview();
}

object WXEUAPI  start_print(intptr_t printer, intptr_t parent, intptr_t printout, int prompt)
{
	return ((wxPrinter*)printer)->Print( (wxWindow*)parent, (wxPrintout*)printout, prompt );
}

object WXEUAPI new_wxPrinter( object params )
{
	wxDeRefDS( params );
	wxPrintDialogData * data = 0;
	
	if( LENGTH( params ) ){
		data = (wxPrintDialogData*) get_int( params, 1 );
	}
	
	return BOX_INT( new wxPrinter( data ) );
}

object WXEUAPI  get_zoom(intptr_t preview)
{
	return ((wxPrintPreview*)preview)->GetZoom();
}

}
