// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/process.h"


extern "C"{
object WXEUAPI  wx_execute(object command, int flag)
{
	object ret = wxExecute( get_string( command ), flag, (wxProcess*)NULL );
	wxDeRefDS( command );
	return ret;
}

void WXEUAPI  wx_shell(object command)
{
	wxShell( get_string( command ) );
	wxDeRefDS( command );
}

class EuProcess : public wxProcess
{
private:
	int m_rid;
	intptr_t m_parent;
	
public:
	EuProcess(wxFrame* parent, int id, int rtn_id)
		: wxProcess(parent, id)
		{
			m_rid = rtn_id;
			m_parent = (intptr_t)parent;
		}

	void OnTerminate( intptr_t pid, int status )
	{
		if( m_rid == -1 ){
			return;
		}
		s1_ptr s = NewS1( 3 );
		s->base[1] = BOX_INT( m_parent );
		s->base[2] = BOX_INT( pid );
		s->base[3] = BOX_INT( status );
		EuApp::wxEuApp->proc( m_rid, MAKE_SEQ( s ) );
	}
};

object WXEUAPI new_wxProcess(object params)
{
	intptr_t parent = get_int( params, 1 );
	int id = get_int( params, 2 );
	int rtn_id = get_int( params, 3 );
	EuProcess * ps = new EuProcess( (wxFrame*)parent, id, rtn_id );
	
	wxDeRefDS( params );
	return BOX_INT( ps );
}

object WXEUAPI  start_process(intptr_t id, object cmd, int flag)
{
	object ret = wxExecute( get_string(cmd), flag, (EuProcess*)id );
	wxDeRefDS( cmd );
	return ret;
}

void WXEUAPI close_process_output(intptr_t id)
{
	((EuProcess*)id)->CloseOutput();
}

void WXEUAPI detach_process(intptr_t id)
{
	((EuProcess*)id)->Detach();
}

object WXEUAPI process_error_stream(intptr_t id)
{
	wxInputStream * stream = ((EuProcess*)id)->GetErrorStream();
	return BOX_INT(stream);
}

object WXEUAPI process_input_stream(intptr_t id)
{
	wxInputStream * stream = ((EuProcess*)id)->GetInputStream();
	return BOX_INT(stream);
}

object WXEUAPI process_output_stream(intptr_t id)
{
	wxOutputStream * stream = ((EuProcess*)id)->GetOutputStream();
	return BOX_INT(stream);
}

object WXEUAPI process_error_available(intptr_t id)
{
	return ((EuProcess*)id)->IsErrorAvailable();
}

object WXEUAPI process_input_available(intptr_t id)
{
	return ((EuProcess*)id)->IsInputAvailable();
}

object WXEUAPI process_input_opened(intptr_t id)
{
	return ((EuProcess*)id)->IsInputOpened();
}

object WXEUAPI kill_process(intptr_t id, int signal, int flags)
{
	return EuProcess::Kill( id, (wxSignal)signal, flags );
}

object WXEUAPI process_exists(intptr_t pid)
{
	return wxProcess::Exists( pid );
}

object WXEUAPI get_pid(intptr_t id)
{
	intptr_t pid = ((EuProcess*)id)->GetPid();
	return BOX_INT(pid);
}

void WXEUAPI process_redirect(intptr_t id)
{
	((EuProcess*)id)->Redirect();
}

object WXEUAPI process_event_pid(intptr_t event)
{
	return ((wxProcessEvent*)event)->GetPid();
}

object WXEUAPI process_event_exitcode(intptr_t event)
{
	return ((wxProcessEvent*)event)->GetExitCode();
}

}
