// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include <wx/regex.h>


extern "C"{

object WXEUAPI new_wxRegEx( object params )
{
	wxRegEx * regex;
	if( LENGTH( params ) ){
		int flags = wxRE_DEFAULT;
		if( LENGTH(params) > 1 ) flags = get_int( params, 2 );
		regex = new wxRegEx( get_string( params, 1), flags );
	}
	else{
		regex = new wxRegEx();
	}
	wxDeRefDS( params );

	return BOX_INT( regex );
		
}

void WXEUAPI delete_wxRegEx( object obj ){
	DELETE_INSTANCE( wxRegEx, obj )
}

object WXEUAPI compile_regex( intptr_t regex, object pattern, int flags )
{
	wxString pat = get_string( pattern );
	wxDeRefDS( pattern );
	return ((wxRegEx*)regex)->Compile( pat, flags );
}

object WXEUAPI regex_matches( intptr_t regex, object text, int flags )
{
	wxString chars = get_string( text );
	wxDeRefDS( text );
	return ((wxRegEx*)regex)->Matches( chars, flags );
}

object WXEUAPI get_match_count( intptr_t regex )
{
	return ((wxRegEx*)regex)->GetMatchCount();
}

object WXEUAPI get_match( intptr_t regex, object text, int index )
{
	wxString string = get_string( text );

	wxString match = ((wxRegEx*)regex)->GetMatch( string, index );
	wxDeRefDS( text );
	return get_sequence( match );
}

object WXEUAPI is_valid_regex( intptr_t regex )
{
	return ((wxRegEx*)regex)->IsValid();
}


object WXEUAPI replace_regex( intptr_t regex, object text, object replacement, int max_matches, int in_place )
{
	wxString txt = get_string( text );
	wxString rep = get_string( replacement );


	int replaced = ((wxRegEx*)regex)->Replace( &txt, rep, max_matches );
	
	text = get_sequence( txt );
	if( in_place ) return text;
	s1_ptr s = NewS1( 2 );
	s->base[1] = replaced;
	s->base[2] = text;
	
	wxDeRefDS( text );
	wxDeRefDS( replacement );
	
	return MAKE_SEQ( s );
}

}
