// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include "wx/richtext/richtextctrl.h"
#include "wx/richtext/richtextbuffer.h"
#include "wx/richtext/richtextprint.h"

extern "C" {

object WXEUAPI new_wxRichTextCtrl( object params )
{
        NEW_CONTROL_STYLE( wxRichTextCtrl, rich, wxRE_MULTILINE );
}

object WXEUAPI write_image( intptr_t rich, intptr_t image, int bitmap_type )
{
        return 1 & ((wxRichTextCtrl*)rich)->WriteImage( *(wxImage*)image, bitmap_type );
}

object WXEUAPI write_image_from_file( intptr_t rich, object filename, int bitmap_type )
{
        wxDeRefDS( filename );
        return 1 & ((wxRichTextCtrl*)rich)->WriteImage( get_string( filename ), bitmap_type );
}

object WXEUAPI write_image_block( intptr_t rich, intptr_t image_block ){
        return 1 & ((wxRichTextCtrl*)rich)->WriteImage( *(wxRichTextImageBlock*)image_block);
}

void WXEUAPI new_line( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->Newline();
}

void WXEUAPI line_break( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->LineBreak();
}

void WXEUAPI set_basic_rich_style( intptr_t rich, intptr_t style )
{
        ((wxRichTextCtrl*)rich)->SetBasicStyle( *(wxRichTextAttr*) style );
}

void WXEUAPI set_basic_rich_text_style( intptr_t rich, intptr_t style )
{
        ((wxRichTextCtrl*)rich)->SetBasicStyle( *(wxTextAttrEx*)style);
}

object WXEUAPI get_basic_rich_style( intptr_t rich )
{
        return  BOX_INT( new wxTextAttrEx(((wxRichTextCtrl*)rich)->GetBasicStyle() ) );
}

void WXEUAPI begin_rich_style( intptr_t rich, intptr_t style )
{
        ((wxRichTextCtrl*)rich)->BeginStyle( *(wxTextAttrEx*)style);
}

void WXEUAPI end_rich_style( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndStyle();
}

void WXEUAPI end_all_rich_styles( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndAllStyles();
}

void WXEUAPI begin_bold( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->BeginBold();
}

void WXEUAPI end_bold( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndBold();
}

void WXEUAPI begin_italic( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->BeginItalic();
}

void WXEUAPI end_italic( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndItalic();
}

void WXEUAPI begin_underline( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->BeginUnderline();
}

void WXEUAPI end_underline( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndUnderline();
}

void WXEUAPI begin_font_size( intptr_t rich, int size )
{
        ((wxRichTextCtrl*)rich)->BeginFontSize( size );
}

void WXEUAPI end_font_size( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndFontSize();
}

void WXEUAPI begin_font( intptr_t rich, intptr_t font )
{
        ((wxRichTextCtrl*)rich)->BeginFont( *(wxFont*)font );
}

void WXEUAPI end_font( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndFont();
}

void WXEUAPI begin_text_color( intptr_t rich, intptr_t color )
{
        ((wxRichTextCtrl*)rich)->BeginTextColour( *(wxColour*)color );
}

void WXEUAPI end_text_color( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndTextColour();
}

void WXEUAPI begin_alignment( intptr_t rich, int align )
{
        ((wxRichTextCtrl*)rich)->BeginAlignment( (wxTextAttrAlignment) align );
}

void WXEUAPI end_alignment( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndAlignment();
}

void WXEUAPI begin_left_indent( intptr_t rich, int indent, int sub_indent )
{
        ((wxRichTextCtrl*)rich)->BeginLeftIndent( indent, sub_indent );
}

void WXEUAPI end_left_indent( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndLeftIndent();
}

void WXEUAPI begin_right_indent( intptr_t rich, int indent )
{
        ((wxRichTextCtrl*)rich)->BeginRightIndent( indent );
}

void WXEUAPI end_right_indent( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndRightIndent();
}

void WXEUAPI begin_paragraph_spacing( intptr_t rich, int before, int after )
{
        ((wxRichTextCtrl*)rich)->BeginParagraphSpacing( before, after );
}

void WXEUAPI end_paragraph_spacing( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndParagraphSpacing();
}

void WXEUAPI begin_line_spacing( intptr_t rich, int spacing )
{
        ((wxRichTextCtrl*)rich)->BeginLineSpacing( spacing );
}

void WXEUAPI end_line_spacing( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndLineSpacing();
}

void WXEUAPI begin_numbered_bullet( intptr_t rich, int number, int indent, int sub_indent, intptr_t style )
{
        ((wxRichTextCtrl*)rich)->BeginNumberedBullet( number, indent, sub_indent, style );
}

void WXEUAPI end_numbered_bullet( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndNumberedBullet();
}

void WXEUAPI begin_symbol_bullet( intptr_t rich, object symbol, int indent, int sub_indent, intptr_t style )
{
        wxDeRefDS( symbol );
        ((wxRichTextCtrl*)rich)->BeginSymbolBullet( get_string( symbol ), indent, sub_indent, style );
}

void WXEUAPI end_symbol_bullet( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndSymbolBullet();
}

void WXEUAPI begin_standard_bullet( intptr_t rich, object bullet_name, int indent, int sub_indent, intptr_t style )
{
        ((wxRichTextCtrl*)rich)->BeginStandardBullet( get_string( bullet_name), indent, sub_indent, style );
}

void WXEUAPI end_standard_bullet( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndStandardBullet();
}

void WXEUAPI begin_char_style( intptr_t rich, object named_style )
{
        wxDeRefDS( named_style );
        ((wxRichTextCtrl*)rich)->BeginCharacterStyle( get_string( named_style ) );
}

void WXEUAPI end_char_style( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndCharacterStyle();
}

void WXEUAPI begin_paragraph_style( intptr_t rich, object named_style )
{
        wxDeRefDS( named_style );
        ((wxRichTextCtrl*)rich)->BeginParagraphStyle( get_string( named_style ) );
}

void WXEUAPI end_paragraph_style( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndParagraphStyle();
}

void WXEUAPI begin_list_style( intptr_t rich, object named_style, int level, int number )
{
        wxDeRefDS( named_style );
        ((wxRichTextCtrl*)rich)->BeginListStyle( get_string( named_style ), level, number );
}

void WXEUAPI end_list_style( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndListStyle();
}

void WXEUAPI begin_url( intptr_t rich, object url, object style )
{
        wxDeRefDS( url );
        wxDeRefDS( style );
        ((wxRichTextCtrl*)rich)->BeginURL( get_string( url ), get_string( style ) );
}

void WXEUAPI end_url( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndURL();
}

void WXEUAPI set_default_style_to_cursor_style( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->SetDefaultStyleToCursorStyle( );
}

void WXEUAPI select_none( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->SelectNone();
}

void WXEUAPI select_word( intptr_t rich, int pos )
{
        ((wxRichTextCtrl*)rich)->SelectWord( pos );
}

object WXEUAPI get_rich_selection_range( intptr_t rich )
{
        wxRichTextRange range = ((wxRichTextCtrl*)rich)->GetSelectionRange();
        s1_ptr r = NewS1( 2 );
        r->base[1] = BOX_INT(range.GetStart());
        r->base[2] = BOX_INT(range.GetEnd());
        return MAKE_SEQ( r );
}

void WXEUAPI set_rich_selection_range( intptr_t rich, int start, int end )
{
        ((wxRichTextCtrl*)rich)->SetSelectionRange( wxRichTextRange( start, end ) );
}

object WXEUAPI get_rich_internal_selection_range( intptr_t rich )
{
        wxRichTextRange range = ((wxRichTextCtrl*)rich)->GetInternalSelectionRange();
        s1_ptr r = NewS1(2);
        r->base[1] = BOX_INT( range.GetStart() );
        r->base[2] = BOX_INT( range.GetEnd() );
        return MAKE_SEQ( r );
}

void WXEUAPI set_rich_internal_selection_range( intptr_t rich, int start, int end )
{
        ((wxRichTextCtrl*)rich)->SetInternalSelectionRange( wxRichTextRange( start, end ) );
}

object WXEUAPI add_paragraph( intptr_t rich, object text )
{
        wxDeRefDS( text );
        wxRichTextRange range = ((wxRichTextCtrl*)rich)->AddParagraph( get_string( text ) );
        s1_ptr r = NewS1( 2 );
        r->base[1] = BOX_INT( range.GetStart() );
        r->base[2] = BOX_INT( range.GetEnd() );
        return MAKE_SEQ( r );
}

object WXEUAPI add_rich_image( intptr_t rich, intptr_t image )
{
        wxRichTextRange range = ((wxRichTextCtrl*)rich)->AddImage( *(wxImage*) image );
        s1_ptr r = NewS1( 2 );
        r->base[1] = BOX_INT( range.GetStart() );
        r->base[2] = BOX_INT( range.GetEnd() );
        return MAKE_SEQ( r );
}

void WXEUAPI layout_rich_content( intptr_t rich, int only_visible )
{
        ((wxRichTextCtrl*)rich)->LayoutContent( only_visible );
}

void WXEUAPI move_rich_caret( intptr_t rich, int pos, int at_start )
{
        ((wxRichTextCtrl*)rich)->MoveCaret( pos, at_start );
}

void WXEUAPI move_right( intptr_t rich, int n_pos, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveRight( n_pos, flags );
}

void WXEUAPI move_left(intptr_t rich, int n_pos, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveLeft( n_pos, flags );
}

void WXEUAPI move_up(intptr_t rich, int n_pos, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveUp( n_pos, flags );
}
void WXEUAPI move_down(intptr_t rich, int n_pos, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveDown( n_pos, flags );
}

void WXEUAPI move_to_line_end( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveToLineEnd( flags );
}

void WXEUAPI move_to_line_start( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveToLineStart( flags );
}

void WXEUAPI move_to_paragraph_end( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveToParagraphEnd( flags );
}

void WXEUAPI move_to_paragraph_start( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveToParagraphStart( flags );
}

void WXEUAPI move_home( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveHome( flags );
}

void WXEUAPI move_end( intptr_t rich, int flags )
{
        ((wxRichTextCtrl*)rich)->MoveEnd( flags );
}

void WXEUAPI page_up( intptr_t rich, int pages, int flags )
{
        ((wxRichTextCtrl*)rich)->PageUp( pages, flags );
}

void WXEUAPI page_down( intptr_t rich, int pages, int flags )
{
        ((wxRichTextCtrl*)rich)->PageDown( pages, flags );
}

void WXEUAPI word_left( intptr_t rich, int words, int flags )
{
        ((wxRichTextCtrl*)rich)->WordLeft( words, flags );
}

void WXEUAPI word_right( intptr_t rich, int words, int flags )
{
        ((wxRichTextCtrl*)rich)->WordRight( words, flags );
}

void WXEUAPI begin_batch_undo( intptr_t rich, object cmd_name )
{
        wxDeRefDS( cmd_name );
        ((wxRichTextCtrl*)rich)->BeginBatchUndo( get_string( cmd_name ) );
}

void WXEUAPI end_batch_undo( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndBatchUndo();
}

object WXEUAPI batching_undo( intptr_t rich )
{
        return 1 & ((wxRichTextCtrl*)rich)->BatchingUndo();
}

void WXEUAPI begin_suppress_undo( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->BeginSuppressUndo();
}

object WXEUAPI suppressing_undo( intptr_t rich )
{
        return 1 & ((wxRichTextCtrl*)rich)->SuppressingUndo();
}

void WXEUAPI end_suppress_undo( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->EndSuppressUndo();
}

object WXEUAPI get_buffer( intptr_t rich )
{
        wxRichTextBuffer buffer = ((wxRichTextCtrl*)rich)->GetBuffer();
        return BOX_INT( new wxRichTextBuffer( buffer ) );
}

object WXEUAPI has_char_text_attr( intptr_t rich, int first, int last, intptr_t text_attr_ex )
{
        return 1 & ((wxRichTextCtrl*)rich)->HasCharacterAttributes( wxRichTextRange( first, last ).ToInternal(),
                *(wxTextAttrEx*) text_attr_ex );
}

object WXEUAPI has_char_rich_attr( intptr_t rich, int first, int last, intptr_t rich_attr )
{
        return 1 & ((wxRichTextCtrl*)rich)->HasCharacterAttributes( 
                wxRichTextRange( first, last ).ToInternal(),
                *(wxRichTextAttr*) rich_attr );
}

object WXEUAPI has_para_text_attr( intptr_t rich, int first, int last, intptr_t text_attr_ex )
{
        return 1 & ((wxRichTextCtrl*)rich)->HasParagraphAttributes( wxRichTextRange( first, last ).ToInternal(),
                        *(wxTextAttrEx*) text_attr_ex );
}

object WXEUAPI has_para_char_attr( intptr_t rich, int first, int last, intptr_t rich_attr )
{
        return 1 & ((wxRichTextCtrl*)rich)->HasParagraphAttributes( wxRichTextRange( first, last ).ToInternal(),
                *(wxRichTextAttr*) rich_attr );
}

object WXEUAPI is_selection_bold( intptr_t rich )
{
        return 1 & ((wxRichTextCtrl*)rich)->IsSelectionBold();
}

object WXEUAPI is_selection_italics( intptr_t rich )
{
        return 1 & ((wxRichTextCtrl*)rich)->IsSelectionItalics();
}

object WXEUAPI is_selection_underlined( intptr_t rich )
{
        return 1 & ((wxRichTextCtrl*)rich)->IsSelectionUnderlined();
}

object WXEUAPI is_selection_aligned( intptr_t rich, int alignment )
{
        return 1 & ((wxRichTextCtrl*)rich)->IsSelectionAligned( (wxTextAttrAlignment) alignment );
}

void WXEUAPI apply_bold_to_selection( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->ApplyBoldToSelection();
}

void WXEUAPI apply_italic_to_selection( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->ApplyItalicToSelection();
}

void WXEUAPI apply_underline_to_selection( intptr_t rich )
{
        ((wxRichTextCtrl*)rich)->ApplyUnderlineToSelection();
}

void WXEUAPI apply_alignment_to_selection( intptr_t rich, int alignment )
{
        ((wxRichTextCtrl*)rich)->ApplyAlignmentToSelection( (wxTextAttrAlignment) alignment );
}

void WXEUAPI apply_rich_style( intptr_t rich, intptr_t style_def )
{
        ((wxRichTextCtrl*)rich)->ApplyStyle( (wxRichTextStyleDefinition*) style_def );
}

void WXEUAPI set_rich_style_sheet( intptr_t rich, intptr_t style_sheet )
{
        ((wxRichTextCtrl*)rich)->SetStyleSheet( (wxRichTextStyleSheet*) style_sheet );
}

object WXEUAPI get_rich_style_sheet( intptr_t rich )
{
        return BOX_INT( ((wxRichTextCtrl*)rich)->GetStyleSheet() );
}

void WXEUAPI push_rich_style_sheet( intptr_t rich, intptr_t style_sheet )
{
        ((wxRichTextCtrl*)rich)->PushStyleSheet( (wxRichTextStyleSheet*) style_sheet );
}

object WXEUAPI pop_rich_style_sheet( intptr_t rich )
{
        return BOX_INT( ((wxRichTextCtrl*)rich)->PopStyleSheet() );
}

void WXEUAPI apply_rich_style_sheet( intptr_t rich, intptr_t style_sheet )
{
        ((wxRichTextCtrl*)rich)->ApplyStyleSheet( (wxRichTextStyleSheet*) style_sheet );
}

object WXEUAPI get_position_rich_event( intptr_t event )
{
        return BOX_INT( ((wxRichTextEvent*)event)->GetPosition() );
}

object WXEUAPI get_rich_event_flags( intptr_t event )
{
        return BOX_INT( ((wxRichTextEvent*)event)->GetFlags() );
}

object WXEUAPI get_rich_event_old_style_sheet( intptr_t event )
{
        return BOX_INT( ((wxRichTextEvent*)event)->GetOldStyleSheet() );
}

object WXEUAPI get_rich_event_new_style_sheet( intptr_t event )
{
        return BOX_INT( ((wxRichTextEvent*)event)->GetNewStyleSheet() );
}

object WXEUAPI get_rich_event_range( intptr_t event )
{
        wxRichTextRange range = ((wxRichTextEvent*)event)->GetRange();
        s1_ptr r = NewS1(2);
        r->base[1] = range.GetStart();
        r->base[2] = range.GetEnd();
        return MAKE_SEQ( r );
}

object WXEUAPI get_rich_event_char( intptr_t event )
{
        return BOX_INT( ((wxRichTextEvent*)event)->GetCharacter() );
}

object WXEUAPI new_wxRichTextAttr( object params )
{
        wxDeRefDS( params );
        wxTextAttrAlignment alignment = wxTEXT_ALIGNMENT_DEFAULT;
        wxColour colBack = wxNullColour;
        
        switch( LENGTH( params ) ){
        case 0:
                return BOX_INT( new wxRichTextAttr() );
        case 3:
                alignment = (wxTextAttrAlignment) get_int( params, 3 );
        case 2:
                colBack = *(wxColour*) get_int( params, 2 );
        default:
                return BOX_INT( new wxRichTextAttr( *(wxColour*)get_int( params, 1 ), colBack, alignment ) );
        }
}

object WXEUAPI rich_to_textex_attr( intptr_t attr )
{
        return BOX_INT( (wxTextAttrEx*) ((wxRichTextAttr*) attr) );
}

object WXEUAPI create_font_from_rich_attr( intptr_t attr )
{
        return BOX_INT( new wxFont( ((wxRichTextAttr*)attr)->CreateFont() ) );
}

object WXEUAPI get_rich_attr_font_attributes( intptr_t attr, intptr_t font )
{
        return 1 & ((wxRichTextAttr*)attr)->GetFontAttributes( *(wxFont*) font );
}

void WXEUAPI set_rich_attr_text_color( intptr_t attr, intptr_t color )
{
        ((wxRichTextAttr*)attr)->SetTextColour( *(wxColour*) color );
}

void WXEUAPI set_rich_attr_back_color( intptr_t attr, intptr_t color )
{
        ((wxRichTextAttr*)attr)->SetBackgroundColour( *(wxColour*) color );
}

void WXEUAPI set_rich_attr_alignment( intptr_t attr, int align )
{
        ((wxRichTextAttr*)attr)->SetAlignment( (wxTextAttrAlignment) align );
}

void WXEUAPI set_rich_attr_tabs( intptr_t attr, object tabs )
{
        wxArrayInt t;
        for( int i = 1; i <= LENGTH( tabs ); i++ )
                t.Add( get_int( tabs, i ) );
        
        ((wxRichTextAttr*)attr)->SetTabs( t );
}

void WXEUAPI set_rich_attr_left_indent( intptr_t attr, int indent, int sub_indent )
{
        ((wxRichTextAttr*)attr)->SetLeftIndent( indent, sub_indent );
}

void WXEUAPI set_rich_attr_right_indent( intptr_t attr, int indent )
{
        ((wxRichTextAttr*)attr)->SetRightIndent( indent );
}

void WXEUAPI set_rich_attr_font_size( intptr_t attr, int points )
{
        ((wxRichTextAttr*)attr)->SetFontSize( points );
}

void WXEUAPI set_rich_attr_font_style( intptr_t attr, intptr_t style )
{
        ((wxRichTextAttr*)attr)->SetFontStyle( style );
}

void WXEUAPI set_rich_attr_font_name( intptr_t attr, object name )
{
        wxDeRefDS( name );
        ((wxRichTextAttr*)attr)->SetFontFaceName( get_string( name ) );
}

void WXEUAPI set_rich_attr_underlined( intptr_t attr, int underline )
{
        ((wxRichTextAttr*)attr)->SetFontUnderlined( underline );
}

void WXEUAPI set_rich_attr_flags( intptr_t attr, int flags )
{
        ((wxRichTextAttr*)attr)->SetFlags( flags );
}

void WXEUAPI set_rich_attr_char_style( intptr_t attr, object style )
{
        ((wxRichTextAttr*)attr)->SetCharacterStyleName( get_string( style ) );
        wxDeRefDS( style );
}

void WXEUAPI set_rich_attr_para_style( intptr_t attr, object style )
{
        wxDeRefDS( style );
        ((wxRichTextAttr*)attr)->SetParagraphStyleName( get_string( style ) );
}

void WXEUAPI set_rich_attr_list_style( intptr_t attr, object style )
{
        wxDeRefDS( style );
        ((wxRichTextAttr*)attr)->SetListStyleName( get_string( style ) );
}

void WXEUAPI set_rich_attr_para_spacing_after( intptr_t attr, int space )
{
        ((wxRichTextAttr*)attr)->SetParagraphSpacingAfter( space );
}

void WXEUAPI set_rich_attr_para_spacing_before( intptr_t attr, int space )
{
        ((wxRichTextAttr*)attr)->SetParagraphSpacingBefore( space );
}

void WXEUAPI set_rich_attr_line_spacing( intptr_t attr, int space )
{
        ((wxRichTextAttr*)attr)->SetLineSpacing( space );
}

void WXEUAPI set_rich_attr_bullet_style( intptr_t attr, intptr_t style )
{
        ((wxRichTextAttr*)attr)->SetBulletStyle( style );
}

void WXEUAPI set_rich_attr_bullet_number( intptr_t attr, int number )
{
        ((wxRichTextAttr*)attr)->SetBulletNumber( number );
}

void WXEUAPI set_rich_attr_bullet_font( intptr_t attr, object font_name )
{
        ((wxRichTextAttr*)attr)->SetBulletFont( get_string( font_name ) );
        wxDeRefDS( font_name );
}

void WXEUAPI set_rich_attr_bullet_name( intptr_t attr, object name )
{
        wxDeRefDS( name );
        ((wxRichTextAttr*)attr)->SetBulletName( get_string( name ) );
}

void WXEUAPI set_rich_attr_url( intptr_t attr, object url )
{
        wxDeRefDS( url );
        ((wxRichTextAttr*)attr)->SetURL( get_string( url ) );
}

void WXEUAPI set_rich_attr_page_break( intptr_t attr, int page_break )
{
        ((wxRichTextAttr*)attr)->SetPageBreak( page_break );
}

void WXEUAPI set_rich_attr_effects( intptr_t attr, int effects )
{
        ((wxRichTextAttr*)attr)->SetTextEffects( effects );
}
        
void WXEUAPI set_rich_attr_effect_flags( intptr_t attr, int flags )
{
        ((wxRichTextAttr*)attr)->SetTextEffectFlags( flags );
}       

void WXEUAPI set_rich_attr_outline_level( intptr_t attr, int level )
{
        ((wxRichTextAttr*)attr)->SetOutlineLevel( level );
}

object WXEUAPI get_rich_attr_color( intptr_t attr )
{
        return BOX_INT( new wxColour( ((wxRichTextAttr*)attr)->GetTextColour() ) );
}

object WXEUAPI get_rich_attr_back_color( intptr_t attr )
{
        return BOX_INT( new wxColour( ((wxRichTextAttr*)attr)->GetBackgroundColour() ) );
}

object WXEUAPI get_rich_attr_alignment( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetAlignment() );
}

object WXEUAPI get_rich_attr_tabs( intptr_t attr )
{
        wxArrayInt tabs = ((wxRichTextAttr*)attr)->GetTabs();
        s1_ptr t = NewS1( tabs.GetCount() );
        
        for( int i = 0; i < tabs.GetCount(); i++){
                t->base[i+1] = tabs[i];
        }
        
        return MAKE_SEQ( t );
}

object WXEUAPI get_rich_attr_left_indent( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetLeftIndent() );
}

object WXEUAPI get_rich_attr_left_sub_indent( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetLeftSubIndent() );
}

object WXEUAPI get_rich_attr_right_indent( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetRightIndent() );
}

object WXEUAPI get_rich_attr_flags( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetFlags() );
}

object WXEUAPI get_rich_attr_font_size( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetFontSize() );
}


object WXEUAPI get_rich_attr_font_style( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetFontStyle() );
}

object WXEUAPI get_rich_attr_font_weight( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetFontWeight() );
}

object WXEUAPI get_rich_attr_underlined( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->GetFontUnderlined();
}

object WXEUAPI get_rich_attr_font_name( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetFontFaceName() );
}

object WXEUAPI get_rich_attr_char_style( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetCharacterStyleName() );
}

object WXEUAPI get_rich_attr_para_style( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetParagraphStyleName() );
}

object WXEUAPI get_rich_attr_list_style( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetListStyleName() );
}

object WXEUAPI get_rich_attr_para_spacing_after( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetParagraphSpacingAfter() );
}

object WXEUAPI get_rich_attr_para_spacing_before( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetParagraphSpacingBefore() );
}

object WXEUAPI get_rich_attr_line_spacing( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetLineSpacing() );
}

object WXEUAPI get_rich_attr_bullet_style( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetBulletStyle() );
}


object WXEUAPI get_rich_attr_bullet_number( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetBulletNumber() );
}

object WXEUAPI get_rich_attr_bullet_text( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetBulletText() );
}

object WXEUAPI get_rich_attr_bullet_font( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetBulletFont() );
}

object WXEUAPI get_rich_attr_bullet_name( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetBulletName() );
}

object WXEUAPI get_rich_attr_url( intptr_t attr )
{
        return get_sequence( ((wxRichTextAttr*)attr)->GetURL() );
}

object WXEUAPI get_rich_attr_effects( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetTextEffects() );
}

object WXEUAPI get_rich_attr_effect_flags( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetTextEffectFlags() );
}

object WXEUAPI get_rich_attr_outline_level( intptr_t attr )
{
        return BOX_INT( ((wxRichTextAttr*)attr)->GetOutlineLevel() );
}

object WXEUAPI has_text_color_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasTextColour();
}

object WXEUAPI has_back_color_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasBackgroundColour();
}

object WXEUAPI has_alignment_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasAlignment();
}

object WXEUAPI has_tabs_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasTabs();
}

object WXEUAPI has_left_indent_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasLeftIndent();
}

object WXEUAPI has_right_indent_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasRightIndent();
}

object WXEUAPI has_font_weight_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFontWeight();
}

object WXEUAPI has_font_size_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFontSize();
}

object WXEUAPI has_italic_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFontItalic();
}

object WXEUAPI has_underlined_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFontUnderlined();
}

object WXEUAPI has_font_name_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFontFaceName();
}

object WXEUAPI has_font_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFont();
}

object WXEUAPI has_para_spacing_after_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasParagraphSpacingAfter();
}

object WXEUAPI has_para_spacing_before_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasParagraphSpacingAfter();
}

object WXEUAPI has_line_spacing_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasLineSpacing();
}

object WXEUAPI has_char_style_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasCharacterStyleName();
}

object WXEUAPI has_para_style_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasParagraphStyleName();
}

object WXEUAPI has_list_style_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasListStyleName();
}

object WXEUAPI has_bullet_style_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasBulletStyle();
}

object WXEUAPI has_bullet_number_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasBulletNumber();
}

object WXEUAPI has_bullet_text_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasBulletText();
}

object WXEUAPI has_bullet_name_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasBulletName();
}

object WXEUAPI has_url_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasURL();
}

object WXEUAPI has_page_break_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasPageBreak();
}

object WXEUAPI has_effects_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasTextEffects();
}

object WXEUAPI has_effect_rich_attr( intptr_t attr, int effect )
{
        return 1 & ((wxRichTextAttr*)attr)->HasTextEffect(effect);
}

object WXEUAPI has_outline_level_rich_attr( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->HasOutlineLevel();
}

object WXEUAPI has_flag_rich_attr( intptr_t attr, int flag )
{
        return 1 & ((wxRichTextAttr*)attr)->HasFlag( flag);
}

object WXEUAPI is_rich_attr_char_style( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->IsCharacterStyle();
}

object WXEUAPI is_rich_attr_para_style( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->IsParagraphStyle();
}

object WXEUAPI is_rich_attr_default( intptr_t attr )
{
        return 1 & ((wxRichTextAttr*)attr)->IsDefault();
}

void WXEUAPI apply_rich_attr( intptr_t attr, intptr_t compare_with )
{
        ((wxRichTextAttr*)attr)->Apply( *(wxRichTextAttr*)attr, (wxRichTextAttr*)compare_with );
}

object WXEUAPI new_wxRichTextPrinting( object params )
{
        
        wxRichTextPrinting * richprint;
        wxString name = wxT("Printing");
        wxWindow * parentWindow = NULL;
        
        int len = ((s1_ptr)SEQ_PTR(params))->length;
        
        switch (len) {
            case 2:
                parentWindow = (wxWindow*)get_int(params, 2);
            case 1:
                name = get_string(params, 1);
            default:
                richprint = new wxRichTextPrinting( name, parentWindow );
        }
        
        wxDeRefDS( params );
        return BOX_INT( richprint );
}

object WXEUAPI get_richprint_footer_text( intptr_t richprint )
{
        wxString text = ((wxRichTextPrinting*)richprint)->GetFooterText();
        return get_sequence( text );
}

object WXEUAPI get_richprint_header_footer_data( intptr_t richprint )
{
        wxRichTextHeaderFooterData data = ((wxRichTextPrinting*)richprint)->GetHeaderFooterData();
        return BOX_INT( &data );
}

object WXEUAPI get_richprint_header_text( intptr_t richprint )
{
        wxString text = ((wxRichTextPrinting*)richprint)->GetHeaderText();
        return get_sequence( text );
}

object WXEUAPI get_richprint_page_setup_data( intptr_t richprint )
{
        wxPageSetupDialogData * data = ((wxRichTextPrinting*)richprint)->GetPageSetupData();
        return BOX_INT( data );
}

object WXEUAPI get_richprint_parent_window( intptr_t richprint )
{
        wxWindow * parent = ((wxRichTextPrinting*)richprint)->GetParentWindow();
        return BOX_INT( parent );
}

object WXEUAPI get_richprint_preview_rect( intptr_t richprint )
{
        wxRect rect = ((wxRichTextPrinting*)richprint)->GetPreviewRect();
        
        s1_ptr s = NewS1( 4 );
        s->base[1] = rect.x;
        s->base[2] = rect.y;
        s->base[3] = rect.width;
        s->base[4] = rect.height;
        
        return MAKE_SEQ( s );
}

object WXEUAPI get_richprint_print_data( intptr_t richprint )
{
        wxPrintData * data = ((wxRichTextPrinting*)richprint)->GetPrintData();
        return BOX_INT( data );
}

object WXEUAPI get_richprint_title( intptr_t richprint )
{
        wxString title = ((wxRichTextPrinting*)richprint)->GetTitle();
        return get_sequence( title );
}

void WXEUAPI show_richprint_page_setup( intptr_t richprint )
{
        ((wxRichTextPrinting*)richprint)->PageSetup();
}

void WXEUAPI show_richprint_preview_buffer( intptr_t richprint, intptr_t buffer )
{
        ((wxRichTextPrinting*)richprint)->PreviewBuffer( *((wxRichTextBuffer*)buffer) );
}

void WXEUAPI show_richprint_preview_file( intptr_t richprint, object richTextFile )
{
        wxDeRefDS( richTextFile );
        ((wxRichTextPrinting*)richprint)->PreviewFile( get_string(richTextFile) );
}

void WXEUAPI show_richprint_print_buffer( intptr_t richprint, intptr_t buffer )
{
        ((wxRichTextPrinting*)richprint)->PrintBuffer( *((wxRichTextBuffer*)buffer) );
}

void WXEUAPI show_richprint_print_file( intptr_t richprint, object richTextFile )
{
        wxDeRefDS( richTextFile );
        ((wxRichTextPrinting*)richprint)->PrintFile( get_string(richTextFile) );
}

void WXEUAPI set_richprint_footer_text( intptr_t richprint, object text, intptr_t page, intptr_t location )
{
        wxDeRefDS( text );
        ((wxRichTextPrinting*)richprint)->SetFooterText( get_string(text), (wxRichTextOddEvenPage)page, (wxRichTextPageLocation)location );
}

void WXEUAPI set_richprint_header_footer_data( intptr_t richprint, intptr_t data )
{
        ((wxRichTextPrinting*)richprint)->SetHeaderFooterData( *((wxRichTextHeaderFooterData*)data) );
}

void WXEUAPI set_richprint_header_footer_font( intptr_t richprint, intptr_t font )
{
        ((wxRichTextPrinting*)richprint)->SetHeaderFooterFont( *((wxFont*)font) );
}

void WXEUAPI set_richprint_header_footer_text_colour( intptr_t richprint, intptr_t colour )
{
        ((wxRichTextPrinting*)richprint)->SetHeaderFooterTextColour( *((wxColour*)colour) );
}

void WXEUAPI set_richprint_header_text( intptr_t richprint, object text, intptr_t page, intptr_t location )
{
        wxDeRefDS( text );
        ((wxRichTextPrinting*)richprint)->SetHeaderText( get_string(text), (wxRichTextOddEvenPage)page, (wxRichTextPageLocation)location );
}

void WXEUAPI set_richprint_page_setup_data( intptr_t richprint, intptr_t pageSetupData )
{
        ((wxRichTextPrinting*)richprint)->SetPageSetupData( *((wxPageSetupData*)pageSetupData) );
}

void WXEUAPI set_richprint_parent_window( intptr_t richprint, intptr_t parent )
{
        ((wxRichTextPrinting*)richprint)->SetParentWindow( (wxWindow*)parent );
}

void WXEUAPI set_richprint_preview_rect( intptr_t richprint, object rect )
{
        wxDeRefDS( rect );
        
        wxRect r = wxRect( get_int(rect, 1), get_int(rect, 2), get_int(rect, 3), get_int(rect, 4) );
        ((wxRichTextPrinting*)richprint)->SetPreviewRect( r );
}

void WXEUAPI set_richprint_print_data( intptr_t richprint, intptr_t printData )
{
        ((wxRichTextPrinting*)richprint)->SetPrintData( *((wxPrintData*)printData) );
}

void WXEUAPI show_richprint_on_first_page( intptr_t richprint, intptr_t show )
{
        ((wxRichTextPrinting*)richprint)->SetShowOnFirstPage( (bool)show );
}

void WXEUAPI set_richprint_title( intptr_t richprint, object title )
{
        wxDeRefDS( title );
        ((wxRichTextPrinting*)richprint)->SetTitle( get_string(title) );
}

}
