// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/slider.h"


extern "C"{
object WXEUAPI  new_wxScrollBar(object params)
{
	NEW_SIMPLE_CONTROL_STYLE(wxScrollBar, wxSB_HORIZONTAL)
}

void WXEUAPI  set_scrollbar(intptr_t scroll, int position, int thumbSize, int range, int pageSize, int refresh)
{
	((wxScrollBar *)scroll)->SetScrollbar( position, thumbSize, range, pageSize, refresh);
}

object WXEUAPI  get_scroll_position(intptr_t scroll)
{
	return ((wxScrollBar*)scroll)->GetThumbPosition();
}

void WXEUAPI  set_scroll_position(intptr_t scroll, int pos)
{
	((wxScrollBar*)scroll)->SetThumbPosition( pos );
}

object WXEUAPI  get_scroll_range(intptr_t scroll)
{
	return ((wxScrollBar*)scroll)->GetRange();
}

object WXEUAPI  get_scroll_page_size(intptr_t scroll)
{
	return ((wxScrollBar*)scroll)->GetPageSize();
}

object WXEUAPI  get_scroll_thumb_size(intptr_t scroll)
{
	return ((wxScrollBar*)scroll)->GetThumbSize();
}

object WXEUAPI  new_wxSlider(object params)
{
/*
--wxSlider(wxWindow* parent, 
--wxWindowID id, 
--int value , 
--int minValue, 
--int maxValue, 
--const wxPoint& point = wxDefaultPosition, 
--const wxSize& size = wxDefaultSize, 
--intptr_t style = wxSL_HORIZONTAL, 
*/
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	intptr_t style = wxSL_HORIZONTAL;
	wxDeRefDS( params );
	switch( len ){
		case 10:
			style = get_int( params, 10 );
		case 9:
			size = wxSize( get_int( params, 8 ), get_int( params, 9 ));
		case 8:
		case 7:
			pos = wxPoint( get_int( params, 6 ), get_int( params, 7 ));
		default:
			wxSlider * slider = new wxSlider( (wxWindow*)get_int( params, 1 ),
				(wxWindowID) get_int( params, 2 ), get_int( params, 3 ),
				get_int( params, 4 ), get_int( params, 5 ), pos, size, style );

			return BOX_INT( slider );
	}
}

object WXEUAPI  get_slide_value(intptr_t slider)
{
	return ((wxSlider*)slider)->GetValue();
}

void WXEUAPI  set_slide_value(intptr_t slider, int val)
{
	((wxSlider*)slider)->SetValue( val );
}

object WXEUAPI  new_wxScrolledWindow(object params)
{
/*
wxScrolledWindow(wxWindow* parent, wxWindowID id = -1, 
const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, 
intptr_t style = wxHSCROLL | wxVSCROLL, const wxString& name = wxT("scrolledWindow"))
*/
	NEW_SIMPLE_CONTROL_STYLE( wxScrolledWindow, wxHSCROLL | wxVSCROLL );
}

object WXEUAPI  calc_scrolled_position( intptr_t scrollwin, int x, int y )
{
	int xx, yy;
	s1_ptr seq = NewS1( 2 );
	
	((wxScrolledWindow *)scrollwin)->CalcScrolledPosition( x, y, &xx, &yy );
	seq->base[1] = xx;
	seq->base[2] = yy;
	
	return MAKE_SEQ( seq );
}

object WXEUAPI  calc_unscrolled_position( intptr_t scrollwin, int x, int y )
{
	int xx, yy;
	s1_ptr seq = NewS1( 2 );
	
	((wxScrolledWindow *)scrollwin)->CalcUnscrolledPosition( x, y, &xx, &yy );
	seq->base[1] = xx;
	seq->base[2] = yy;
	
	return MAKE_SEQ( seq );
}

void WXEUAPI  enable_scrolling( intptr_t scrollwin, int xScrolling, int yScrolling )
{
	((wxScrolledWindow *)scrollwin)->EnableScrolling( xScrolling, yScrolling );
}

void WXEUAPI  fit_inside( intptr_t scrollwin )
{
	((wxScrolledWindow *)scrollwin)->FitInside();
}

object WXEUAPI  get_scroll_pixels_per_unit( intptr_t scrollwin )
{
	int xUnit, yUnit;
	s1_ptr seq = NewS1( 2 );
	
	((wxScrolledWindow *)scrollwin)->GetScrollPixelsPerUnit( &xUnit, &yUnit );
	seq->base[1] = xUnit;
	seq->base[2] = yUnit;
	
	return MAKE_SEQ( seq );
}

object WXEUAPI  get_view_start( intptr_t scrollwin )
{
	int x, y;
	s1_ptr seq = NewS1( 2 );
	
	((wxScrolledWindow *)scrollwin)->GetViewStart( &x, &y );
	seq->base[1] = x;
	seq->base[2] = y;
	
	return MAKE_SEQ( seq );
}

object WXEUAPI  get_virtual_size( intptr_t scrollwin )
{
	int x, y;
	s1_ptr seq = NewS1( 2 );
	
	((wxScrolledWindow *)scrollwin)->GetVirtualSize( &x, &y );
	seq->base[1] = x;
	seq->base[2] = y;
	
	return MAKE_SEQ( seq );
}

object WXEUAPI  is_retained( intptr_t scrollwin )
{
	return ((wxScrolledWindow *)scrollwin)->IsRetained();
}

void WXEUAPI  prepare_dc( intptr_t scrollwin, intptr_t dc )
{
	((wxScrolledWindow *)scrollwin)->DoPrepareDC( *(wxDC*)dc );
}

void WXEUAPI  scroll_window( intptr_t scrollwin, int x, int y )
{
	((wxScrolledWindow *)scrollwin)->Scroll( x, y );
}

void WXEUAPI  set_scrollbars( intptr_t scrollwin, int pixelsPerUnitX, int pixelsPerUnitY, int noUnitsX, int noUnitsY, int xPos, int yPos, int noRefresh )
{
	((wxScrolledWindow *)scrollwin)->SetScrollbars( pixelsPerUnitX, pixelsPerUnitY, noUnitsX, noUnitsY, xPos, yPos, noRefresh );
}

void WXEUAPI  set_scroll_rate( intptr_t scrollwin, int xstep, int ystep )
{
	((wxScrolledWindow *)scrollwin)->SetScrollRate( xstep, ystep );
}

void WXEUAPI  set_target_window( intptr_t scrollwin, int target )
{
	((wxScrolledWindow *)scrollwin)->SetTargetWindow( (wxWindow *)target );
}

void WXEUAPI  set_virtual_size( intptr_t scrollwin, int width, int height )
{
	((wxScrolledWindow *)scrollwin)->SetVirtualSize( width, height );
}

object WXEUAPI  get_window_scroll_position(intptr_t window, int orient)
{
	return ((wxWindow*)window)->GetScrollPos(orient);
}

}
