// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "wx/sizer.h"
#include "alldefs.h"
#include "wxeu.h"

#include "wx/splitter.h"

extern "C"{

object WXEUAPI new_wxBoxSizer( object params )
{
	wxBoxSizer * sizer = new wxBoxSizer( get_int( params, 1 ) );
	wxDeRefDS( params );
	return BOX_INT( sizer );
}

object WXEUAPI new_wxStaticBoxSizer( object params )
{
	int len = LENGTH( params );
	wxDeRefDS( params );
	switch( len ){
		case 3:
			return BOX_INT( new wxStaticBoxSizer( 
			                    get_int( params, 1 ),
			                    (wxWindow*) get_int( params, 2 ),
			                    get_string( params, 3 )) );
		case 2:
			return BOX_INT( new wxStaticBoxSizer(
			                    (wxStaticBox*)get_int( params, 1 ),
			                    get_int( params, 2 ) ));
		default:
			return 0;
	}
}

void WXEUAPI  add_window_to_sizer(intptr_t sizer, intptr_t window, int option, int flag, int border)
{
	((wxSizer *)sizer)->Add( (wxWindow *) window, option, flag, border );
}

void WXEUAPI  add_sizer_to_sizer(intptr_t sizer, intptr_t window, int option, int flag, int border)
{
	((wxSizer *)sizer)->Add( (wxSizer *) window, option, flag, border );
}

void WXEUAPI  space_sizer(intptr_t sizer, int width, int height, int option, int flag, int border)
{
	((wxSizer*)sizer)->Add( width, height, option, flag, border );
}

void WXEUAPI  set_sizer(intptr_t window, intptr_t sizer)
{
	((wxWindow *)window)->SetSizer( (wxSizer *) sizer );
}

object WXEUAPI  new_wxSplitterWindow(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxSplitterWindow, wxSP_BORDER | wxSP_FULLSASH );
}

void WXEUAPI  split_window(intptr_t split, intptr_t win1, intptr_t win2, int orient, int pos)
{
	if( orient == wxHORIZONTAL ){
		((wxSplitterWindow*)split)->SplitHorizontally( (wxWindow*)win1,
			(wxWindow*)win2, pos );
	}
	else {
	((wxSplitterWindow*)split)->SplitVertically( (wxWindow*)win1,
			(wxWindow*)win2, pos );
	}
}

void WXEUAPI  set_min_pane_size(intptr_t split, int size)
{
	((wxSplitterWindow*)split)->SetMinimumPaneSize( size );
}

void WXEUAPI  set_splitter_sash_position(intptr_t split, int pos, int redraw)
{
	((wxSplitterWindow*)split)->SetSashPosition( pos, redraw );
}

object WXEUAPI  get_splitter_sash_position(intptr_t split)
{
	return BOX_INT( ((wxSplitterWindow*)split)->GetSashPosition());
}

object WXEUAPI  new_wxFlexGridSizer(object params)
{
	int vgap = 0;
	int hgap = 0;
	switch( LENGTH( params ) ){
		case 4:
			hgap = get_int( params, 4 );
		
		case 3:
			vgap = get_int( params, 3 );
		
		default:
			break;
	
	}
	wxFlexGridSizer * fgs = new wxFlexGridSizer( get_int( params, 1 ),
		get_int( params, 2 ), vgap, hgap );
	wxDeRefDS( params );
	return BOX_INT( fgs );
}

object WXEUAPI  fit_window(intptr_t sizer, intptr_t window)
{
	wxSize size = ((wxSizer*)sizer)->Fit( (wxWindow*)window );
	s1_ptr s = NewS1(2);
	s->base[1] = size.GetWidth();
	s->base[2] = size.GetHeight();
	return MAKE_SEQ( s );
}

object WXEUAPI  get_sizer_size(intptr_t sizer)
{
	wxSize size = ((wxSizer*)sizer)->GetSize();
	s1_ptr s = NewS1(2);
	s->base[1] = size.GetWidth();
	s->base[2] = size.GetHeight();
	return MAKE_SEQ( s );
}

object WXEUAPI  get_sizer_minsize(intptr_t sizer)
{
	wxSize size = ((wxSizer*)sizer)->GetMinSize();
	s1_ptr s = NewS1(2);
	s->base[1] = size.GetWidth();
	s->base[2] = size.GetHeight();
	return MAKE_SEQ( s );
}

object WXEUAPI  get_sizer_position(intptr_t sizer)
{
	wxPoint pos = ((wxSizer*)sizer)->GetPosition();
	s1_ptr s = NewS1(2);
	s->base[1] = pos.x;
	s->base[2] = pos.y;
	return MAKE_SEQ( s );
}

object WXEUAPI  sizer_calc_min(intptr_t sizer)
{
	wxSize size = ((wxSizer*)sizer)->CalcMin();
	s1_ptr s = NewS1(2);
	s->base[1] = size.GetWidth();
	s->base[2] = size.GetHeight();
	return MAKE_SEQ( s );
}

void WXEUAPI set_sash_gravity( intptr_t split, double gravity )
{
	((wxSplitterWindow*)split)->SetSashGravity( gravity );
}

object WXEUAPI get_sash_gravity( intptr_t split )
{
	return NewDouble( ((wxSplitterWindow*)split)->GetSashGravity() );
}

void WXEUAPI detatch_sizer( intptr_t sizer, int detatch )
{
	if( ((wxObject*)detatch)->IsKindOf( CLASSINFO(wxSizer) ) )
		((wxSizer*)sizer)->Detach( (wxSizer*) detatch );
	else
		((wxSizer*)sizer)->Detach( (wxWindow*) detatch);
}

object WXEUAPI get_sizer_window( intptr_t sizer )
{
	return BOX_INT( ((wxSizer*)sizer)->GetContainingWindow() );
}

object WXEUAPI sizer_item_shown( intptr_t sizer, intptr_t item )
{
	if( ((wxObject*)item)->IsKindOf( CLASSINFO( wxSizer ) ) )
		return 1 & ((wxSizer*)sizer)->IsShown((wxSizer*)item);
	else
		return 1 & ((wxSizer*)sizer)->IsShown((wxWindow*)item);
}

void WXEUAPI layout_sizer( intptr_t sizer )
{
	((wxSizer*)sizer)->Layout();
}

object WXEUAPI replace_sizer_item( intptr_t sizer, intptr_t old_item, intptr_t new_item, int recursive )
{
	if( ((wxObject*)old_item)->IsKindOf( CLASSINFO( wxSizer ) ) ){
		return 1 & ((wxSizer*)sizer)->Replace( (wxSizer*)old_item, (wxSizer*)new_item, recursive );
	}
	else{
		return 1 & ((wxSizer*)sizer)->Replace( (wxWindow*)old_item, (wxWindow*)new_item, recursive );
	}

}

void WXEUAPI show_sizer_item_sizer( intptr_t sizer, intptr_t item, int show, int recursive )
{
		((wxSizer*)sizer)->Show( (wxSizer*)item, show, recursive );
}

void WXEUAPI show_sizer_item_win( intptr_t sizer, intptr_t item, int show, int recursive )
{
		((wxSizer*)sizer)->Show( (wxWindow*)item, show, recursive );
}

object WXEUAPI split_event_get_sash_pos( intptr_t event )
{
	return BOX_INT( ((wxSplitterEvent*)event)->GetSashPosition() );
}

object WXEUAPI split_event_x( intptr_t event )
{
	return BOX_INT( ((wxSplitterEvent*)event)->GetX() );
}

object WXEUAPI split_event_y( intptr_t event )
{
	return BOX_INT( ((wxSplitterEvent*)event)->GetY() );
}

object WXEUAPI split_event_win_removed( intptr_t event )
{
	return BOX_INT( ((wxSplitterEvent*)event)->GetWindowBeingRemoved() );
}

void WXEUAPI split_event_set_sash_pos( intptr_t event, int pos )
{
	((wxSplitterEvent*)event)->SetSashPosition( pos );
}

void WXEUAPI unsplit_window( intptr_t split, intptr_t window )
{
	((wxSplitterWindow*)split)->Unsplit( ((wxWindow*)window) );
}

void WXEUAPI initialize_split( intptr_t split, intptr_t window )
{
	((wxSplitterWindow*)split)->Initialize( ((wxWindow*)window) );
}

object WXEUAPI new_wxStdDialogButtonSizer(object params)
{
	wxStdDialogButtonSizer * dbs = new wxStdDialogButtonSizer();
	wxDeRefDS( params );
	
	return BOX_INT( dbs );
}

void WXEUAPI add_button(intptr_t dbs, intptr_t button)
{
	((wxStdDialogButtonSizer*)dbs)->AddButton( (wxButton*)button );
}

void WXEUAPI realize(intptr_t dbs)
{
	((wxStdDialogButtonSizer*)dbs)->Realize();
}

object WXEUAPI get_window_sizer(intptr_t wnd)
{
	return BOX_INT( ((wxWindow*)wnd)->GetSizer() );
}

void WXEUAPI add_growable_col( intptr_t sizer, int idx, int proportion ){
	wxFlexGridSizer *flex = (wxFlexGridSizer*) sizer;
	flex->AddGrowableCol( (size_t)idx, proportion );
}

void WXEUAPI add_growable_row( intptr_t sizer, int idx, int proportion ){
	((wxFlexGridSizer*)sizer)->AddGrowableRow( (size_t)idx, proportion );
}

}
