// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include "wx/statbox.h"
#include "wx/statline.h"

extern "C"{
object WXEUAPI  new_wxStaticBox(object params)
{
	NEW_CONTROL_STYLE( wxStaticBox, box, 0 )
}

object WXEUAPI  new_wxStaticLine(object params)
{
	NEW_SIMPLE_CONTROL_STYLE( wxStaticLine, wxLI_HORIZONTAL )
}

object WXEUAPI  new_wxStaticText(object params)
{
	NEW_CONTROL(wxStaticText)
}

object WXEUAPI  new_wxStaticBitmap(object params)
{
/*
wxStaticBitmap(wxWindow* parent, 
wxWindowID id, 
const wxBitmap& label, 
*/
	wxPoint pos = wxDefaultPosition;
	wxSize size = wxDefaultSize;
	intptr_t style = 0;
	wxStaticBitmap * bmp;
	wxBitmap * bitmap = &wxNullBitmap;
	wxWindowID id = -1;
	
	switch( LENGTH(params) ){
		case 8:
			style = get_int( params, 8 );
			
		case 7:
			size = wxSize( get_int(params, 6), get_int(params, 7));
			
		case 6:
		case 5:
			pos = wxPoint( get_int(params, 4), get_int(params, 5) );
			
		case 4:
		case 3:
			bitmap = (wxBitmap*)get_int( params, 3 );
			
		case 2:
			id = get_int( params, 2 );
		
		default:
			bmp = new wxStaticBitmap( (wxWindow*) get_int( params, 1 ),
//				get_int( params, 2 ), *(wxBitmap*)get_int( params, 3 ),
//				pos, size, style );
				id, *bitmap, pos, size, style);
		
	}
	wxDeRefDS( params );
	return BOX_INT( bmp );
}

object WXEUAPI  get_staticbitmap(intptr_t staticbitmap)
{
	wxBitmap* bmp = new wxBitmap( ((wxStaticBitmap*)staticbitmap)->GetBitmap());
	return BOX_INT( bmp );
}

void WXEUAPI  set_staticbitmap(intptr_t staticbitmap, intptr_t bitmap)
{
	wxBitmap bmp = bitmap ? *reinterpret_cast<wxBitmap*>( bitmap ) : wxNullBitmap;
	((wxStaticBitmap*)staticbitmap)->SetBitmap( bmp );
}

}
