// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"



extern "C"{
void WXEUAPI  set_status_fields(intptr_t bar, object widths)
{

	int * widths_ptr;
	int len = ((s1_ptr)SEQ_PTR(widths))->length;
	widths_ptr = new int[len];
	for( int i = 0; i < len; i++ ){
		widths_ptr[i] = get_int( widths, i + 1 );
	}
	((wxStatusBar *)bar)->SetFieldsCount( len, widths_ptr );
	delete[] widths_ptr;
	wxDeRefDS(widths);
}


object WXEUAPI  new_wxStatusBar(object params)
{
/*
--wxStatusBar(
--1 wxWindow* parent, 
--2 wxWindowID id, 
--3 intptr_t style = wxST_SIZEGRIP, 
--4 const wxString& name = "statusBar")
*/

	wxFrame * frame = (wxFrame*) get_int( params, 1 );
	
	//virtual wxStatusBar* CreateStatusBar(int number = 1, intptr_t style = 0, 
	//wxWindowID id = -1, const wxString& name = "statusBar")
	int number = 1;
	intptr_t style = 0;
	wxWindowID id = -1;
	switch( LENGTH(params) ){
		case 4:
			id = get_int( params, 4 );
		case 3:
			style = get_int( params, 3 );
		case 2:
			number =  get_int( params, 2 );
		default:
			break;
	}
	wxStatusBar * bar = frame->CreateStatusBar( number, style, id );
	wxDeRefDS(params);
	return BOX_INT( bar );
}

void WXEUAPI  set_status_text(intptr_t bar, object text, int field)
{
	if( field >= ((wxStatusBar *)bar)->GetFieldsCount()){
		return;
	}
	
	wxString str = get_string( text );
	((wxStatusBar *)bar)->SetStatusText( str, field );
	wxDeRefDS(text);
}

object WXEUAPI get_status_fields_count( intptr_t bar )
{
	return BOX_INT( ((wxStatusBar*)bar)->GetFieldsCount());
}

object WXEUAPI get_status_text( intptr_t bar, int field )
{
	return get_sequence( ((wxStatusBar*)bar)->GetStatusText( field ) );
}

void WXEUAPI pop_status_text( intptr_t bar, int field )
{
	((wxStatusBar*)bar)->PopStatusText( field );
}

void WXEUAPI push_status_text( intptr_t bar, object text, int field )
{
	((wxStatusBar*)bar)->PushStatusText( get_string( text ), field );
}

void WXEUAPI set_min_status_height( intptr_t bar, int height )
{
	((wxStatusBar*)bar)->SetMinHeight( height );
}

void WXEUAPI set_status_styles( intptr_t bar, object styles )
{
	((wxStatusBar*)bar)->SetStatusStyles( LENGTH(styles), (int*) SEQ_PTR(styles)->base + 1 );
}

object WXEUAPI get_field_rect( intptr_t bar, int field )
{

	wxRect rect;
	s1_ptr seq;
	
	if ( ((wxStatusBar*)bar)->GetFieldRect(field, rect) ) {
		
		seq = NewS1( 4 );
		seq->base[1] = rect.x;
		seq->base[2] = rect.y;
		seq->base[3] = rect.width;
		seq->base[4] = rect.height;
		
	} else {
		seq = NewS1( 0 );
		
	}

	return MAKE_SEQ( seq );
}

}
