// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wx/toolbar.h"


extern "C"{
void WXEUAPI  set_tool_bitmap_size(intptr_t bar, int x, int y)
{
	wxSize size = wxSize( x, y );
	((wxToolBar *)bar)->SetToolBitmapSize( size );
}

void WXEUAPI  set_tool_margins(intptr_t toolbar, int x, int y)
{
	((wxToolBar*)toolbar)->SetMargins( x, y );
}

object WXEUAPI  new_wxToolBar(object params)
{
/*
--wxToolBar(wxWindow* parent, 
--wxWindowID id, 
--const wxPoint& pos = wxDefaultPosition, 
--const wxSize& size = wxDefaultSize, 
--intptr_t style = wxTB_HORIZONTAL | wxNO_BORDER, 
--const wxString& name = wxPanelNameStr)
*/

	intptr_t style = wxTB_HORIZONTAL | wxNO_BORDER;
	wxSize size = wxDefaultSize;
	wxPoint pos = wxDefaultPosition;
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	wxToolBar * bar;
	
	wxDeRefDS( params );
	
	switch( len ){
		case 7:
			style = get_int( params, 7 );
		
		case 6:
			size = wxSize( get_int( params, 5), get_int( params, 6) );
		
		case 5:
		case 4:
			pos = wxPoint( get_int( params, 3 ), get_int( params, 4 ) );
		
		default:
			bar = new wxToolBar( (wxWindow *) get_int( params, 1), (wxWindowID)get_int( params, 2 ),
				pos, size, style );
			return BOX_INT( bar );
	}
}

object WXEUAPI  new_wxToolBarItem(object params)
{
	int bar, id, kind;
	wxBitmap b1, b2;
	wxString lbl, sp1, sp2;
	wxToolBarToolBase * tool;
	
	int len = ((s1_ptr)SEQ_PTR(params))->length;
	b1 = wxNullBitmap;
	b2 = wxNullBitmap;
	kind = (int)wxITEM_NORMAL;
	sp1 = wxT("");
	sp2 = wxT("");
	
	switch( len ) {
		
		case 8:
			sp2 = get_string( params, 8 );
			
		case 7:
			sp1 = get_string( params, 7 );
			
		case 6:
			kind = get_int( params, 6 );
			
		case 5:
			if ( get_int(params, 5) != 0 ) {
				b2 = *( (wxBitmap*)get_int(params, 5) );
			}
			
		case 4:
			if ( get_int(params, 4) != 0 ) {
				b1 = *( (wxBitmap*)get_int(params, 4) );
			}
			
		default:
			bar = get_int( params, 1 );
			id = get_int( params, 2 );
			lbl = get_string( params, 3 );
		
	}
	
	tool = ((wxToolBar*)bar)->AddTool( id, lbl, b1, b2, (wxItemKind)kind, sp1, sp2 );
	
	wxDeRefDS( params );
	return BOX_INT( tool );
}

object WXEUAPI  add_tool(intptr_t bar, int id, intptr_t b1, intptr_t b2, object label, object s1, object s2, int kind)
{
	wxString lbl = get_string( label );
	wxString sp1 = get_string( s1 );
	wxString sp2 = get_string( s2 );
	wxToolBarToolBase * tool = ((wxToolBar *)bar)->AddTool( id, lbl,*((wxBitmap *) b1),*((wxBitmap *) b2), (wxItemKind) kind, sp1, sp2);
	wxDeRefDS( s1 );
	wxDeRefDS( s2 );
	return BOX_INT( tool );
}

void WXEUAPI  show_toolbar(intptr_t bar)
{
	((wxToolBar *)bar)->Realize();
}

void WXEUAPI  add_separator(intptr_t bar)
{
	((wxToolBar *)bar)->AddSeparator();
}

void WXEUAPI  toggle_tool(intptr_t bar, int id, int toggle)
{
	((wxToolBar*)bar)->ToggleTool( id, toggle );
}

void WXEUAPI  enable_tool(intptr_t bar, int id, int enable)
{
	((wxToolBar*)bar)->EnableTool( id, (bool)enable );
}

void WXEUAPI  set_tool_bitmap(intptr_t bar, int id, intptr_t b1, intptr_t b2)
{
	((wxToolBar *)bar)->SetToolNormalBitmap( id, *((wxBitmap *) b1) );
	((wxToolBar *)bar)->SetToolDisabledBitmap( id, *((wxBitmap *) b2) );
}

void WXEUAPI  set_tool_label(intptr_t bar, int id, object label)
{
	wxToolBarToolBase * tool = ((wxToolBar *)bar)->FindById( id );
	if (tool) {
		tool->SetLabel( get_string(label) );
	}

	wxDeRefDS( label );
}

void WXEUAPI  set_tool_help(intptr_t bar, int id, object short_help, object intptr_t_help)
{
	wxToolBarToolBase * tool = ((wxToolBar *)bar)->FindById( id );
	if (tool) {
		tool->SetShortHelp( get_string(short_help) );
		tool->SetLongHelp( get_string(intptr_t_help) );
	}

	wxDeRefDS( short_help );
	wxDeRefDS( intptr_t_help );
}

object WXEUAPI  get_tool_state(intptr_t bar, int id)
{
	return ((wxToolBar *)bar)->GetToolState( id );
}

object WXEUAPI  get_tool_pos( intptr_t bar, int id )
{
	return ((wxToolBar *)bar)->GetToolPos( id );
}

object WXEUAPI get_tool_size( intptr_t bar)
{
	wxSize size = ((wxToolBar *)bar)->GetToolSize();
	s1_ptr s = NewS1( 2 );
	
	s->base[1] = size.GetWidth();
	s->base[2] = size.GetHeight();
	
	return MAKE_SEQ( s );
}

}
