// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"

#include "wx/wizard.h"

extern "C"{
object WXEUAPI  new_wxWizard(object params)
{
/*
--/li /b parent
--/li /b id [=-1]
--/li /b title [=""]
--/li /b bitmap [=wxNullBitmap]
--/li /b x [=-1]
--/li /b y [=-1]
wxWizard(wxWindow* parent, int id = -1, const wxString& title = wxEmptyString, 
const wxBitmap& bitmap = wxNullBitmap, const wxPoint& pos = wxDefaultPosition, 
intptr_t style = wxDEFAULT_DIALOG_STYLE)
*/
	int len = ((s1_ptr)SEQ_PTR( params ))->length;
	int id = -1;
	wxString title = wxEmptyString;
	wxBitmap bitmap = wxNullBitmap;
	wxPoint pos = wxDefaultPosition;
	intptr_t style =  wxDEFAULT_DIALOG_STYLE;

	switch( len ){
		case 7:
			style = (intptr_t)get_int( params, 7 );
		case 6:
			pos = wxPoint( get_int( params, 5 ), get_int( params, 6 ) );
		case 5:
		case 4:
			// check to see if they passed a real bitmap
			if (get_int(params, 4) != 0)
			{
				bitmap = *((wxBitmap*)get_int(params, 4));
			}
		case 3:
			title = get_string( params, 3 );
		case 2:
			id = get_int( params, 2 );
		default:
			wxWizard * wizard = new wxWizard( (wxWindow*)get_int( params, 1 ),
				id, title, bitmap, pos, style );
			return BOX_INT( wizard );
	}
}


class EuWizardPage : public wxWizardPage {
	public:
	
	 EuWizardPage(wxWizard* parent, const wxBitmap& bitmap = wxNullBitmap,
		const wxChar *resource = NULL) : wxWizardPage( parent, bitmap, resource ){
		
			prev = NULL;
			next = NULL;
	}
	
	virtual wxWizardPage * GetNext(){ return next; }
	virtual wxWizardPage * GetPrev(){ return prev;}
	void SetNext( EuWizardPage *next_page ){ next = next_page; }
	void SetPrev( EuWizardPage *prev_page ){ prev = prev_page; }
	private:
	
	EuWizardPage * prev;
	EuWizardPage * next;
	
};

void WXEUAPI  set_next_wizard_page(intptr_t page, intptr_t next)
{
	((wxWizardPageSimple*)page)->SetNext( (wxWizardPageSimple*) next );
}


void WXEUAPI  set_prev_wizard_page(intptr_t page, intptr_t prev)
{
	((wxWizardPageSimple*)page)->SetPrev((wxWizardPage*) prev );
}

object WXEUAPI  new_wxWizardPage(object params)
{
/*
--/li /b parent
--/li /b bitmap [=wxNullBitmap]
--/li resource [=NULL]
wxWizardPage(wxWizard* parent, const wxBitmap& bitmap = wxNullBitmap,
const wxChar *resource = NULL)
wxWizardPageSimple(wxWizard* parent = NULL, wxWizardPage* prev = NULL, 
wxWizardPage* next = NULL, const wxBitmap& bitmap = wxNullBitmap)
*/
	wxBitmap bitmap = wxNullBitmap;
	wxChar * resource = NULL;
	int len = ((s1_ptr)SEQ_PTR(params))->length;

	switch( len ){
		case 3:
			resource = (wxChar *) get_int(params, 3 );
		case 2:
			if( get_int(params, 2 ) )
				bitmap = *((wxBitmap*)get_int(params, 2 ));
		default:
			wxWizardPageSimple * page = new wxWizardPageSimple( 
				(wxWizard*)get_int(params, 1),
				NULL, NULL,
				bitmap, resource );
			return BOX_INT( page );
	}
}

object WXEUAPI  wizard_event_page(intptr_t event)
{
	return BOX_INT( ((wxWizardEvent*)event)->GetPage() );
}

object WXEUAPI  wizard_event_direction(intptr_t event)
{
	return ((wxWizardEvent*)event)->GetDirection();
}

object WXEUAPI  run_wizard(intptr_t wizard, intptr_t first_page)
{
	return (object) ((wxWizard*)wizard)->RunWizard( (wxWizardPage *)first_page );
}

}
