// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "alldefs.h"
#include "wxeu.h"
#include "wxEuphoria.h"
#include <wx/xrc/xmlres.h>
#include <wx/filesys.h>
#include <wx/fs_arc.h>

extern "C" {

object WXEUAPI new_wxXmlResource( object params )
{
	wxDeRefDS( params );
	int len = LENGTH( params );
	
	if ( (len ==2) && (get_int(params, 2)) )
		wxFileSystem::AddHandler(new wxArchiveFSHandler);
	
	wxXmlResource *r = wxXmlResource::Get();
	r->InitAllHandlers();
	if ( !r->Load(get_string(params,1)) )
		return 0;
		
	return BOX_INT(r);
}


object WXEUAPI xrc_get_xrcid( intptr_t resource, object name)
{
	wxDeRefDS( name );
	return BOX_INT( ((wxXmlResource*)resource)->GetXRCID( get_string(name), wxNOT_FOUND ) );
}


object WXEUAPI xrc_get_control( intptr_t resource, intptr_t parent, object name)
{
	wxDeRefDS( name );

    int id = ((wxXmlResource*)resource)->GetXRCID(get_string(name), wxNOT_FOUND);

	if (id==wxNOT_FOUND) {
	    wxLogError(_("XRC resource '%s' not found!"),get_string(name).c_str());
		return wxNOT_FOUND;
	}

    return BOX_INT( ((wxWindow*)parent)->FindWindow(id) );
}


object WXEUAPI xrc_load_dialog( intptr_t resource, intptr_t parent, object name )
{
	//wxDialog* LoadDialog(wxWindow* parent, const wxString& name)

	wxDeRefDS( name );
	wxWindow *w = (wxWindow*)parent;
	wxDialog *d = ((wxXmlResource*)resource)->LoadDialog(w,get_string(name));
	
	
	return BOX_INT( d );
}


object WXEUAPI xrc_load_panel( intptr_t resource, intptr_t parent, object name )
{
	//wxPanel* LoadPanel(wxWindow* parent, const wxString& name)

	wxDeRefDS( name );
	wxWindow *w = (wxWindow*)parent;
	return BOX_INT( ((wxXmlResource*)resource)->LoadPanel(w,get_string(name)) );
}


object WXEUAPI xrc_load_frame( intptr_t resource, intptr_t parent, object name )
{
	//wxFrame* LoadFrame(wxWindow* parent, const wxString& name)

	wxDeRefDS( name );
	wxWindow *w = (wxWindow*)parent;
	wxFrame *frame = ((wxXmlResource*)resource)->LoadFrame(w,get_string(name));
	
	frame->Connect(frame->GetId(), frame->GetId(), wxEVT_CLOSE_WINDOW, 
			wxCommandEventHandler(EuFrame::OnCloseWindow ));
	
	return BOX_INT( frame );
}

object WXEUAPI xrc_load_bitmap(intptr_t resource, object name )
{
	wxDeRefDS( name );
	wxBitmap b  = ((wxXmlResource*)resource)->LoadBitmap(get_string(name));
	return BOX_INT( new wxBitmap( b ) );
}

object WXEUAPI xrc_load_icon(intptr_t resource, object name )
{
	wxDeRefDS( name );
	wxIcon ic  = ((wxXmlResource*)resource)->LoadIcon(get_string(name));
	return BOX_INT( new wxIcon( ic ) );
}

object WXEUAPI xrc_load_menu(intptr_t resource, object name )
{
	wxDeRefDS( name );
	return BOX_INT( ((wxXmlResource*)resource)->LoadMenu(get_string(name)) );
}

object WXEUAPI xrc_load_menu_bar( intptr_t resource, intptr_t parent, object name )
{
	wxDeRefDS( name );
	wxWindow *w = (wxWindow*)parent;
	return BOX_INT( ((wxXmlResource*)resource)->LoadMenuBar(w, get_string(name)) );
}

object WXEUAPI xrc_load_tool_bar( intptr_t resource, intptr_t parent, object name )
{
	wxDeRefDS( name );
	wxWindow *w = (wxWindow*)parent;
	return BOX_INT( ((wxXmlResource*)resource)->LoadToolBar(w, get_string(name)) );
}

} // extern "C"
