// For compilers that support precompilation, includes "wx/wx.h".

#include <iostream>
using namespace std;

#include "wx/setup.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif


#include "alldefs.h"
#include "wxeu.h"
#include "wx/wizard.h"
#include "wx/tglbtn.h"
#include "wx/grid.h"
#include "wx/treectrl.h"
#include "wx/listctrl.h"
#include "wx/html/htmlwin.h"
#include "wx/richtext/richtextctrl.h"
#include "wx/splitter.h"
#include "wx/notebook.h"
#include "wx/process.h"
#include "wx/mediactrl.h"
#include "wx/aui/aui.h"
#include "wx/aui/auibook.h"
#include <wx/clrpicker.h>
#include <wx/filepicker.h>
#include <wx/fontpicker.h>
#include <wx/datectrl.h>
#include <wx/dateevt.h>
#include <wx/collpane.h>

#ifndef wxEVT_HOTKEY
#define wxEVT_HOTKEY 0
#endif

intptr_t get_int( object seq, int index )
{
	if( !IS_ATOM_INT(seq) && !IS_SEQUENCE(seq) ) 
		EuApp::RTFatal("expected a sequence");
	
	if (index > SEQ_PTR(seq)->length )
		EuApp::RTFatal("index out of bounds");
	
	object x = (object) SEQ_PTR(seq)->base[index];

	if( !IS_ATOM_INT( x ) && !IS_ATOM( x ) && IS_SEQUENCE( x ) ){
		std::cout << "expected an integer " << std::hex << x 
			<< " IS_ATOM_INT( " << IS_ATOM_INT( x ) << " )"
			<< " IS_ATOM( " << IS_ATOM( x ) << " )"
			<< " IS_SEQUENCE( " << IS_SEQUENCE(x) << " )"
			<< " NOVALUE[" << NOVALUE << "]" 
			<< std::endl;
		EuApp::RTFatal("expected an integer");
	}
	
	if (x > NOVALUE && x < TOO_BIG_INT) 
		return x; // an integer
    else
		return (intptr_t)((d_ptr)DBL_PTR(x))->dbl; 
	
}

intptr_t get_int( object x )
{
	if( IS_SEQUENCE( x ) )
		EuApp::RTFatal("expected an integer");
	
	if (x > NOVALUE && x < TOO_BIG_INT) 
		return x; // an integer
    else
		return (intptr_t)((d_ptr)DBL_PTR(x))->dbl; 
}

double get_double( object seq, int index )
{
	if( !IS_SEQUENCE(seq) ) 
		EuApp::RTFatal("expected a sequence");
	
	if (index > SEQ_PTR(seq)->length )
		EuApp::RTFatal("index out of bounds");
	
	object x = (object) SEQ_PTR(seq)->base[index];

	if( IS_SEQUENCE( x ) )
		EuApp::RTFatal("expected an integer");
	
	if (x > NOVALUE && x < TOO_BIG_INT) 
		return (double)x; // a double
    else
		return (double)((d_ptr)DBL_PTR(x))->dbl; 
	
}

double get_double( object x )
{
	if( IS_SEQUENCE( x ) )
		EuApp::RTFatal("expected an integer");

	if (x > NOVALUE && x < TOO_BIG_INT) 
		return (double)x; // a double
    else
		return (double)((d_ptr)DBL_PTR(x))->dbl; 
}

wxString get_string( object seq )
{
	wxChar * str;
	
	if( !IS_SEQUENCE(seq) ) 
		EuApp::RTFatal("expected a sequence");
	s1_ptr s1 = SEQ_PTR(seq);
	int len = s1->length;
	str = new wxChar[len+1];
	for( int i = 1; i <= s1->length; i++ ){
		object x = s1->base[i];
		if( IS_SEQUENCE( x ) ) return wxEmptyString;
		if( !IS_ATOM_INT( x ) )
			x = (intptr_t) DBL_PTR(x)->dbl;
		str[i-1] = (wxChar) x;
		
	}
	str[len] = 0;
	wxString s( str );
	delete[] str;
	return s;
}

wxString get_string( object seq, int index )
{
	if( !IS_SEQUENCE(seq) ) 
		EuApp::RTFatal("expected a sequence");
	
	if (index > SEQ_PTR(seq)->length )
		EuApp::RTFatal("index out of bounds");

	return get_string( (object) SEQ_PTR( seq )->base[index] );
}


object get_sequence( wxString str )
{
	s1_ptr estring = NewS1( str.length() );
	for(int i=0;i<str.length();i++)
		estring->base[i+1] = BOX_INT(str.GetChar(i));
	return MAKE_SEQ( estring );
}

object get_sequence( const char *c )
{
	int len = strlen( c );
	s1_ptr estring = NewS1( len );
	for(int i = 0; i < len; ++i){
		estring->base[i+1] = c[i];
	}
	return MAKE_SEQ( estring );
}

object get_sequence( const char *c, size_t len )
{
	s1_ptr estring = NewS1( len );
	for(int i = 0; i < len; ++i){
		estring->base[i+1] = (unsigned char)c[i];
	}
	return MAKE_SEQ( estring );
}

object get_sequence( const wchar_t *c, size_t len )
{
	s1_ptr estring = NewS1( len );
	for(int i = 0; i < len; ++i){
		estring->base[i+1] = c[i];
	}
	return MAKE_SEQ( estring );
}

char *get_char( object seq )
{
	int len = LENGTH( seq ) + 1;
	char *buf = new char[len];
	char *out = buf - 1;
	s1_ptr s = SEQ_PTR( seq );
	for( size_t i = 1; i < len; ++i ){
		*++out = (char) s->base[i];
	}
	*++out = 0;
	return buf;
}

wchar_t *get_wchar( object seq )
{
	int len = LENGTH( seq ) + 1;
	wchar_t *buf = new wchar_t[len];
	wchar_t *out = buf - 1;
	s1_ptr s = SEQ_PTR( seq );
	for( size_t i = 1; i < len; ++i ){
		*++out = (wchar_t) s->base[i];
	}
	*++out = 0;
	return buf;
}


wxDateTime::Month month( int m ){
// stupid wxWidgets refuses to use ints for months, so 
// we use this stupid function...
	switch(m){
		case 1: return wxDateTime::Jan;
		case 2: return wxDateTime::Feb;
		case 3: return wxDateTime::Mar;
		case 4: return wxDateTime::Apr;
		case 5: return wxDateTime::May;
		case 6: return wxDateTime::Jun;
		case 7: return wxDateTime::Jul;
		case 8: return wxDateTime::Aug;
		case 9: return wxDateTime::Sep;
		case 10: return wxDateTime::Oct;
		case 11: return wxDateTime::Nov;
		case 12: return wxDateTime::Dec;
		default: return wxDateTime::Inv_Month;
	}
}

wxDateTime get_datetime( object Date )
{
	s1_ptr d = SEQ_PTR( Date );
	wxDateTime date;
	switch( d->length ){
		case 10:
		case 9:
		case 8:
		case 7:
			date.SetMillisecond( d->base[7] );
			
		case 6:
			date.SetSecond( d->base[6] );
			
		case 5:
			date.SetMinute( d->base[5] );
			
		case 4:
			date.SetHour( d->base[4] );
			
		case 3:
			date.SetDay( d->base[3] );
			
		case 2:
			date.SetMonth( month(d->base[2] ) );
		default:
			date.SetYear( d->base[1] );
			break;
	}
	return date;
}

object get_datetime( wxDateTime date )
{
	s1_ptr d = NewS1( 10 );
	d->base[1] = date.GetYear();
	d->base[2] = date.GetMonth();
	d->base[3] = date.GetDay();
	d->base[4] = date.GetHour();
	d->base[5] = date.GetMinute();
	d->base[6] = date.GetSecond();
	d->base[7] = date.GetMillisecond();
	d->base[8] = date.GetWeekDay();
	d->base[9] = date.GetDayOfYear();
	return MAKE_SEQ(d);
}

#ifndef wxEVT_MEDIA_LOADED

// These might not be available:

#define wxEVT_MEDIA_LOADED 0
#define wxEVT_MEDIA_STOP 0
#define wxEVT_MEDIA_FINISHED 0
#define wxEVT_MEDIA_STATECHANGED 0
#define wxEVT_MEDIA_PLAY 0
#define wxEVT_MEDIA_PAUSE  0

#endif

extern "C" {

int EuEventTypes[] = {
    wxEVT_COMMAND_BUTTON_CLICKED , // 32, -- 10000 + 1,   
    wxEVT_COMMAND_CHECKBOX_CLICKED , // 33, --10000 + 2,
    wxEVT_COMMAND_CHOICE_SELECTED , // 10000 + 3,
    wxEVT_COMMAND_LISTBOX_SELECTED , // 10000 + 4,
    wxEVT_COMMAND_LISTBOX_DOUBLECLICKED , // 10000 + 5,
    wxEVT_COMMAND_CHECKLISTBOX_TOGGLED , // 37, -- 10000 + 6, -- 37?
    // now they are in wx/textctrl.h
//#if WXWIN_COMPATIBILITY_EVENT_TYPES
    wxEVT_COMMAND_TEXT_UPDATED , // 10000 + 7,
    wxEVT_COMMAND_TEXT_ENTER , // 10000 + 8,
    wxEVT_COMMAND_TEXT_URL , // 10000 + 13,
    wxEVT_COMMAND_TEXT_MAXLEN , // 10000 + 14,
//#endif // WXWIN_COMPATIBILITY_EVENT_TYPES
    wxEVT_COMMAND_MENU_SELECTED , // 10000 + 9,
    wxEVT_COMMAND_SLIDER_UPDATED , // 10000 + 10,
    wxEVT_COMMAND_RADIOBOX_SELECTED , // 10000 + 11,
    wxEVT_COMMAND_RADIOBUTTON_SELECTED , // 41, --10000 + 12, 

    // wxEVT_COMMAND_SCROLLBAR_UPDATED is now obsolete since we use
    // wxEVT_SCROLL... events

    wxEVT_COMMAND_SCROLLBAR_UPDATED , // 10000 + 13, -- 42?
    wxEVT_COMMAND_VLBOX_SELECTED , // 10000 + 14,
    wxEVT_COMMAND_COMBOBOX_SELECTED , // 10000 + 15,
    wxEVT_COMMAND_TOOL_RCLICKED , // 10000 + 16,
    wxEVT_COMMAND_TOOL_ENTER , // 10000 + 17,
    wxEVT_COMMAND_SPINCTRL_UPDATED , // 10000 + 18, -- 47?

        // Sockets and timers send events, too
    wxEVT_SOCKET , // 12000 + 50,
    wxEVT_TIMER  , // 10000 + 80,

        // Mouse event types
    wxEVT_LEFT_DOWN , // 10000 + 100,
    wxEVT_LEFT_UP , // 10000 + 101,
    wxEVT_MIDDLE_DOWN , // 10000 + 102,
    wxEVT_MIDDLE_UP , // 10000 + 103,
    wxEVT_RIGHT_DOWN , // 10000 + 104,
    wxEVT_RIGHT_UP , // 10000 + 105,
    wxEVT_MOTION , // 10000 + 106,
    wxEVT_ENTER_WINDOW , // 10000 + 107,
    wxEVT_LEAVE_WINDOW , // 10000 + 108,
    wxEVT_LEFT_DCLICK , // 10000 + 109,
    wxEVT_MIDDLE_DCLICK , // 10000 + 110,
    wxEVT_RIGHT_DCLICK , // 10000 + 111,
    wxEVT_SET_FOCUS , // 10000 + 112,
    wxEVT_KILL_FOCUS , // 10000 + 113,
    wxEVT_CHILD_FOCUS , // 10000 + 114,
    wxEVT_MOUSEWHEEL , // 10000 + 115, -- 65? -> 64

        // Non-client mouse events
    wxEVT_NC_LEFT_DOWN , // 10000 + 200,
    wxEVT_NC_LEFT_UP , // 10000 + 201,
    wxEVT_NC_MIDDLE_DOWN , // 10000 + 202,
    wxEVT_NC_MIDDLE_UP , // 10000 + 203,
    wxEVT_NC_RIGHT_DOWN , // 10000 + 204,
    wxEVT_NC_RIGHT_UP , // 10000 + 205,
    wxEVT_NC_MOTION , // 10000 + 206,
    wxEVT_NC_ENTER_WINDOW , // 10000 + 207,
    wxEVT_NC_LEAVE_WINDOW , // 10000 + 208,
    wxEVT_NC_LEFT_DCLICK , // 10000 + 209,
    wxEVT_NC_MIDDLE_DCLICK , // 10000 + 210,
    wxEVT_NC_RIGHT_DCLICK , // 77, --10000 + 211, -- 77

        // Character input event type
    wxEVT_CHAR , // 10000 + 212,  -- 78?
    wxEVT_CHAR_HOOK , // 10000 + 213,
    wxEVT_NAVIGATION_KEY , // 10000 + 214,
    wxEVT_KEY_DOWN , // 10000 + 215,
    wxEVT_KEY_UP , // 81, --10000 + 216,  

    wxEVT_HOTKEY , // 10000 + 217, -- 82 ?
        // Set cursor event
    wxEVT_SET_CURSOR , // 10000 + 230,

        // wxScrollBar and wxSlider event identifiers
    wxEVT_SCROLL_TOP , // 10000 + 300,
    wxEVT_SCROLL_BOTTOM , // 10000 + 301,
    wxEVT_SCROLL_LINEUP , // 10000 + 302,
    wxEVT_SCROLL_LINEDOWN , // 10000 + 303,
    wxEVT_SCROLL_PAGEUP , // 10000 + 304,
    wxEVT_SCROLL_PAGEDOWN , // 10000 + 305,
    wxEVT_SCROLL_THUMBTRACK , // 10000 + 306,
    wxEVT_SCROLL_THUMBRELEASE , // 10000 + 307,
    wxEVT_SCROLL_CHANGED , // 10000 + 308,

        // Scroll events from wxWindow
    wxEVT_SCROLLWIN_TOP , // 10000 + 320,
    wxEVT_SCROLLWIN_BOTTOM , // 10000 + 321,
    wxEVT_SCROLLWIN_LINEUP , // 10000 + 322,
    wxEVT_SCROLLWIN_LINEDOWN , // 10000 + 323,
    wxEVT_SCROLLWIN_PAGEUP , // 10000 + 324,
    wxEVT_SCROLLWIN_PAGEDOWN , // 10000 + 325,
    wxEVT_SCROLLWIN_THUMBTRACK , // 10000 + 326,
    wxEVT_SCROLLWIN_THUMBRELEASE , // 10000 + 327, -- 100

        // System events
    wxEVT_SIZE , // 10000 + 400,
    wxEVT_MOVE , // 10000 + 401,
    wxEVT_CLOSE_WINDOW , // 10000 + 402,
    wxEVT_END_SESSION , // 10000 + 403,
    wxEVT_QUERY_END_SESSION , // 10000 + 404,
    wxEVT_ACTIVATE_APP , // 10000 + 405,
//    wxEVT_POWER , // 10000 + 406,
    wxEVT_ACTIVATE , // 10000 + 409,
    wxEVT_CREATE , // 10000 + 410,
    wxEVT_DESTROY , // 10000 + 411,
    wxEVT_SHOW , // 10000 + 412,
    wxEVT_ICONIZE , // 10000 + 413,
    wxEVT_MAXIMIZE , // 10000 + 414,
    wxEVT_MOUSE_CAPTURE_CHANGED , // 10000 + 415,
    wxEVT_PAINT , // 10000 + 416, -- 116
    wxEVT_ERASE_BACKGROUND , // 10000 + 417,
    wxEVT_NC_PAINT , // 10000 + 418,
    wxEVT_PAINT_ICON , // 10000 + 419,
    wxEVT_MENU_OPEN , // 10000 + 420,
    wxEVT_MENU_CLOSE , // 10000 + 421,
    wxEVT_MENU_HIGHLIGHT , // 10000 + 422,
    // wxEVT_POPUP_MENU_INIT , // 10000 + 423,
    wxEVT_CONTEXT_MENU , // 10000 + 424,
    wxEVT_SYS_COLOUR_CHANGED , // 10000 + 425,
    wxEVT_DISPLAY_CHANGED , // 10000 + 426,
    wxEVT_SETTING_CHANGED , // 10000 + 427,
    wxEVT_QUERY_NEW_PALETTE , // 10000 + 428,
    wxEVT_PALETTE_CHANGED , // 10000 + 429,
    wxEVT_JOY_BUTTON_DOWN , // 10000 + 430,
    wxEVT_JOY_BUTTON_UP , // 10000 + 431,
    wxEVT_JOY_MOVE , // 10000 + 432,
    wxEVT_JOY_ZMOVE , // 10000 + 433,
    wxEVT_DROP_FILES , // 10000 + 434,
    wxEVT_DRAW_ITEM , // 10000 + 435,
    wxEVT_MEASURE_ITEM , // 10000 + 436,
    wxEVT_COMPARE_ITEM , // 10000 + 437,
    wxEVT_INIT_DIALOG , // 10000 + 438,
    wxEVT_IDLE , // 12000 + 439,
    wxEVT_UPDATE_UI , // 10000 + 440,
    wxEVT_SIZING , // 10000 + 441,
    wxEVT_MOVING , // 10000 + 442,
    wxEVT_HIBERNATE , // 10000 + 443,

        // Generic command events
        // Note: a click is a higher-level event than button down/up
    wxEVT_COMMAND_LEFT_CLICK , // 10000 + 500,
    wxEVT_COMMAND_LEFT_DCLICK , // 10000 + 501,
    wxEVT_COMMAND_RIGHT_CLICK , // 10000 + 502,
    wxEVT_COMMAND_RIGHT_DCLICK , // 10000 + 503,
    wxEVT_COMMAND_SET_FOCUS , // 10000 + 504,
    wxEVT_COMMAND_KILL_FOCUS , // 10000 + 505,
    wxEVT_COMMAND_ENTER , // 10000 + 506,
	
	// Tree events:
    wxEVT_COMMAND_TREE_BEGIN_DRAG,// 600)
    wxEVT_COMMAND_TREE_BEGIN_RDRAG,// 601)
    wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT,// 602)
    wxEVT_COMMAND_TREE_END_LABEL_EDIT,// 603)
    wxEVT_COMMAND_TREE_DELETE_ITEM,// 604)
    wxEVT_COMMAND_TREE_GET_INFO,// 605)
    wxEVT_COMMAND_TREE_SET_INFO,// 606)
    wxEVT_COMMAND_TREE_ITEM_EXPANDED,// 607)
    wxEVT_COMMAND_TREE_ITEM_EXPANDING,// 608)
    wxEVT_COMMAND_TREE_ITEM_COLLAPSED,// 609)
    wxEVT_COMMAND_TREE_ITEM_COLLAPSING,// 610)
    wxEVT_COMMAND_TREE_SEL_CHANGED,// 611)
    wxEVT_COMMAND_TREE_SEL_CHANGING,// 612)
    wxEVT_COMMAND_TREE_KEY_DOWN,// 613)
    wxEVT_COMMAND_TREE_ITEM_ACTIVATED,// 614)
    wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK,// 615)
    wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK,// 616)
    wxEVT_COMMAND_TREE_END_DRAG,// 617)
    wxEVT_COMMAND_TREE_STATE_IMAGE_CLICK,// 618)
    wxEVT_COMMAND_TREE_ITEM_GETTOOLTIP,// 619)
    wxEVT_COMMAND_TREE_ITEM_MENU,// 620)
    
        // Help events
    wxEVT_HELP , // 10000 + 1050,
    wxEVT_DETAILED_HELP , // 10000 + 1051,

	wxEVT_COMMAND_TOOL_CLICKED,   // wxEVT_COMMAND_MENU_SELECTED

	wxEVT_WIZARD_CANCEL,
	wxEVT_WIZARD_FINISHED,
	wxEVT_WIZARD_HELP,
	wxEVT_WIZARD_PAGE_CHANGED,
	wxEVT_WIZARD_PAGE_CHANGING,
	
	wxEVT_COMMAND_TOGGLEBUTTON_CLICKED,
	
	wxEVT_GRID_CELL_CHANGE,
	wxEVT_GRID_CELL_LEFT_CLICK,
	wxEVT_GRID_CELL_LEFT_DCLICK,
	wxEVT_GRID_CELL_RIGHT_CLICK,
	wxEVT_GRID_CELL_RIGHT_DCLICK,
	wxEVT_GRID_COL_SIZE,
	wxEVT_GRID_EDITOR_CREATED,
	wxEVT_GRID_EDITOR_HIDDEN,
	wxEVT_GRID_EDITOR_SHOWN,
	wxEVT_GRID_LABEL_LEFT_CLICK,
	wxEVT_GRID_LABEL_LEFT_DCLICK,
	wxEVT_GRID_LABEL_RIGHT_CLICK ,
	wxEVT_GRID_LABEL_RIGHT_DCLICK,
	wxEVT_GRID_RANGE_SELECT,
	wxEVT_GRID_ROW_SIZE,
	wxEVT_GRID_SELECT_CELL,
	wxEVT_COMMAND_LIST_ITEM_SELECTED,
	wxEVT_COMMAND_HTML_LINK_CLICKED,
	wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK,
	
	wxEVT_COMMAND_RICHTEXT_CHARACTER,
	wxEVT_COMMAND_RICHTEXT_DELETE,
	wxEVT_COMMAND_RICHTEXT_RETURN,
	wxEVT_COMMAND_RICHTEXT_STYLE_CHANGED,
	wxEVT_COMMAND_RICHTEXT_STYLESHEET_CHANGING,
	wxEVT_COMMAND_RICHTEXT_STYLESHEET_REPLACING,
	wxEVT_COMMAND_RICHTEXT_STYLESHEET_REPLACED,
	wxEVT_COMMAND_RICHTEXT_CONTENT_INSERTED,
	wxEVT_COMMAND_RICHTEXT_CONTENT_DELETED,
	wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING,
	wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED,
	wxEVT_COMMAND_SPLITTER_UNSPLIT,
	wxEVT_COMMAND_SPLITTER_DOUBLECLICKED,
	
	wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED,
	wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING,
	
	wxEVT_END_PROCESS,
	
	wxEVT_MEDIA_LOADED,
	wxEVT_MEDIA_STOP,
	wxEVT_MEDIA_FINISHED,
	wxEVT_MEDIA_STATECHANGED,
	wxEVT_MEDIA_PLAY,
	wxEVT_MEDIA_PAUSE,
	
	wxEVT_AUI_PANE_BUTTON,
	wxEVT_AUI_PANE_CLOSE,
	wxEVT_AUI_PANE_MAXIMIZE,
	wxEVT_AUI_PANE_RESTORE,
	wxEVT_AUI_RENDER,
	wxEVT_AUI_FIND_MANAGER,
	
	wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSE,
	wxEVT_COMMAND_AUINOTEBOOK_PAGE_CHANGED,
	wxEVT_COMMAND_AUINOTEBOOK_PAGE_CHANGING,
	wxEVT_COMMAND_AUINOTEBOOK_BUTTON,
	wxEVT_COMMAND_AUINOTEBOOK_BEGIN_DRAG,
	wxEVT_COMMAND_AUINOTEBOOK_END_DRAG,
	wxEVT_COMMAND_AUINOTEBOOK_DRAG_MOTION,
	wxEVT_COMMAND_AUINOTEBOOK_ALLOW_DND,
	wxEVT_COMMAND_AUINOTEBOOK_TAB_MIDDLE_DOWN,
	wxEVT_COMMAND_AUINOTEBOOK_TAB_MIDDLE_UP,
	wxEVT_COMMAND_AUINOTEBOOK_TAB_RIGHT_DOWN,
	wxEVT_COMMAND_AUINOTEBOOK_TAB_RIGHT_UP,
	wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSED,
	wxEVT_COMMAND_AUINOTEBOOK_DRAG_DONE,
	wxEVT_COMMAND_AUINOTEBOOK_BG_DCLICK,
	
	wxEVT_COMMAND_LIST_BEGIN_DRAG,
	
	wxEVT_COMMAND_COLOURPICKER_CHANGED,
	wxEVT_DATE_CHANGED,
	wxEVT_COMMAND_DIRPICKER_CHANGED,
	wxEVT_COMMAND_FILEPICKER_CHANGED,
	wxEVT_COMMAND_FONTPICKER_CHANGED,
	wxEVT_COMMAND_COLLPANE_CHANGED
	};

}
