#ifndef WXEU_H_
#define WXEU_H_

#include <assert.h>
#include "be.h"
#include "wxstdint.h"
#include "wx/datetime.h"

intptr_t get_int( object seq, int index );
intptr_t get_int( object x );
double get_double( object seq, int index );
double get_double( object x );
wxString get_string( object seq );
wxString get_string( object seq, int index );
object get_datetime( wxDateTime date );
wxDateTime get_datetime( object Date );
wxDateTime::Month month( int m );

#define BOX_INT(x)	box_int((intptr_t)x)

#ifdef WXEUMSW

#define WXEUAPI  __cdecl

#else

#define WXEUAPI

#endif

#define wxDeRefDS(a) assert(DBL_PTR(a)->ref); --(DBL_PTR(a)->ref);
#define wxDeRef(a) if(IS_DBL_OR_SEQUENCE(a)){ wxDeRefDS(a); }

#ifdef LENGTH
#undef LENGTH
#endif

#define LENGTH( obj ) ((s1_ptr)SEQ_PTR(obj))->length

#define NEW_CONTROL(control) \
	s1_ptr p = SEQ_PTR( params );\
	wxPoint pos = wxDefaultPosition;\
	wxSize size = wxDefaultSize;\
	intptr_t style = 0;\
	wxWindowID id = -1;\
	wxString caption(wxT(""));\
	\
	switch( p->length ){\
		case 8:\
			style = get_int( params, 8 );\
		\
		case 7:\
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );\
		\
		case 6:\
		case 5:\
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5) );\
		\
		case 4:\
		case 3:\
			caption = get_string( params, 3 );\
		case 2:\
			id = get_int( params, 2 );\
		default:\
			break;\
	}\
	control * cont = new control( (wxWindow *)get_int(params, 1),\
			id, caption,\
			pos, size, style );\
	wxDeRefDS(params);\
	return BOX_INT( cont );

#define NEW_CONTROL_NO_RETURN(control, name) \
	s1_ptr p = SEQ_PTR( params );\
	wxPoint pos;\
	wxSize size;\
	intptr_t style = 0;\
	wxString text(wxT(""));\
	wxWindowID id = -1;\
	\
	switch( p->length ){\
		case 10:\
		case 9:\
		case 8:\
			style = get_int( params, 8 );\
		\
		case 7:\
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );\
		\
		case 6:\
		case 5:\
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5) );\
		case 4:\
		case 3:\
			text = get_string( params, 3 );\
		case 2:\
			id = get_int( params, 2 );\
		\
		default:\
			break;\
	}\
	control * name = new control( (wxWindow *)get_int(params, 1),\
			(wxWindowID) id, text,\
			pos, size, style );

#define NEW_CONTROL_NO_RETURN_STYLE(control, name, default_style) \
	s1_ptr p = SEQ_PTR( params );\
	wxString text(wxT(""));\
	wxWindowID id = -1;\
	wxPoint pos = wxDefaultPosition;\
	wxSize size = wxDefaultSize;\
	intptr_t style = default_style;\
	switch( p->length ){\
		case 10:\
		case 9:\
		case 8:\
			style = get_int( params, 8 );\
		case 7:\
			size = wxSize( get_int( params, 6 ), get_int( params, 7 ) );\
		case 6:\
		case 5:\
			pos = wxPoint( get_int( params, 4 ), get_int( params, 5) );\
		case 4:\
		case 3:\
			text = get_string( params, 3 );\
		case 2:\
			id = get_int( params, 2 );\
		default:\
			break;\
	}\
	wxDeRefDS(params);\
	control * name = new control( (wxWindow *)get_int(params, 1),\
			id, text, pos, size, style );

#define NEW_CONTROL_STYLE( control, name, default_style ) \
	NEW_CONTROL_NO_RETURN_STYLE( control, name, default_style ) \
	return BOX_INT( name );

#define NEW_SIMPLE_CONTROL(control) \
	s1_ptr p = SEQ_PTR( params );\
	wxPoint pos;\
	wxSize size;\
	intptr_t style = 0;\
	wxWindowID id = -1;\
	\
	switch( p->length ){\
		case 7:\
			style = get_int( params, 7 );\
		\
		case 6:\
			size = wxSize( get_int( params, 5 ), get_int( params, 6 ) );\
		\
		case 5:\
		case 4:\
			pos = wxPoint( get_int( params, 3 ), get_int( params, 4) );\
		case 2:\
			id = (wxWindowID) get_int( params, 2 );\
		default:\
			break;\
	}\
	control * control_ptr = new control( (wxWindow *)get_int(params, 1),\
		id, pos, size, style );\
	wxDeRefDS(params);\
	return BOX_INT( control_ptr );

#define NEW_SIMPLE_CONTROL_STYLE(control, default_style) \
	s1_ptr p = SEQ_PTR( params );\
	wxPoint pos;\
	wxSize size;\
	wxWindowID id = -1;\
	intptr_t style = default_style;\
	\
	switch( p->length ){\
		case 7:\
			style = get_int( params, 7 );\
		\
		case 6:\
			size = wxSize( get_int( params, 5 ), get_int( params, 6 ) );\
		\
		case 5:\
		case 4:\
			pos = wxPoint( get_int( params, 3 ), get_int( params, 4) );\
		\
		case 2:\
			id = (wxWindowID) get_int( params, 2 );\
		default:\
			break;\
	}\
	control * control_ptr = new control( (wxWindow *)get_int(params, 1),\
		id, pos, size, style );\
	wxDeRefDS(params);\
	return BOX_INT( control_ptr );

#define NEW_SIMPLE_CONTROL_NO_RETURN(control, name) \
	s1_ptr p = SEQ_PTR( params );\
	wxPoint pos = wxDefaultPosition;\
	wxSize size = wxDefaultSize;\
	intptr_t style = 0;\
	wxWindowID id = -1;\
	switch( p->length ){\
		case 10:\
		case 9:\
		case 8:\
		case 7:\
			style = get_int( params, 7 );\
		case 6:\
			size = wxSize( get_int( params, 5 ), get_int( params, 6 ) );\
		case 5:\
		case 4:\
			pos = wxPoint( get_int( params, 3 ), get_int( params, 4) );\
		case 2:\
			id = (wxWindowID)get_int(params, 2);\
		default:\
			break;\
	}\
	wxDeRefDS(params);\
	control * name = new control( (wxWindow *)get_int(params, 1),\
		id, pos, size, style );

#define DELETE_INSTANCE( clazz, obj ) \
	if( IS_SEQUENCE( obj ) ){\
		s1_ptr s = SEQ_PTR( obj );\
		for( int i = 1; i <= s->length; i++){\
			delete (clazz *) get_int( obj, i );\
		}\
	}\
	else\
		delete (clazz *) get_int(obj);\
	wxDeRef( obj );

typedef object WXEUAPI (*EuCallFunc)(intptr_t);
typedef void WXEUAPI (*EuCallProc)(intptr_t);

// Define a new application type, each program should derive a class from wxApp
class EuApp : public wxApp
{
public:
    // override base class virtuals
    // ----------------------------

    // this one is called on application startup and is a good place for the app
    // initialization (doing it here and not in the ctor allows to have an error
    // return: if OnInit() returns false, the application terminates)
    virtual bool OnInit() {
		wxInitAllImageHandlers();
		return true;
	};
    
	static EuApp * wxEuApp;
	static object the_object;
	static EuCallFunc callFunc;
	static EuCallProc callProc;
	static intptr_t error_rid;
	static void proc( intptr_t rid, object obj );
	static object func( intptr_t rid, object obj );
	static void RTFatal( const char *msg );
};



#ifdef WXEUMSW
static unsigned int default_heap;
#endif
extern intptr_t winInstance;
intptr_t get_int( object seq, intptr_t index );
intptr_t get_int( object x );
double get_double( object seq, intptr_t index );
double get_double( object x );
wxString get_string( object seq );
wxString get_string( object seq, intptr_t index );
object get_sequence( wxString str );
object get_sequence( const char *c );
object get_sequence( const char *c, size_t len );
object get_sequence( const wchar_t *c, size_t len );
wchar_t *get_wchar( object seq );
char *get_char( object seq );
static object box_int( intptr_t x )
{
	if(x > NOVALUE && x < TOO_BIG_INT)
		return (object) x;
	else
		return (object)NewDouble((eudouble)x);
}	

static void unbox_int( intptr_t x )
{
	if(IS_DBL_OR_SEQUENCE(x))
		free( DBL_PTR( x ) );
}	
#endif
